+++++++++++
Python News
+++++++++++

What's New in Python 3.13.3 final?
==================================

*Release date: 2025-04-08*

macOS
-----

- gh-124111: Update macOS installer to use Tcl/Tk 8.6.16.

- gh-131423: Update macOS installer to use OpenSSL 3.0.16. Patch by Bénédikt
  Tran.

- gh-131025: Update macOS installer to ship with SQLite 3.49.1.

- gh-91132: Update macOS installer to use ncurses 6.5.

Windows
-------

- gh-131423: Update bundled version of OpenSSL to 3.0.16. The new build also
  disables uplink support, which may be relevant to embedders but has no
  impact on normal use.

- gh-131025: Update Windows installer to ship with SQLite 3.49.1.

- gh-131020: :source:`pylauncher <PC/launcher2.c>` correctly detects a BOM
  when searching for the shebang. Fix by Chris Eibl.

Tools/Demos
-----------

- gh-131852: :program:`msgfmt` no longer adds the ``POT-Creation-Date`` to
  generated ``.mo`` files for consistency with GNU ``msgfmt``.

- gh-85012: Correctly reset ``msgctxt`` when compiling messages in
  :program:`msgfmt`.

- gh-130025: The iOS testbed now correctly handles symlinks used as Python
  framework references.

Tests
-----

- gh-131050: ``test_ssl.test_dh_params`` is skipped if the underlying TLS
  library does not support finite-field ephemeral Diffie-Hellman.

- gh-129200: Multiple iOS testbed runners can now be started at the same
  time without introducing an ambiguity over simulator ownership.

- gh-130292: The iOS testbed will now run successfully on a machine that has
  not previously run Xcode tests (such as CI configurations).

- gh-130293: The tests of terminal colorization are no longer sensitive to
  the value of the ``TERM`` variable in the testing environment.

- gh-126332: Add unit tests for pyrepl.

Security
--------

- gh-131809: Update bundled libexpat to 2.7.1

- gh-131261: Upgrade to libexpat 2.7.0

- gh-127371: Avoid unbounded buffering for
  :meth:`!tempfile.SpooledTemporaryFile.writelines`. Previously, disk
  spillover was only checked after the lines iterator had been exhausted.
  This is now done after each line is written.

- gh-121284: Fix bug in the folding of rfc2047 encoded-words when flattening
  an email message using a modern email policy. Previously when an
  encoded-word was too long for a line, it would be decoded, split across
  lines, and re-encoded. But commas and other special characters in the
  original text could be left unencoded and unquoted. This could
  theoretically be used to spoof header lines using a carefully constructed
  encoded-word if the resulting rendered email was transmitted or re-parsed.

Library
-------

- gh-132174: Fix function name in error message of
  ``_interpreters.run_string``.

- gh-132171: Fix crash of ``_interpreters.run_string`` on string subclasses.

- gh-129204: Introduce new ``_PYTHON_SUBPROCESS_USE_POSIX_SPAWN``
  environment variable knob in :mod:`subprocess` to control the use of
  :func:`os.posix_spawn`.

- gh-132159: Do not shadow user arguments in generated :meth:`!__new__` by
  decorator :class:`warnings.deprecated`. Patch by Xuehai Pan.

- gh-132075: Fix possible use of :mod:`socket` address structures with
  uninitialized members. Now all structure members are initialized with
  zeroes by default.

- gh-132002: Fix crash when deallocating :class:`contextvars.ContextVar`
  with weird unahashable string names.

- gh-131668: :mod:`socket`: Fix code parsing AF_BLUETOOTH socket addresses.

- gh-131492: Fix a resource leak when constructing a :class:`gzip.GzipFile`
  with a filename fails, for example when passing an invalid
  ``compresslevel``.

- gh-131325: Fix sendfile fallback implementation to drain data after
  writing to transport in :mod:`asyncio`.

- gh-129843: Fix incorrect argument passing in
  :func:`warnings.warn_explicit`.

- gh-131204: Use monospace font from System Font Stack for cross-platform
  support in :class:`difflib.HtmlDiff`.

- gh-130940: The ``PyConfig.use_system_logger`` attribute, introduced in
  Python 3.13.2, has been removed. The introduction of this attribute
  inadvertently introduced an ABI breakage on macOS and iOS. The use of the
  system logger is now enabled by default on iOS, and disabled by default on
  macOS.

- gh-131045: Fix issue with ``__contains__``, values, and pseudo-members for
  :class:`enum.Flag`.

- gh-130959: Fix pure-Python implementation of
  :func:`datetime.time.fromisoformat` to reject times with spaces in
  fractional part (for example, ``12:34:56.400 +02:00``), matching the C
  implementation. Patch by Michał Gorny.

- gh-130637: Add validation for numeric response data in poplib.POP3.stat()
  method

- gh-130461: Remove ``.. index::`` directives from the :mod:`uuid` module
  documentation. These directives previously created entries in the general
  index for :func:`~uuid.getnode` as well as the :func:`~uuid.uuid1`,
  :func:`~uuid.uuid3`, :func:`~uuid.uuid4`, and :func:`~uuid.uuid5`
  constructor functions.

- gh-130379: The zipapp module now calculates the list of files to be added
  to the archive before creating the archive. This avoids accidentally
  including the target when it is being created in the source directory.

- gh-130285: Fix corner case for :func:`random.sample` allowing the *counts*
  parameter to specify an empty population. So now, ``sample([], 0,
  counts=[])`` and ``sample('abc', k=0, counts=[0, 0, 0])`` both give the
  same result as ``sample([], 0)``.

- gh-130250: Fix regression in ``traceback.print_last()``.

- gh-130230: Fix crash in :func:`pow` with only :class:`~decimal.Decimal`
  third argument.

- gh-118761: Reverts a change in the previous release attempting to make
  some stdlib imports used within the :mod:`subprocess` module lazy as this
  was causing errors during ``__del__`` finalizers calling methods such as
  ``terminate``, or ``kill``, or ``send_signal``.

- gh-130164: Fixed failure to raise :exc:`TypeError` in
  :meth:`inspect.Signature.bind` for positional-only arguments provided by
  keyword when a variadic keyword argument (e.g. ``**kwargs``) is present.

- gh-130151: Fix reference leaks in :func:`!_hashlib.hmac_new` and
  :func:`!_hashlib.hmac_digest`. Patch by Bénédikt Tran.

- gh-130145: Fix :meth:`!asyncio.AbstractEventloop.run_forever` when another
  loop is already running.

- gh-129726: Fix :class:`gzip.GzipFile` raising an unraisable exception
  during garbage collection when referring to a temporary object by breaking
  the reference loop with :mod:`weakref`.

- gh-127750: Remove broken :func:`functools.singledispatchmethod` caching
  introduced in :gh:`85160`.

- gh-129583: Update bundled pip to 25.0.1

- gh-97850: Update the deprecation warning of
  :meth:`importlib.abc.Loader.load_module`.

- gh-129646: Update the locale alias mapping in the :mod:`locale` module to
  match the latest X Org locale alias mapping and support new locales in
  Glibc 2.41.

- gh-129603: Fix bugs where :class:`sqlite3.Row` objects could segfault if
  their inherited :attr:`~sqlite3.Cursor.description` was set to ``None``.
  Patch by Erlend Aasland.

- gh-128231: Execution of multiple statements in the new REPL now stops
  immediately upon the first exception encountered. Patch by Bartosz
  Sławecki.

- gh-117779: Fix reading duplicated entries in :mod:`zipfile` by name.
  Reading duplicated entries (except the last one) by ``ZipInfo`` now emits
  a warning instead of raising an exception.

- gh-128772: Fix :mod:`pydoc` for methods with the ``__module__`` attribute
  equal to ``None``.

- gh-92897: Scheduled the deprecation of the ``check_home`` argument of
  :func:`sysconfig.is_python_build` to Python 3.15.

- gh-128657: Fix possible extra reference when using objects returned by
  :func:`hashlib.sha256` under :term:`free threading`.

- gh-128703: Fix :func:`mimetypes.guess_type` to use default mapping for
  empty ``Content-Type`` in registry.

- gh-128308: Support the *name* keyword argument for eager tasks in
  :func:`asyncio.loop.create_task`,  :func:`asyncio.create_task` and
  :func:`asyncio.TaskGroup.create_task`, by passing on all *kwargs* to the
  task factory set by :func:`asyncio.loop.set_task_factory`.

- gh-128388: Fix ``PyREPL`` on Windows to support more keybindings, like the
  :kbd:`Control-←` and :kbd:`Control-→` word-skipping keybindings and those
  with meta (i.e. :kbd:`Alt`), e.g. :kbd:`Alt-d` to ``kill-word`` or
  :kbd:`Alt-Backspace` ``backward-kill-word``.

- gh-126037: :mod:`xml.etree.ElementTree`: Fix a crash in
  :meth:`Element.find <xml.etree.ElementTree.Element.find>`,
  :meth:`Element.findtext <xml.etree.ElementTree.Element.findtext>` and
  :meth:`Element.findall <xml.etree.ElementTree.Element.findall>` when the
  tag to find implements an :meth:`~object.__eq__` method mutating the
  element being queried. Patch by Bénédikt Tran.

- gh-127712: Fix handling of the ``secure`` argument of
  :class:`logging.handlers.SMTPHandler`.

- gh-126033: :mod:`xml.etree.ElementTree`: Fix a crash in
  :meth:`Element.remove <xml.etree.ElementTree.Element.remove>` when the
  element is concurrently mutated. Patch by Bénédikt Tran.

- gh-118201: Fixed intermittent failures of :any:`os.confstr`,
  :any:`os.pathconf` and :any:`os.sysconf` on iOS and Android.

- gh-124927: Non-printing characters are now properly handled in the new
  REPL.

IDLE
----

- gh-129873: Simplify displaying the IDLE doc by only copying the text
  section of idle.html to idlelib/help.html. Patch by Stan Ulbrych.

Documentation
-------------

- gh-131417: Mention :class:`asyncio.Future` and :class:`asyncio.Task` in
  generic classes list.

- gh-125722: Require Sphinx 8.2.0 or later to build the Python
  documentation. Patch by Adam Turner.

- gh-129712: The wheel tags supported by each macOS universal SDK option are
  now documented.

- gh-46236: C API: Document :c:func:`PyUnicode_RSplit`,
  :c:func:`PyUnicode_Partition` and :c:func:`PyUnicode_RPartition`.

Core and Builtins
-----------------

- gh-132011: Fix crash when calling :meth:`!list.append` as an unbound
  method.

- gh-131998: Fix a crash when using an unbound method :term:`descriptor`
  object in a function where a bound method descriptor was used.

- gh-131988: Fix a performance regression that caused scaling bottlenecks in
  the free threaded build in 3.13.1 and 3.13.2.

- gh-131719: Fix missing NULL check in ``_PyMem_FreeDelayed`` in
  :term:`free-threaded <free threading>` build.

- gh-131670: Fix :func:`anext` failing on sync :meth:`~object.__anext__`
  raising an exception.

- gh-131141: Fix data race in :data:`sys.monitoring` instrumentation while
  registering callback.

- gh-130932: Fix incorrect exception handling in
  ``_PyModule_IsPossiblyShadowing``

- gh-130851: Fix a crash in the :term:`free threading` build when
  constructing a :class:`code` object with :attr:`~codeobject.co_consts`
  that contains instances of types that are not otherwise generated by the
  bytecode compiler.

- gh-130794: Fix memory leak in the :term:`free threaded <free threading>`
  build when resizing a shared list or dictionary from multiple short-lived
  threads.

- gh-130775: Do not crash on negative ``column`` and ``end_column`` in
  :mod:`ast` locations.

- gh-130382: Fix ``PyRefTracer_DESTROY`` not being sent from
  :file:`Python/ceval.c` ``Py_DECREF()``.

- gh-130618: Fix a bug that was causing ``UnicodeDecodeError`` or
  ``SystemError`` to be raised when using f-strings with ``lambda``
  expressions with non-ASCII characters. Patch by Pablo Galindo

- gh-130163: Fix possible crashes related to concurrent change and use of
  the :mod:`sys` module attributes.

- gh-88887: Fixing multiprocessing Resource Tracker process leaking, usually
  observed when running Python as PID 1.

- gh-130115: Fix an issue with thread identifiers being sign-extended on
  some platforms.

- gh-128396: Fix a crash that occurs when calling :func:`locals` inside an
  inline comprehension that uses the same local variable as the outer frame
  scope where the variable is a free or cell var.

- gh-116042: Fix location for SyntaxErrors of invalid escapes in the
  tokenizer. Patch by Pablo Galindo

- gh-129983: Fix data race in compile_template in :file:`sre.c`.

- gh-129967: Fix a race condition in the :term:`free threading` build when
  ``repr(set)`` is called concurrently with ``set.clear()``.

- gh-129900: Fix return codes inside :exc:`SystemExit` not getting returned
  by the REPL.

- gh-129732: Fixed a race in ``_Py_qsbr_reserve`` in the free threading
  build.

- gh-129643: Fix thread safety of :c:func:`PyList_Insert` in free-threading
  builds.

- gh-129668: Fix race condition when raising :exc:`MemoryError` in the free
  threaded build.

- gh-129643: Fix thread safety of :c:func:`PyList_SetItem` in free-threading
  builds. Patch by Kumar Aditya.

- gh-128714: Fix the potential races in get/set dunder methods
  ``__annotations__``, ``__annotate__`` and ``__type_params__`` for function
  object, and add related tests.

- gh-128632: Disallow ``__classdict__`` as the name of a type parameter.
  Using this name would previously crash the interpreter in some
  circumstances.

- gh-127953: The time to handle a ``LINE`` event in sys.monitoring (and
  sys.settrace) is now independent of the number of lines in the code
  object.

- gh-125331: ``from __future__ import barry_as_FLUFL`` now works in more
  contexts, including when it is used in files, with the ``-c`` flag, and in
  the REPL when there are multiple statements on the same line. Previously,
  it worked only on subsequent lines in the REPL, and when the appropriate
  flags were passed directly to :func:`compile`. Patch by Pablo Galindo.

C API
-----

- gh-131740: Update PyUnstable_GC_VisitObjects to traverse perm gen.

- gh-129533: Update :c:func:`PyGC_Enable()`, :c:func:`PyGC_Disable()`,
  :c:func:`PyGC_IsEnabled()` to use atomic operation for thread-safety at
  free-threading build. Patch by Donghee Na.

Build
-----

- gh-131865: The DTrace build now properly passes the ``CC`` and ``CFLAGS``
  variables to the ``dtrace`` command when utilizing SystemTap on Linux.

- gh-131675: Fix mimalloc library builds for 32-bit ARM targets.

- gh-130673: Fix potential ``KeyError`` when handling object sections during
  JIT building process.

- gh-130740: Ensure that ``Python.h`` is included before ``stdbool.h``
  unless ``pyconfig.h`` is included before or in some platform-specific
  contexts.

- gh-129838: Don't redefine ``_Py_NO_SANITIZE_UNDEFINED`` when compiling
  with a recent GCC version and undefined sanitizer enabled.

- gh-129660: Drop ``test_embed`` from PGO training, whose contribution in
  recent versions is considered to be ignorable.


What's New in Python 3.13.2 final?
==================================

*Release date: 2025-02-04*

macOS
-----

- gh-127592: Usage of the unified Apple System Log APIs was disabled when
  the minimum macOS version is earlier than 10.12.

Windows
-------

- gh-127353: Allow to force color output on Windows using environment
  variables. Patch by Andrey Efremov.

Tools/Demos
-----------

- gh-129248: The iOS test runner now strips the log prefix from each line
  output by the test suite.

- gh-128152: Fix a bug where Argument Clinic's C pre-processor parser tried
  to parse pre-processor directives inside C comments. Patch by Erlend
  Aasland.

Tests
-----

- gh-127906: Test the limited C API in test_cppext. Patch by Victor Stinner.

- gh-127637: Add tests for the :mod:`dis` command-line interface. Patch by
  Bénédikt Tran.

- gh-126925: iOS test results are now streamed during test execution, and
  the deprecated xcresulttool is no longer used.

Security
--------

- gh-105704: When using :func:`urllib.parse.urlsplit` and
  :func:`urllib.parse.urlparse` host parsing would not reject domain names
  containing square brackets (``[`` and ``]``). Square brackets are only
  valid for IPv6 and IPvFuture hosts according to `RFC 3986 Section 3.2.2
  <https://www.rfc-editor.org/rfc/rfc3986#section-3.2.2>`__.

- gh-127655: Fixed the
  :class:`!asyncio.selector_events._SelectorSocketTransport` transport not
  pausing writes for the protocol when the buffer reaches the high water
  mark when using :meth:`asyncio.WriteTransport.writelines`.

- gh-126108: Fix a possible ``NULL`` pointer dereference in
  :c:func:`!PySys_AddWarnOptionUnicode`.

- gh-80222: Fix bug in the folding of quoted strings when flattening an
  email message using a modern email policy. Previously when a quoted string
  was folded so that it spanned more than one line, the surrounding quotes
  and internal escapes would be omitted. This could theoretically be used to
  spoof header lines using a carefully constructed quoted string if the
  resulting rendered email was transmitted or re-parsed.

- gh-119511: Fix a potential denial of service in the :mod:`imaplib` module.
  When connecting to a malicious server, it could cause an arbitrary amount
  of memory to be allocated. On many systems this is harmless as unused
  virtual memory is only a mapping, but if this hit a virtual address size
  limit it could lead to a :exc:`MemoryError` or other process crash. On
  unusual systems or builds where all allocated memory is touched and backed
  by actual ram or storage it could've consumed resources doing so until
  similarly crashing.

Library
-------

- gh-129502: Unlikely errors in preparing arguments for :mod:`ctypes`
  callback are now handled in the same way as errors raised in the callback
  of in converting the result of the callback -- using
  :func:`sys.unraisablehook` instead of :func:`sys.excepthook` and not
  setting :data:`sys.last_exc` and other variables.

- gh-129403: Corrected :exc:`ValueError` message for
  :class:`asyncio.Barrier` and :class:`threading.Barrier`.

- gh-129409: Fix an integer overflow in the :mod:`csv` module when writing a
  data field larger than 2GB.

- gh-118761: Improve import time of :mod:`subprocess` by lazy importing
  ``locale`` and ``signal``. Patch by Taneli Hukkinen.

- gh-129346: In :mod:`sqlite3`, handle out-of-memory when creating
  user-defined SQL functions.

- gh-129061: Fix FORCE_COLOR and NO_COLOR when empty strings. Patch by Hugo
  van Kemenade.

- gh-128550: Removed an incorrect optimization relating to eager tasks in
  :class:`asyncio.TaskGroup` that resulted in cancellations being missed.

- gh-128991: Release the enter frame reference within :mod:`bdb` callback

- gh-128978: Fix a :exc:`NameError` in
  :func:`!sysconfig.expand_makefile_vars`. Patch by Bénédikt Tran.

- gh-128961: Fix a crash when setting state on an exhausted
  :class:`array.array` iterator.

- gh-128894: Fix ``traceback.TracebackException._format_syntax_error`` not
  to fail on exceptions with custom metadata.

- gh-128916: Do not attempt to set ``SO_REUSEPORT`` on sockets of address
  families other than ``AF_INET`` and ``AF_INET6``, as it is meaningless
  with these address families, and the call with fail with Linux kernel
  6.12.9 and newer.

- gh-128679: Fix :func:`tracemalloc.stop` race condition. Fix
  :mod:`tracemalloc` to support calling :func:`tracemalloc.stop` in one
  thread, while another thread is tracing memory allocations. Patch by
  Victor Stinner.

- gh-128636: Fix PyREPL failure when :data:`os.environ` is overwritten with
  an invalid value.

- gh-128562: Fix possible conflicts in generated :mod:`tkinter` widget names
  if the widget class name ends with a digit.

- gh-128498: Default to stdout isatty for color detection instead of stderr.
  Patch by Hugo van Kemenade.

- gh-128552: Fix cyclic garbage introduced by
  :meth:`asyncio.loop.create_task` and :meth:`asyncio.TaskGroup.create_task`
  holding a reference to the created task if it is eager.

- gh-128479: Fix :func:`!asyncio.staggered.staggered_race` leaking tasks and
  issuing an unhandled exception.

- gh-128400: Fix crash when using :func:`faulthandler.dump_traceback` while
  other threads are active on the :term:`free threaded <free threading>`
  build.

- gh-88834: Unify the instance check for :class:`typing.Union` and
  :class:`types.UnionType`: :class:`!Union` now uses the instance checks
  against its parameters instead of the subclass checks.

- gh-128302: Fix
  :meth:`!xml.dom.xmlbuilder.DOMEntityResolver.resolveEntity`, which was
  broken by the Python 3.0 transition.

- gh-128302: Allow :meth:`!xml.dom.xmlbuilder.DOMParser.parse` to correctly
  handle :class:`!xml.dom.xmlbuilder.DOMInputSource` instances that only
  have a :attr:`!systemId` attribute set.

- gh-112064: Fix incorrect handling of negative read sizes in
  :meth:`HTTPResponse.read <http.client.HTTPResponse.read>`. Patch by Yury
  Manushkin.

- gh-58956: Fixed a frame reference leak in :mod:`bdb`.

- gh-128131: Completely support random access of uncompressed unencrypted
  read-only zip files obtained by :meth:`ZipFile.open
  <zipfile.ZipFile.open>`.

- gh-112328: :class:`enum.EnumDict` can now be used without resorting to
  private API.

- gh-127975: Avoid reusing quote types in :func:`ast.unparse` if not needed.

- gh-128062: Revert the font of :mod:`turtledemo`'s menu bar to its default
  value and display the shortcut keys in the correct position.

- gh-128014: Fix resetting the default window icon by passing ``default=''``
  to the :mod:`tkinter` method :meth:`!wm_iconbitmap`.

- gh-115514: Fix exceptions and incomplete writes after
  :class:`!asyncio._SelectorTransport` is closed before writes are
  completed.

- gh-41872: Fix quick extraction of module docstrings from a file in
  :mod:`pydoc`. It now supports docstrings with single quotes, escape
  sequences, raw string literals, and other Python syntax.

- gh-127060: Set TERM environment variable to "dumb" to disable traceback
  colors in IDLE, since IDLE doesn't understand ANSI escape sequences. Patch
  by Victor Stinner.

- gh-126742: Fix support of localized error messages reported by
  :manpage:`dlerror(3)` and :manpage:`gdbm_strerror <gdbm(3)>` in
  :mod:`ctypes` and :mod:`dbm.gnu` functions respectively. Patch by Bénédikt
  Tran.

- gh-127873: When ``-E`` is set, only ignore ``PYTHON_COLORS`` and not
  ``FORCE_COLOR``/``NO_COLOR``/``TERM`` when colourising output. Patch by
  Hugo van Kemenade.

- gh-127870: Detect recursive calls in ctypes ``_as_parameter_`` handling.
  Patch by Victor Stinner.

- gh-127847: Fix the position when doing interleaved seeks and reads in
  uncompressed, unencrypted zip files returned by
  :meth:`zipfile.ZipFile.open`.

- gh-127732: The :mod:`platform` module now correctly detects Windows Server
  2025.

- gh-126821: macOS and iOS apps can now choose to redirect stdout and stderr
  to the system log during interpreter configuration.

- gh-93312: Include ``<sys/pidfd.h>`` to get ``os.PIDFD_NONBLOCK`` constant.
  Patch by Victor Stinner.

- gh-83662: Add missing ``__class_getitem__`` method to the Python
  implementation of :func:`functools.partial`, to make it compatible with
  the C version. This is mainly relevant for alternative Python
  implementations like PyPy and GraalPy, because CPython will usually use
  the C-implementation of that function.

- gh-127586: :class:`multiprocessing.pool.Pool` now properly restores
  blocked signal handlers of the parent thread when creating processes via
  either *spawn* or *forkserver*.

- gh-98188: Fix an issue in :meth:`email.message.Message.get_payload` where
  data cannot be decoded if the Content Transfer Encoding mechanism contains
  trailing whitespaces or additional junk text. Patch by Hui Liu.

- gh-127257: In :mod:`ssl`, system call failures that OpenSSL reports using
  ``ERR_LIB_SYS`` are now raised as :exc:`OSError`.

- gh-127096: Do not recreate unnamed section on every read in
  :class:`configparser.ConfigParser`. Patch by Andrey Efremov.

- gh-127196: Fix crash when dict with keys in invalid encoding were passed
  to several functions in ``_interpreters`` module.

- gh-126775: Make :func:`linecache.checkcache` thread safe and GC
  re-entrancy safe.

- gh-126332: Fix _pyrepl crash when entering a double CTRL-Z on an
  overflowing line.

- gh-126225: :mod:`getopt` and :mod:`optparse` are no longer marked as
  deprecated. There are legitimate reasons to use one of these modules in
  preference to :mod:`argparse`, and none of these modules are at risk of
  being removed from the standard library. Of the three, ``argparse``
  remains the recommended default choice, *unless* one of the concerns noted
  at the top of the ``optparse`` module documentation applies.

- gh-125553: Fix round-trip invariance for backslash continuations in
  :func:`tokenize.untokenize`.

- gh-123987: Fixed issue in NamespaceReader where a non-path item in a
  namespace path, such as a sentinel added by an editable installer, would
  break resource loading.

- gh-123401: The :mod:`http.cookies` module now supports parsing obsolete
  :rfc:`850` date formats, in accordance with :rfc:`9110` requirements.
  Patch by Nano Zheng.

- gh-122431: :func:`readline.append_history_file` now raises a
  :exc:`ValueError` when given a negative value.

- gh-119257: Show tab completions menu below the current line, which results
  in less janky behaviour, and fixes a cursor movement bug. Patch by Daniel
  Hollas

Documentation
-------------

- gh-125722: Require Sphinx 8.1.3 or later to build the Python
  documentation. Patch by Adam Turner.

- gh-67206: Document that :const:`string.printable` is not printable in the
  POSIX sense. In particular, :meth:`string.printable.isprintable()
  <str.isprintable>` returns :const:`False`. Patch by Bénédikt Tran.

Core and Builtins
-----------------

- gh-129345: Fix null pointer dereference in :func:`syslog.openlog` when an
  audit hook raises an exception.

- gh-129093: Fix f-strings such as ``f'{expr=}'`` sometimes not displaying
  the full expression when the expression contains ``!=``.

- gh-124363: Treat debug expressions in f-string as raw strings. Patch by
  Pablo Galindo

- gh-128799: Add frame of ``except*`` to traceback when it wraps a naked
  exception.

- gh-128078: Fix a :exc:`SystemError` when using :func:`anext` with a
  default tuple value. Patch by Bénédikt Tran.

- gh-128717: Fix a crash when setting the recursion limit while other
  threads are active on the :term:`free threaded <free threading>` build.

- gh-128330: Restore terminal control characters on REPL exit.

- gh-128079: Fix a bug where :keyword:`except* <except_star>` does not
  properly check the return value of an :exc:`ExceptionGroup`'s
  :meth:`~BaseExceptionGroup.split` function, leading to a crash in some
  cases. Now when :meth:`~BaseExceptionGroup.split` returns an invalid
  object, :keyword:`except* <except_star>` raises a :exc:`TypeError` with
  the original raised :exc:`ExceptionGroup` object chained to it.

- gh-128030: Avoid error from calling ``PyModule_GetFilenameObject`` on a
  non-module object when importing a non-existent symbol from a non-module
  object.

- gh-127903: ``Objects/unicodeobject.c``: fix a crash on DEBUG builds in
  ``_copy_characters`` when there is nothing to copy.

- gh-127599: Fix statistics for increments of object reference counts (in
  particular, when a reference count was increased by more than 1 in a
  single operation).

- gh-127651: When raising :exc:`ImportError` for missing symbols in ``from``
  imports, use ``__file__`` in the error message if ``__spec__.origin`` is
  not a location

- gh-127582: Fix non-thread-safe object resurrection when calling finalizers
  and watcher callbacks in the free threading build.

- gh-127434: The iOS compiler shims can now accept arguments with spaces.

- gh-127536: Add missing locks around some list assignment operations in the
  free threading build.

- gh-126862: Fix a possible overflow when a class inherits from an absurd
  number of super-classes. Reported by Valery Fedorenko. Patch by Bénédikt
  Tran.

- gh-127349: Fixed the error when resizing terminal in Python REPL. Patch by
  Semyon Moroz.

- gh-126076: Relocated objects such as ``tuple``, ``bytes`` and ``str``
  objects are properly tracked by :mod:`tracemalloc` and its associated
  hooks. Patch by Pablo Galindo.

C API
-----

- gh-127791: Fix loss of callbacks after more than one call to
  :c:func:`PyUnstable_AtExit`.

Build
-----

- gh-129539: Don't redefine ``EX_OK`` when the system has the ``sysexits.h``
  header.

- gh-128472: Skip BOLT optimization of functions using computed gotos,
  fixing errors on build with LLVM 19.

- gh-123925: Fix building the :mod:`curses` module on platforms with
  libncurses but without libncursesw.

- gh-128321: Set ``LIBS`` instead of ``LDFLAGS`` when checking if
  :mod:`sqlite3` library functions are available. This fixes the ordering of
  linked libraries during checks, which was incorrect when using a
  statically linked ``libsqlite3``.

- gh-127865: Fix build failure on systems without thread-locals support.


What's New in Python 3.13.1 final?
==================================

*Release date: 2024-12-03*

macOS
-----

- gh-124448: Update bundled Tcl/Tk in macOS installer to 8.6.15.

Windows
-------

- gh-126911: Update credits command output.

- gh-118973: Ensures the experimental free-threaded install includes the
  ``_tkinter`` module. The optional Tcl/Tk component must also be installed
  in order for the module to work.

- gh-126497: Fixes venv failure due to missing redirector executables in
  experimental free-threaded installs.

- gh-126074: Removed unnecessary DLLs from Windows embeddable package

- gh-125315: Avoid crashing in :mod:`platform` due to slow WMI calls on some
  Windows machines.

- gh-126084: Fix venvwlauncher to launch pythonw instead of python so no
  extra console window is created.

- gh-125842: Fix a :exc:`SystemError` when :func:`sys.exit` is called with
  ``0xffffffff`` on Windows.

- gh-125550: Enable the :ref:`launcher` to detect Python 3.14 installs from
  the Windows Store.

- gh-124448: Updated bundled Tcl/Tk to 8.6.15.

Tools/Demos
-----------

- gh-126807: Fix extraction warnings in :program:`pygettext.py` caused by
  mistaking function definitions for function calls.

- gh-126167: The iOS testbed was modified so that it can be used by
  third-party projects for testing purposes.

Tests
-----

- gh-126909: Fix test_os extended attribute tests to work on filesystems
  with 1 KiB xattr size limit.

- gh-125041: Re-enable skipped tests for :mod:`zlib` on the s390x
  architecture: only skip checks of the compressed bytes, which can be
  different between zlib's software implementation and the
  hardware-accelerated implementation.

- gh-124295: Add translation tests to the :mod:`argparse` module.

Security
--------

- gh-126623: Upgrade libexpat to 2.6.4

- gh-125140: Remove the current directory from ``sys.path`` when using
  PyREPL.

- gh-122792: Changed IPv4-mapped ``ipaddress.IPv6Address`` to consistently
  use the mapped IPv4 address value for deciding properties. Properties
  which have their behavior fixed are ``is_multicast``, ``is_reserved``,
  ``is_link_local``, ``is_global``, and ``is_unspecified``.

Library
-------

- gh-127321: :func:`pdb.set_trace` will not stop at an opcode that does not
  have an associated line number anymore.

- gh-127303: Publicly expose :data:`~token.EXACT_TOKEN_TYPES` in
  :attr:`!token.__all__`.

- gh-123967: Fix faulthandler for trampoline frames. If the top-most frame
  is a trampoline frame, skip it. Patch by Victor Stinner.

- gh-127182: Fix :meth:`!io.StringIO.__setstate__` crash, when :const:`None`
  was passed as the first value.

- gh-127217: Fix :func:`urllib.request.pathname2url` for paths starting with
  multiple slashes on Posix.

- gh-127035: Fix :mod:`shutil.which` on Windows. Now it looks at direct
  match if and only if the command ends with a PATHEXT extension or X_OK is
  not in mode. Support extensionless files if "." is in PATHEXT. Support
  PATHEXT extensions that end with a dot.

- gh-122273: Support PyREPL history on Windows. Patch by devdanzin and
  Victor Stinner.

- gh-127078: Fix issue where :func:`urllib.request.url2pathname` failed to
  discard an extra slash before a UNC drive in the URL path on Windows.

- gh-126766: Fix issue where :func:`urllib.request.url2pathname` failed to
  discard any 'localhost' authority present in the URL.

- gh-127065: Fix crash when calling a :func:`operator.methodcaller` instance
  from multiple threads in the free threading build.

- gh-126997: Fix support of STRING and GLOBAL opcodes with non-ASCII
  arguments in :mod:`pickletools`. :func:`pickletools.dis` now outputs
  non-ASCII bytes in STRING, BINSTRING and SHORT_BINSTRING arguments as
  escaped (``\xXX``).

- gh-126316: :mod:`grp`: Make :func:`grp.getgrall` thread-safe by adding a
  mutex. Patch by Victor Stinner.

- gh-126618: Fix the representation of :class:`itertools.count` objects when
  the count value is :data:`sys.maxsize`.

- gh-85168: Fix issue where :func:`urllib.request.url2pathname` and
  :func:`~urllib.request.pathname2url` always used UTF-8 when quoting and
  unquoting file URIs. They now use the :term:`filesystem encoding and error
  handler`.

- gh-67877: Fix memory leaks when :mod:`regular expression <re>` matching
  terminates abruptly, either because of a signal or because memory
  allocation fails.

- gh-126789: Fixed the values of :py:func:`sysconfig.get_config_vars`,
  :py:func:`sysconfig.get_paths`, and their siblings when the :py:mod:`site`
  initialization happens after :py:mod:`sysconfig` has built a cache for
  :py:func:`sysconfig.get_config_vars`.

- gh-126188: Update bundled pip to 24.3.1

- gh-126780: Fix :func:`os.path.normpath` for drive-relative paths on
  Windows.

- gh-126766: Fix issue where :func:`urllib.request.url2pathname` failed to
  discard two leading slashes introducing an empty authority section.

- gh-126727: ``locale.nl_langinfo(locale.ERA)`` now returns multiple era
  description segments separated by semicolons. Previously it only returned
  the first segment on platforms with Glibc.

- gh-126699: Allow :class:`collections.abc.AsyncIterator` to be a base for
  Protocols.

- gh-126654: Fix crash when non-dict was passed to several functions in
  ``_interpreters`` module.

- gh-104745: Limit starting a patcher (from :func:`unittest.mock.patch` or
  :func:`unittest.mock.patch.object`) more than once without stopping it

- gh-126595: Fix a crash when instantiating :class:`itertools.count` with an
  initial count of :data:`sys.maxsize` on debug builds. Patch by Bénédikt
  Tran.

- gh-120423: Fix issue where :func:`urllib.request.pathname2url` mishandled
  Windows paths with embedded forward slashes.

- gh-126565: Improve performances of :meth:`zipfile.Path.open` for
  non-reading modes.

- gh-126505: Fix bugs in compiling case-insensitive :mod:`regular
  expressions <re>` with character classes containing non-BMP characters:
  upper-case non-BMP character did was ignored and the ASCII flag was
  ignored when matching a character range whose upper bound is beyond the
  BMP region.

- gh-117378: Fixed the :mod:`multiprocessing` ``"forkserver"`` start method
  forkserver process to correctly inherit the parent's :data:`sys.path`
  during the importing of :func:`multiprocessing.set_forkserver_preload`
  modules in the same manner as :data:`sys.path` is configured in workers
  before executing work items.

  This bug caused some forkserver module preloading to silently fail to
  preload. This manifested as a performance degration in child processes
  when the ``sys.path`` was required due to additional repeated work in
  every worker.

  It could also have a side effect of ``""`` remaining in :data:`sys.path`
  during forkserver preload imports instead of the absolute path from
  :func:`os.getcwd` at multiprocessing import time used in the worker
  ``sys.path``.

  The ``sys.path`` differences between phases in the child process could
  potentially have caused preload to import incorrect things from the wrong
  location.  We are unaware of that actually having happened in practice.

- gh-125679: The :class:`multiprocessing.Lock` and
  :class:`multiprocessing.RLock` ``repr`` values no longer say "unknown" on
  macOS.

- gh-126476: Raise :class:`calendar.IllegalMonthError` (now a subclass of
  :class:`IndexError`) for :func:`calendar.month` when the input month is
  not correct.

- gh-126489: The Python implementation of :mod:`pickle` no longer calls
  :meth:`pickle.Pickler.persistent_id` for the result of
  :meth:`!persistent_id`.

- gh-126313: Fix an issue in :func:`curses.napms` when
  :func:`curses.initscr` has not yet been called. Patch by Bénédikt Tran.

- gh-126303: Fix pickling and copying of :class:`os.sched_param` objects.

- gh-126138: Fix a use-after-free crash on :class:`asyncio.Task` objects
  whose underlying coroutine yields an object that implements an evil
  :meth:`~object.__getattribute__`. Patch by Nico Posada.

- gh-126220: Fix crash in :class:`!cProfile.Profile` and
  :class:`!_lsprof.Profiler` when their callbacks were directly called with
  0 arguments.

- gh-126212: Fix issue where :func:`urllib.request.pathname2url` and
  :func:`~urllib.request.url2pathname` removed slashes from Windows DOS
  drive paths and URLs.

- gh-126223: Raise a :exc:`UnicodeEncodeError` instead of a
  :exc:`SystemError` upon calling :func:`!_interpreters.create` with an
  invalid Unicode character.

- gh-126205: Fix issue where :func:`urllib.request.pathname2url` generated
  URLs beginning with four slashes (rather than two) when given a Windows
  UNC path.

- gh-126105: Fix a crash in :mod:`ast` when the :attr:`ast.AST._fields`
  attribute is deleted.

- gh-126106: Fixes a possible ``NULL`` pointer dereference in :mod:`ssl`.

- gh-126080: Fix a use-after-free crash on :class:`asyncio.Task` objects for
  which the underlying event loop implements an evil
  :meth:`~object.__getattribute__`. Reported by Nico-Posada. Patch by
  Bénédikt Tran.

- gh-126083: Fixed a reference leak in :class:`asyncio.Task` objects when
  reinitializing the same object with a non-``None`` context. Patch by Nico
  Posada.

- gh-125984: Fix use-after-free crashes on :class:`asyncio.Future` objects
  for which the underlying event loop implements an evil
  :meth:`~object.__getattribute__`. Reported by Nico-Posada. Patch by
  Bénédikt Tran.

- gh-125969: Fix an out-of-bounds crash when an evil
  :meth:`asyncio.loop.call_soon` mutates the length of the internal
  callbacks list. Patch by Bénédikt Tran.

- gh-125966: Fix a use-after-free crash in
  :meth:`asyncio.Future.remove_done_callback`. Patch by Bénédikt Tran.

- gh-125789: Fix possible crash when mutating list of callbacks returned by
  :attr:`!asyncio.Future._callbacks`. It now always returns a new copy in C
  implementation :mod:`!_asyncio`. Patch by Kumar Aditya.

- gh-124452: Fix an issue in
  :meth:`email.policy.EmailPolicy.header_source_parse` and
  :meth:`email.policy.Compat32.header_source_parse` that introduced spurious
  leading whitespaces into header values when the header includes a newline
  character after the header name delimiter (``:``) and before the value.

- gh-125884: Fixed the bug for :mod:`pdb` where it can't set breakpoints on
  functions with certain annotations.

- gh-125355: Fix several bugs in
  :meth:`argparse.ArgumentParser.parse_intermixed_args`.

  * The parser no longer changes temporarily during parsing.
  * Default values are not processed twice.
  * Required mutually exclusive groups containing positional arguments are now supported.
  * The missing arguments report now includes the names of all required optional and positional arguments.
  * Unknown options can be intermixed with positional arguments in parse_known_intermixed_args().

- gh-125666: Avoid the exiting the interpreter if a null byte is given as
  input in the new REPL.

- gh-125710: [Enum] fix hashable<->nonhashable comparisons for member values

- gh-125631: Restore ability to set :attr:`~pickle.Pickler.persistent_id`
  and :attr:`~pickle.Unpickler.persistent_load` attributes of instances of
  the :class:`!Pickler` and :class:`!Unpickler` classes in the :mod:`pickle`
  module.

- gh-125378: Fixed the bug in :mod:`pdb` where after a multi-line command,
  an empty line repeats the first line of the multi-line command, instead of
  the full command.

- gh-125682: Reject non-ASCII digits in the Python implementation of
  :func:`json.loads` conforming to the JSON specification.

- gh-125660: Reject invalid unicode escapes for Python implementation of
  :func:`json.loads`.

- gh-125259: Fix the notes removal logic for errors thrown in enum
  initialization.

- gh-125590: Allow ``FrameLocalsProxy`` to delete and pop if the key is not
  a fast variable.

- gh-125519: Improve traceback if :func:`importlib.reload` is called with an
  object that is not a module. Patch by Alex Waygood.

- gh-125451: Fix deadlock when
  :class:`concurrent.futures.ProcessPoolExecutor` shuts down concurrently
  with an error when feeding a job to a worker process.

- gh-125422: Fixed the bug where :mod:`pdb` and :mod:`bdb` can step into the
  bottom caller frame.

- gh-100141: Fixed the bug where :mod:`pdb` will be stuck in an infinite
  loop when debugging an empty file.

- gh-125115: Fixed a bug in :mod:`pdb` where arguments starting with ``-``
  can't be passed to the debugged script.

- gh-53203: Fix :func:`time.strptime` for ``%c``, ``%x`` and ``%X`` formats
  in many locales that use non-ASCII digits, like Persian, Burmese, Odia and
  Shan.

- gh-125398: Fix the conversion of the :envvar:`!VIRTUAL_ENV` path in the
  activate script in :mod:`venv` when running in Git Bash for Windows.

- gh-125316: Fix using :func:`functools.partial` as :class:`enum.Enum`
  member. A FutureWarning with suggestion to use :func:`enum.member` is now
  emitted when the ``partial`` instance is used as an enum member.

- gh-125245: Fix race condition when importing :mod:`collections.abc`, which
  could incorrectly return an empty module.

- gh-125243: Fix data race when creating :class:`zoneinfo.ZoneInfo` objects
  in the free threading build.

- gh-125254: Fix a bug where ArgumentError includes the incorrect ambiguous
  option in :mod:`argparse`.

- gh-125235: Keep :mod:`tkinter` TCL paths in venv pointing to base
  installation on Windows.

- gh-61011: Fix inheritance of nested mutually exclusive groups from parent
  parser in :class:`argparse.ArgumentParser`. Previously, all nested
  mutually exclusive groups lost their connection to the group containing
  them and were displayed as belonging directly to the parser.

- gh-52551: Fix encoding issues in :func:`time.strftime`, the
  :meth:`~datetime.datetime.strftime` method of the :mod:`datetime` classes
  :class:`~datetime.datetime`, :class:`~datetime.date` and
  :class:`~datetime.time` and formatting of these classes. Characters not
  encodable in the current locale are now acceptable in the format string.
  Surrogate pairs and sequence of surrogatescape-encoded bytes are no longer
  recombinated. Embedded null character no longer terminates the format
  string.

- gh-125118: Don't copy arbitrary values to :c:expr:`_Bool` in the
  :mod:`struct` module.

- gh-125069: Fix an issue where providing a :class:`pathlib.PurePath` object
  as an initializer argument to a second :class:`~pathlib.PurePath` object
  with a different :attr:`~pathlib.PurePath.parser` resulted in arguments to
  the former object's initializer being joined by the latter object's
  parser.

- gh-125096: If the :envvar:`PYTHON_BASIC_REPL` environment variable is set,
  the :mod:`site` module no longer imports the :mod:`!_pyrepl` module.
  Moreover, the :mod:`site` module now respects :option:`-E` and
  :option:`-I` command line options: ignore :envvar:`PYTHON_BASIC_REPL` in
  this case. Patch by Victor Stinner.

- gh-124969: Fix ``locale.nl_langinfo(locale.ALT_DIGITS)`` on platforms with
  glibc. Now it returns a string consisting of up to 100 semicolon-separated
  symbols (an empty string in most locales) on all Posix platforms.
  Previously it only returned the first symbol or an empty string.

- gh-124960: Fix support for the ``barry_as_FLUFL`` future flag in the new
  REPL.

- gh-124984: Fixed thread safety in :mod:`ssl` in the free-threaded build.
  OpenSSL operations are now protected by a per-object lock.

- gh-124958: Fix refcycles in exceptions raised from
  :class:`asyncio.TaskGroup` and the python implementation of
  :class:`asyncio.Future`

- gh-53203: Fix :func:`time.strptime` for ``%c`` and ``%x`` formats in many
  locales: Arabic, Bislama, Breton, Bodo, Kashubian, Chuvash, Estonian,
  French, Irish, Ge'ez, Gurajati, Manx Gaelic, Hebrew, Hindi, Chhattisgarhi,
  Haitian Kreyol, Japanese, Kannada, Korean, Marathi, Malay, Norwegian,
  Nynorsk, Punjabi, Rajasthani, Tok Pisin, Yoruba, Yue Chinese, Yau/Nungon
  and Chinese.

- gh-124917: Allow calling :func:`os.path.exists` and
  :func:`os.path.lexists` with keyword arguments on Windows. Fixes a
  regression in 3.13.0.

- gh-124653: Fix detection of the minimal Queue API needed by the
  :mod:`logging` module. Patch by Bénédikt Tran.

- gh-124858: Fix reference cycles left in tracebacks in
  :func:`asyncio.open_connection` when used with ``happy_eyeballs_delay``

- gh-124390: Fixed :exc:`AssertionError` when using
  :func:`!asyncio.staggered.staggered_race` with
  :attr:`asyncio.eager_task_factory`.

- gh-124651: Properly quote template strings in :mod:`venv` activation
  scripts.

- gh-116850: Fix :mod:`argparse` for namespaces with not directly writable
  dict (e.g. classes).

- gh-58573: Fix conflicts between abbreviated long options in the parent
  parser and subparsers in :mod:`argparse`.

- gh-124594: All :mod:`asyncio` REPL prompts run in the same :class:`context
  <contextvars.Context>`. Contributed by Bartosz Sławecki.

- gh-61181: Fix support of :ref:`choices` with string value in
  :mod:`argparse`. Substrings of the specified string no longer considered
  valid values.

- gh-80259: Fix :mod:`argparse` support of positional arguments with
  ``nargs='?'``, ``default=argparse.SUPPRESS`` and specified ``type``.

- gh-120378: Fix a crash related to an integer overflow in
  :func:`curses.resizeterm` and :func:`curses.resize_term`.

- gh-123884: Fixed bug in itertools.tee() handling of other tee inputs (a
  tee in a tee). The output now has the promised *n* independent new
  iterators.  Formerly, the first iterator was identical (not independent)
  to the input iterator. This would sometimes give surprising results.

- gh-58956: Fixed a bug in :mod:`pdb` where sometimes the breakpoint won't
  trigger if it was set on a function which is already in the call stack.

- gh-124345: :mod:`argparse` vim supports abbreviated single-dash long
  options separated by ``=`` from its value.

- gh-104860: Fix disallowing abbreviation of single-dash long options in
  :mod:`argparse` with ``allow_abbrev=False``.

- gh-63143: Fix parsing mutually exclusive arguments in :mod:`argparse`.
  Arguments with the value identical to the default value (e.g. booleans,
  small integers, empty or 1-character strings) are no longer considered
  "not present".

- gh-72795: Positional arguments with :ref:`nargs` equal to ``'*'`` or
  :data:`!argparse.REMAINDER` are no longer required. This allows to use
  positional argument with ``nargs='*'`` and without ``default`` in mutually
  exclusive group and improves error message about required arguments.

- gh-59317: Fix parsing positional argument with :ref:`nargs` equal to
  ``'?'`` or ``'*'`` if it is preceded by an option and another positional
  argument.

- gh-53780: :mod:`argparse` now ignores the first ``"--"`` (double dash)
  between an option and command.

- gh-124217: Add RFC 9637 reserved IPv6 block ``3fff::/20`` in
  :mod:`ipaddress` module.

- gh-81691: Fix handling of multiple ``"--"`` (double dashes) in
  :mod:`argparse`. Only the first one has now been removed, all subsequent
  ones are now taken literally.

- gh-123978: Remove broken :func:`time.thread_time` and
  :func:`time.thread_time_ns` on NetBSD.

- gh-124008: Fix possible crash (in debug build), incorrect output or
  returning incorrect value from raw binary ``write()`` when writing to
  console on Windows.

- gh-123935: Fix parent slots detection for dataclasses that inherit from
  classes with ``__dictoffset__``.

- gh-122765: Fix unbalanced quote errors occurring when activate.csh in
  :mod:`venv` was sourced with a custom prompt containing unpaired quotes or
  newlines.

- gh-123370: Fix the canvas not clearing after running turtledemo clock.

- gh-116810: Resolve a memory leak introduced in CPython 3.10's :mod:`ssl`
  when the :attr:`ssl.SSLSocket.session` property was accessed.  Speeds up
  read and write access to said property by no longer unnecessarily cloning
  session objects via serialization.

- gh-120754: Update unbounded ``read`` calls in :mod:`zipfile` to specify an
  explicit ``size`` putting a limit on how much data they may read. This
  also updates handling around ZIP max comment size to match the standard
  instead of reading comments that are one byte too long.

- gh-70764: Fixed an issue where :func:`inspect.getclosurevars` would
  incorrectly classify an attribute name as a global variable when the name
  exists both as an attribute name and a global variable.

- gh-118289: :func:`!posixpath.realpath` now raises
  :exc:`NotADirectoryError` when *strict* mode is enabled and a
  non-directory path with a trailing slash is supplied.

- gh-119826: Always return an absolute path for :func:`os.path.abspath` on
  Windows.

- gh-117766: Always use :func:`str` to print ``choices`` in :mod:`argparse`.

- gh-101955: Fix SystemError when match regular expression pattern
  containing some combination of possessive quantifier, alternative and
  capture group.

- gh-88110: Fixed :class:`multiprocessing.Process` reporting a ``.exitcode``
  of 1 even on success when using the ``"fork"`` start method while using a
  :class:`concurrent.futures.ThreadPoolExecutor`.

- gh-71936: Fix a race condition in :class:`multiprocessing.pool.Pool`.

- bpo-46128: Strip :class:`unittest.IsolatedAsyncioTestCase` stack frames
  from reported stacktraces.

- bpo-14074: Fix :mod:`argparse` metavar processing to allow positional
  arguments to have a tuple metavar.

IDLE
----

- gh-122392: Increase currently inadequate vertical spacing for the IDLE
  browsers (path, module, and stack) on high-resolution monitors.

Documentation
-------------

- gh-126622: Added stub pages for removed modules explaining their removal,
  where to find replacements, and linking to the last Python version that
  supported them. Contributed by Ned Batchelder.

- gh-125277: Require Sphinx 7.2.6 or later to build the Python
  documentation. Patch by Adam Turner.

- gh-124872: Added definitions for :term:`context`, :term:`current context`,
  and :term:`context management protocol`, updated related definitions to be
  consistent, and expanded the documentation for
  :class:`contextvars.Context`.

- gh-125018: The :mod:`importlib.metadata` documentation now includes
  semantic cross-reference targets for the significant documented APIs. This
  means intersphinx references like :func:`importlib.metadata.version` will
  now work as expected.

- gh-70870: Clarified the dual usage of the term "free variable" (both the
  formal meaning of any reference to names defined outside the local scope,
  and the narrower pragmatic meaning of nonlocal variables named in
  ``co_freevars``).

- gh-121277: Writers of CPython's documentation can now use ``next`` as the
  version for the ``versionchanged``, ``versionadded``, ``deprecated``
  directives.

- gh-60712: Include the :class:`object` type in the lists of documented
  types. Change by Furkan Onder and Martin Panter.

- bpo-34008: The :c:func:`Py_Main` documentation moved from the "Very High
  Level API" section to the "Initialization and Finalization" section.

  Also make it explicit that we expect ``Py_Main`` to typically be called
  instead of ``Py_Initialize`` rather than after it (since ``Py_Main`` makes
  its own call to ``Py_Initialize``). Document that calling both is
  supported but is version dependent on which settings will be applied
  correctly.

Core and Builtins
-----------------

- gh-113841: Fix possible undefined behavior division by zero in
  :class:`complex`'s :c:func:`_Py_c_pow`.

- gh-127020: Fix a crash in the free threading build when
  :c:func:`PyCode_GetCode`, :c:func:`PyCode_GetVarnames`,
  :c:func:`PyCode_GetCellvars`, or :c:func:`PyCode_GetFreevars` were called
  from multiple threads at the same time.

- gh-126980: Fix :meth:`~object.__buffer__` of :class:`bytearray` crashing
  when :attr:`~inspect.BufferFlags.READ` or
  :attr:`~inspect.BufferFlags.WRITE` are passed as flags.

- gh-126881: Fix crash in finalization of dtoa state. Patch by Kumar Aditya.

- gh-126341: Now :exc:`ValueError` is raised instead of :exc:`SystemError`
  when trying to iterate over a released :class:`memoryview` object.

- gh-126688: Fix a crash when calling :func:`os.fork` on some operating
  systems, including SerenityOS.

- gh-126066: Fix :mod:`importlib` to not write an incomplete .pyc files when
  a ulimit or some other operating system mechanism is preventing the write
  to go through fully.

- gh-126312: Fix crash during garbage collection on an object frozen by
  :func:`gc.freeze` on the free-threaded build.

- gh-126139: Provide better error location when attempting to use a
  :term:`future statement <__future__>` with an unknown future feature.

- gh-126018: Fix a crash in :func:`sys.audit` when passing a non-string as
  first argument and Python was compiled in debug mode.

- gh-125942: On Android, the ``errors`` setting of :any:`sys.stdout` was
  changed from ``surrogateescape`` to ``backslashreplace``.

- gh-125859: Fix a crash in the free threading build when
  :func:`gc.get_objects` or :func:`gc.get_referrers` is called during an
  in-progress garbage collection.

- gh-125703: Correctly honour :mod:`tracemalloc` hooks in specialized
  ``Py_DECREF`` paths. Patch by Pablo Galindo

- gh-125593: Use color to highlight error locations in traceback from
  exception group

- gh-125444: Fix illegal instruction for older Arm architectures. Patch by
  Diego Russo, testing by Ross Burton.

- gh-124375: Fix a crash in the free threading build when the GC runs
  concurrently with a new thread starting.

- gh-125221: Fix possible race condition when calling
  :meth:`~object.__reduce_ex__` for the first time in the free threading
  build.

- gh-125038: Fix crash when iterating over a generator expression after
  direct changes on ``gi_frame.f_locals``. Patch by Mikhail Efimov.

- gh-123378: Fix a crash in the :meth:`~object.__str__` method of
  :exc:`UnicodeError` objects when the :attr:`UnicodeError.start` and
  :attr:`UnicodeError.end` values are invalid or out-of-range. Patch by
  Bénédikt Tran.

- gh-116510: Fix a crash caused by immortal interned strings being shared
  between sub-interpreters that use basic single-phase init.  In that case,
  the string can be used by an interpreter that outlives the interpreter
  that created and interned it.  For interpreters that share obmalloc state,
  also share the interned dict with the main interpreter.

- gh-122878: Use the ``pager`` binary, if available (e.g. on Debian and
  derivatives), to display REPL ``help()``.

- gh-124188: Fix reading and decoding a line from the source file witn
  non-UTF-8 encoding for syntax errors raised in the compiler.

- gh-123930: Improve the error message when a script shadowing a module from
  the standard library causes :exc:`ImportError` to be raised during a
  "from" import. Similarly, improve the error message when a script
  shadowing a third party module attempts to "from" import an attribute from
  that third party module while still initialising.

- gh-122907: Building with ``HAVE_DYNAMIC_LOADING`` now works as well as it
  did in 3.12. Existing deficiences will be addressed separately. (See
  https://github.com/python/cpython/issues/122950.)

- gh-118950: Fix bug where SSLProtocol.connection_lost wasn't getting called
  when OSError was thrown on writing to socket.

- gh-113570: Fixed a bug in ``reprlib.repr`` where it incorrectly called the
  repr method on shadowed Python built-in types.

- gh-109746: If :func:`!_thread.start_new_thread` fails to start a new
  thread, it deletes its state from interpreter and thus avoids its repeated
  cleanup on finalization.

C API
-----

- gh-126554: Fix error handling in :class:`ctypes.CDLL` objects which could
  result in a crash in rare situations.

- gh-125608: Fix a bug where dictionary watchers (e.g.,
  :c:func:`PyDict_Watch`) on an object's attribute dictionary
  (:attr:`~object.__dict__`) were not triggered when the object's attributes
  were modified.

- bpo-34008: Added ``Py_IsInitialized`` to the list of APIs that are safe to
  call before the interpreter is initialized, and updated the embedding
  tests to cover it.

Build
-----

- gh-123877: Set ``wasm32-wasip1`` as the WASI target. The old
  ``wasm32-wasi`` target is deprecated so it can be used for an eventual
  WASI 1.0.

- gh-89640: Hard-code float word ordering as little endian on WASM.

- gh-125940: The Android build now supports `16 KB page sizes
  <https://developer.android.com/guide/practices/page-sizes>`__.

- gh-89640: Improve detection of float word ordering on Linux when link-time
  optimizations are enabled.

- gh-125269: Fix detection of whether ``-latomic`` is needed when
  cross-compiling CPython using the configure script.

- gh-121634: Allow for specifying the target compile triple for WASI.

- gh-122578: Use WASI SDK 24 for testing.

- gh-115382: Fix cross compile failures when the host and target SOABIs
  match.


What's New in Python 3.13.0 final?
==================================

*Release date: 2024-10-07*

Core and Builtins
-----------------

- gh-125008: Fix :func:`tokenize.untokenize` producing invalid syntax for
  double braces preceded by certain escape characters.

- gh-124871: Fix compiler bug (in some versions of 3.13) where an assertion
  fails during reachability analysis.


What's New in Python 3.13.0 release candidate 3?
================================================

*Release date: 2024-10-01*

macOS
-----

- gh-123797: Check for runtime availability of ``ptsname_r`` function on
  macos.

Windows
-------

- gh-124609: Fix ``_Py_ThreadId`` for Windows builds using MinGW. Patch by
  Tony Roberts.

- gh-124254: Ensures experimental free-threaded binaries remain installed
  when updating.

- gh-123915: Ensure that ``Tools\msi\buildrelease.bat`` uses different
  directories for AMD64 and ARM64 builds.

Tests
-----

- gh-124378: Updated ``test_ttk`` to pass with Tcl/Tk 8.6.15.

Library
-------

- gh-124538: Fixed crash when using :func:`gc.get_referents` on a capsule
  object.

- gh-124498: Fix :class:`typing.TypeAliasType` not to be generic, when
  ``type_params`` is an empty tuple.

- gh-123017: Due to unreliable results on some devices,
  :func:`time.strftime` no longer accepts negative years on Android.

- gh-123014: :func:`os.pidfd_open` and :func:`signal.pidfd_send_signal` are
  now unavailable when building against Android API levels older than 31,
  since the underlying system calls may cause a crash.

- gh-124248: Fixed potential crash when using :mod:`struct` to process
  zero-width 'Pascal string' fields (``0p``).

- gh-87041: Fix a bug in :mod:`argparse` where lengthy subparser argument
  help is incorrectly indented.

- gh-124212: Fix invalid variable in :mod:`venv` handling of failed symlink
  on Windows

- gh-124171: Add workaround for broken :c:func:`!fmod()` implementations on
  Windows, that loose zero sign (e.g. ``fmod(-10, 1)`` returns ``0.0``).
  Patch by Sergey B Kirpichev.

- gh-123934: Fix :class:`unittest.mock.MagicMock` reseting magic methods
  return values after ``.reset_mock(return_value=True)`` was called.

- gh-123968: Fix the command-line interface for the :mod:`random` module to
  select floats between 0 and N, not 1 and N.

- gh-123892: Add ``"_wmi"`` to :data:`sys.stdlib_module_names`. Patch by
  Victor Stinner.

- gh-123339: Fix :func:`inspect.getsource` for classes in
  :mod:`collections.abc` and :mod:`decimal` (for pure Python implementation)
  modules. :func:`inspect.getcomments` now raises OSError instead of
  IndexError if the ``__firstlineno__`` value for a class is out of bound.

- gh-121735: When working with zip archives, importlib.resources now
  properly honors module-adjacent references (e.g. ``files(pkg.mod)`` and
  not just ``files(pkg)``).

- gh-122145: Fix an issue when reporting tracebacks corresponding to Python
  code emitting an empty AST body. Patch by Nikita Sobolev and Bénédikt
  Tran.

- gh-119004: Fix a crash in :ref:`OrderedDict.__eq__
  <collections_OrderedDict__eq__>` when operands are mutated during the
  check. Patch by Bénédikt Tran.

- bpo-44864: Do not translate user-provided strings in
  :class:`argparse.ArgumentParser`.

IDLE
----

- gh-112938: Fix uninteruptable hang when Shell gets rapid continuous
  output.

- gh-120104: Fix padding in config and search dialog windows in IDLE.

Documentation
-------------

- gh-124720: Update "Using Python on a Mac" section of the "Python Setup and
  Usage" document and include information on installing free-threading
  support.

- gh-116622: Add an Android platform guide, and flag modules not available
  on Android.

Core and Builtins
-----------------

- gh-124567: Revert the incremental GC (in 3.13), since it's not clear the
  benefits outweigh the costs at this point.

- gh-124642: Fixed scalability issue in free-threaded builds for lock-free
  reads from dictionaries in multi-threaded scenarios

- gh-116510: Fix a bug that can cause a crash when sub-interpreters use
  "basic" single-phase extension modules.  Shared objects could refer to
  PyGC_Head nodes that had been freed as part of interpreter cleanup.

- gh-124547: When deallocating an object with inline values whose
  ``__dict__`` is still live: if memory allocation for the inline values
  fails, clear the dictionary. Prevents an interpreter crash.

- gh-124513: Fix a crash in FrameLocalsProxy constructor: check the number
  of arguments. Patch by Victor Stinner.

- gh-124442: Fix nondeterminism in compilation by sorting the value of
  :attr:`~type.__static_attributes__`. Patch by kp2pml30.

- gh-123856: Fix PyREPL failure when a keyboard interrupt is triggered after
  using a history search

- gh-65961: Document the deprecation of setting and using ``__package__``
  and ``__cached__``.

- gh-124027: Support ``<page up>``, ``<page down>``, and ``<delete>`` keys
  in the Python REPL when ``$TERM`` is set to ``vt100``.

- gh-77894: Fix possible crash in the garbage collector when it tries to
  break a reference loop containing a :class:`memoryview` object. Now a
  :class:`!memoryview` object can only be cleared if there are no buffers
  that refer it.

- gh-123339: Setting the :attr:`!__module__` attribute for a class now
  removes the ``__firstlineno__`` item from the type's dict, so they will no
  longer be inconsistent.

C API
-----

- gh-124160: Fix crash when importing modules containing state and
  single-phase initialization in a subinterpreter.

- gh-123880: Fixed a bug that prevented circular imports of extension
  modules that use single-phase initialization.

Build
-----

- gh-124487: Windows builds now use Windows 8.1 as their API baseline
  (installation already required Windows 8.1).

- gh-124043: Building using :option:`--with-trace-refs` is (temporarily)
  disallowed when the GIL is disabled.


What's New in Python 3.13.0 release candidate 2?
================================================

*Release date: 2024-09-06*

macOS
-----

- gh-123418: Updated macOS installer build to use OpenSSL 3.0.15.

Windows
-------

- gh-123418: Updated Windows build to use OpenSSL 3.0.15.

- gh-122573: The Windows build of CPython now requires 3.10 or newer.

- gh-100256: :mod:`mimetypes` no longer fails when it encounters an
  inaccessible registry key.

- gh-79846: Makes :code:`ssl.create_default_context()` ignore invalid
  certificates in the Windows certificate store

Tools/Demos
-----------

- gh-123418: Update GitHub CI workflows to use OpenSSL 3.0.15 and
  multissltests to use 3.0.15, 3.1.7, and 3.2.3.

Tests
-----

- gh-119727: Add ``--single-process`` command line option to Python test
  runner (regrtest). Patch by Victor Stinner.

- gh-101525: Skip ``test_gdb`` if the binary is relocated by BOLT. Patch by
  Donghee Na.

Security
--------

- gh-123678: Upgrade libexpat to 2.6.3

- gh-121285: Remove backtracking from tarfile header parsing for
  ``hdrcharset``, PAX, and GNU sparse headers.

Library
-------

- gh-123657: Fix crash and memory leak in :func:`decimal.getcontext`. It
  crashed when using a thread-local context by
  ``--with-decimal-contextvar=no``.

- gh-123448: Fixed memory leak of :class:`typing.NoDefault` by moving it to
  the static types array.

- gh-123409: Fix :attr:`ipaddress.IPv6Address.reverse_pointer` output
  according to :rfc:`RFC 3596, §2.5 <3596#section-2.5>`.  Patch by Bénédikt
  Tran.

- gh-123270: Applied a more surgical fix for malformed payloads in
  :class:`zipfile.Path` causing infinite loops (gh-122905) without breaking
  contents using legitimate characters.

- gh-123228: Fix return type for
  :func:`!_pyrepl.readline._ReadlineWrapper.get_line_buffer` to be
  :func:`str`.  Patch by Sergey B Kirpichev.

- gh-123240: Raise audit events for the :func:`input` in the new REPL.

- gh-123243: Fix memory leak in :mod:`!_decimal`.

- gh-122546: Consistently use same file name for different exceptions in the
  new repl. Patch by Sergey B Kirpichev.

- gh-123213: :meth:`xml.etree.ElementTree.Element.extend` and
  :class:`~xml.etree.ElementTree.Element` assignment no longer hide the
  internal exception if an erronous generator is passed. Patch by Bar Harel.

- gh-85110: Preserve relative path in URL without netloc in
  :func:`urllib.parse.urlunsplit` and :func:`urllib.parse.urlunparse`.

- gh-123067: Fix quadratic complexity in parsing ``"``-quoted cookie values
  with backslashes by :mod:`http.cookies`.

- gh-122981: Fix :func:`inspect.getsource` for generated classes with Python
  base classes (e.g. enums).

- gh-122903: ``zipfile.Path.glob`` now correctly matches directories instead
  of silently omitting them.

- gh-122905: :class:`zipfile.Path` objects now sanitize names from the
  zipfile.

- gh-122695: Fixed double-free when using :func:`gc.get_referents` with a
  freed :class:`asyncio.Future` iterator.

- gh-116263: :class:`logging.handlers.RotatingFileHandler` no longer rolls
  over empty log files.

- gh-105376: Restore the deprecated :mod:`logging` ``warn()`` method. It was
  removed in Python 3.13 alpha 1. Keep the deprecated ``warn()`` method in
  Python 3.13. Patch by Victor Stinner.

- gh-122744: Bump the version of pip bundled in ensurepip to version 24.2.

- gh-118814: Fix the :class:`typing.TypeVar` constructor when name is passed
  by keyword.

- gh-122478: Remove internal frames from tracebacks shown in
  :class:`code.InteractiveInterpreter` with non-default
  :func:`sys.excepthook`. Save correct tracebacks in
  :attr:`sys.last_traceback` and update ``__traceback__`` attribute of
  :attr:`sys.last_value` and :attr:`sys.last_exc`.

- gh-116622: On Android, the ``FICLONE`` and ``FICLONERANGE`` constants are
  no longer exposed by :mod:`fcntl`, as these ioctls are blocked by SELinux.

- gh-82378: Make sure that the new :term:`REPL` interprets
  :data:`sys.tracebacklimit` in the same way that the classic REPL did.

- gh-122334: Fix crash when importing :mod:`ssl` after the main interpreter
  restarts.

- gh-87320: In :class:`code.InteractiveInterpreter`, handle exceptions
  caused by calling a non-default :func:`sys.excepthook`. Before, the
  exception bubbled up to the caller, ending the :term:`REPL`.

- gh-121650: :mod:`email` headers with embedded newlines are now quoted on
  output. The :mod:`~email.generator` will now refuse to serialize (write)
  headers that are unsafely folded or delimited; see
  :attr:`~email.policy.Policy.verify_generated_headers`. (Contributed by Bas
  Bloemsaat and Petr Viktorin in :gh:`121650`.)

- gh-121723: Make :func:`logging.config.dictConfig` accept any object
  implementing the Queue public API. See the :ref:`queue configuration
  <configure-queue>` section for details. Patch by Bénédikt Tran.

- gh-122081: Fix a crash in the :func:`!decimal.IEEEContext` optional
  function available via the ``EXTRA_FUNCTIONALITY`` configuration flag.

- gh-121804: Correctly show error locations, when :exc:`SyntaxError` raised
  in new repl. Patch by Sergey B Kirpichev.

- gh-121151: Fix wrapping of long usage text of arguments inside a mutually
  exclusive group in :mod:`argparse`.

- gh-108172: ``webbrowser`` honors OS preferred browser on Linux when its
  desktop entry name contains the text of a known browser name.

- gh-109109: You can now get the raw TLS certificate chains from TLS
  connections via :meth:`ssl.SSLSocket.get_verified_chain` and
  :meth:`ssl.SSLSocket.get_unverified_chain` methods.

  Contributed by Mateusz Nowak.

IDLE
----

- gh-120083: Add explicit black IDLE Hovertip foreground color needed for
  recent macOS. Fixes Sonoma showing unreadable white on pale yellow.  Patch
  by John Riggles.

Core and Builtins
-----------------

- gh-120221: asyncio REPL is now again properly recognizing
  KeyboardInterrupts. Display of exceptions raised in secondary threads is
  fixed.

- gh-119310: Allow the new interactive shell to read history files written
  with the editline library that use unicode-escaped entries.  Patch by
  aorcajo and Łukasz Langa.

- gh-123572: Fix key mappings for various F-keys in Windows for the new
  REPL. Patch by devdanzin

- gh-119034: Change ``<page up>`` and ``<page down>`` keys of the Python
  REPL to history search forward/backward. Patch by Victor Stinner.

- gh-123545: Fix a double decref in rare cases on experimental JIT builds.

- gh-123484: Fix ``_Py_DebugOffsets`` for long objects to be relative to the
  start of the object rather than the start of a subobject.

- gh-123344: Add AST optimizations for type parameter defaults.

- gh-123321: Prevent Parser/myreadline race condition from segfaulting on
  multi-threaded use. Patch by Bar Harel and Amit Wienner.

- gh-123177: Fix a bug causing stray prompts to appear in the middle of
  wrapped lines in the new REPL.

- gh-122982: Extend the deprecation period for bool inversion (``~``) by two
  years.

- gh-123275: Support :option:`-X gil=1 <-X>` and :envvar:`PYTHON_GIL=1
  <PYTHON_GIL>` on non-free-threaded builds.

- gh-123177: Deactivate line wrap in the Apple Terminal via a ANSI escape
  code. Patch by Pablo Galindo

- gh-123229: Fix valgrind warning by initializing the f-string buffers to 0
  in the tokenizer. Patch by Pablo Galindo

- gh-122298: Restore printout of GC stats when
  ``gc.set_debug(gc.DEBUG_STATS)`` is called. This featue was accidentally
  removed when implementing incremental GC.

- gh-121804: Correctly show error locations when a :exc:`SyntaxError` is
  raised in the basic REPL. Patch by Sergey B Kirpichev.

- gh-123142: Fix too-wide source location in exception tracebacks coming
  from broken iterables in comprehensions.

- gh-123048: Fix a bug where pattern matching code could emit a
  :opcode:`JUMP_FORWARD` with no source location.

- gh-123123: Fix displaying :exc:`SyntaxError` exceptions covering multiple
  lines. Patch by Pablo Galindo

- gh-123083: Fix a potential use-after-free in ``STORE_ATTR_WITH_HINT``.

- gh-123022: Fix crash in free-threaded build when calling
  :c:func:`Py_Initialize` from a non-main thread.

- gh-122888: Fix crash on certain calls to ``str()`` with positional
  arguments of the wrong type. Patch by Jelle Zijlstra.

- gh-116622: Fix Android stdout and stderr messages being truncated or lost.

- gh-122527: Fix a crash that occurred when a ``PyStructSequence`` was
  deallocated after its type's dictionary was cleared by the GC.  The type's
  :c:member:`~PyTypeObject.tp_basicsize` now accounts for non-sequence
  fields that aren't included in the :c:macro:`Py_SIZE` of the sequence.

- gh-122445: Add only fields which are modified via self.* to
  :attr:`~type.__static_attributes__`.

- gh-98442: Fix too wide source locations of the cleanup instructions of a
  with statement.

- gh-93691: Fix source locations of instructions generated for with
  statements.

- gh-120097: ``FrameLocalsProxy`` now subclasses ``collections.abc.Mapping``
  and can be matched as a mapping in ``match`` statements

C API
-----

- gh-122728: Fix :c:func:`PyEval_GetLocals` to avoid :exc:`SystemError`
  ("bad argument to internal function"). Patch by Victor Stinner.

Build
-----

- gh-123418: Updated Android build to use OpenSSL 3.0.15.

- gh-123297: Propagate the value of ``LDFLAGS`` to ``LDCXXSHARED`` in
  :mod:`sysconfig`. Patch by Pablo Galindo

- gh-116622: Rename build variable ``MODULE_LDFLAGS`` back to ``LIBPYTHON``,
  as it's used by package build systems (e.g. Meson).

- gh-118943: Fix an issue where the experimental JIT could be built several
  times by the ``make regen-all`` target, leading to possible race
  conditions on heavily parallelized builds.

- gh-118943: Fix a possible race condition affecting parallel builds
  configured with ``--enable-experimental-jit``, in which
  :exc:`FileNotFoundError` could be caused by another process already moving
  ``jit_stencils.h.new`` to ``jit_stencils.h``.


What's New in Python 3.13.0 release candidate 1?
================================================

*Release date: 2024-07-31*

Tests
-----

- gh-59022: Add tests for :func:`pkgutil.extend_path`. Patch by Andreas
  Stocker.

- gh-99242: :func:`os.getloadavg` may throw :exc:`OSError` when running
  regression tests under certain conditions (e.g. chroot). This error is now
  caught and ignored, since reporting load average is optional.

Security
--------

- gh-122133: Authenticate the socket connection for the
  ``socket.socketpair()`` fallback on platforms where ``AF_UNIX`` is not
  available like Windows.

  Patch by Gregory P. Smith <greg@krypto.org> and Seth Larson
  <seth@python.org>. Reported by Ellie <el@horse64.org>

- gh-121957: Fixed missing audit events around interactive use of Python,
  now also properly firing for ``python -i``, as well as for ``python -m
  asyncio``. The events in question are ``cpython.run_stdin`` and
  ``cpython.run_startup``.

Library
-------

- gh-122400: Handle :exc:`ValueError`\s raised by :func:`os.stat` in
  :class:`filecmp.dircmp` and :func:`filecmp.cmpfiles`. Patch by Bénédikt
  Tran.

- gh-122311: Fix some error messages in :mod:`pickle`.

- gh-122332: Fixed segfault with :meth:`asyncio.Task.get_coro` when using an
  eager task factory.

- gh-105733: :func:`ctypes.ARRAY` is now :term:`soft deprecated`: it no
  longer emits deprecation warnings and is not scheduled for removal.

- gh-122087: Restore :func:`inspect.ismethoddescriptor` and
  :func:`inspect.isroutine` returning ``False`` for
  :class:`functools.partial` objects.

- gh-122170: Handle :exc:`ValueError`\s raised by :func:`os.stat` in
  :mod:`linecache`. Patch by Bénédikt Tran.

- gh-82951: Serializing objects with complex ``__qualname__`` (such as
  unbound methods and nested classes) by name no longer involves serializing
  parent objects by value in pickle protocols < 4.

- gh-113785: :mod:`csv` now correctly parses numeric fields (when used with
  :const:`csv.QUOTE_NONNUMERIC` or :const:`csv.QUOTE_STRINGS`) which start
  with an escape character.

- gh-122088: :func:`@warnings.deprecated <warnings.deprecated>` now copies
  the coroutine status of functions and methods so that
  :func:`inspect.iscoroutinefunction` returns the correct result.

- gh-120930: Fixed a bug introduced by gh-92081 that added an incorrect
  extra blank to encoded words occurring in wrapped headers.

- gh-121474: Fix missing sanity check for ``parties`` arg in
  :class:`threading.Barrier` constructor. Patch by Clinton Christian
  (pygeek).

- gh-120289: Fixed the use-after-free issue in :mod:`cProfile` by
  disallowing ``disable()`` and ``clear()`` in external timers.

IDLE
----

- gh-122482: Change About IDLE to direct users to discuss.python.org instead
  of the now unused idle-dev email and mailing list.

Core and Builtins
-----------------

- gh-116090: Fix an issue in JIT builds that prevented some :keyword:`for`
  loops from correctly firing :monitoring-event:`RAISE` monitoring events.

- gh-122208: Dictionary watchers now only deliver the PyDict_EVENT_ADDED
  event when the insertion is in a known good state to succeed.

- gh-122300: Preserve AST nodes for f-string with single-element format
  specifiers. Patch by Pablo Galindo

- gh-120906: :attr:`frame.f_locals` now supports arbitrary hashable objects
  as keys.

- gh-122029: Emit ``c_call`` events in :func:`sys.setprofile` when a
  ``PyMethodObject`` pointing to a ``PyCFunction`` is called.

- gh-122026: Fix a bug that caused the tokenizer to not correctly identify
  mismatched parentheses inside f-strings in some situations. Patch by Pablo
  Galindo

- gh-118934: Make ``PyEval_GetLocals`` return borrowed reference

C API
-----

- gh-116622: Make :any:`PyObject_Print` work around a bug in Android and
  OpenBSD which prevented it from throwing an exception when trying to write
  to a read-only stream.

- gh-121489: Export private :c:func:`!_PyBytes_Join` again.

Build
-----

- gh-120522: Added a :option:`--with-app-store-compliance` option to patch
  out known issues with macOS/iOS App Store review processes.


What's New in Python 3.13.0 beta 4?
===================================

*Release date: 2024-07-18*

Tests
-----

- gh-121084: Fix test_typing random leaks. Clear typing ABC caches when
  running tests for refleaks (``-R`` option): call ``_abc_caches_clear()``
  on typing abstract classes and their subclasses. Patch by Victor Stinner.

- gh-121160: Add a test for :func:`readline.set_history_length`. Note that
  this test may fail on readline libraries.

- gh-121200: Fix ``test_expanduser_pwd2()`` of ``test_posixpath``.  Call
  ``getpwnam()`` to get ``pw_dir``, since it can be different than
  ``getpwall()`` ``pw_dir``. Patch by Victor Stinner.

- gh-121188: When creating the JUnit XML file, regrtest now escapes
  characters which are invalid in XML, such as the chr(27) control character
  used in ANSI escape sequences. Patch by Victor Stinner.

Library
-------

- gh-57141: The *shallow* argument to :class:`filecmp.dircmp` (new in Python
  3.13) is now keyword-only.

- gh-121245: Simplify handling of the history file in
  ``site.register_readline()`` helper. The ``CAN_USE_PYREPL`` variable now
  will be initialized, when imported.  Patch by Sergey B Kirpichev.

- gh-121332: Fix constructor of :mod:`ast` nodes with custom
  ``_attributes``. Previously, passing custom attributes would raise a
  :py:exc:`DeprecationWarning`. Passing arguments to the constructor that
  are not in ``_fields`` or ``_attributes`` remains deprecated. Patch by
  Jelle Zijlstra.

- gh-121279: Avoid :exc:`NameError` for the :mod:`warnings` module when
  accessing the depracated atributes of the :mod:`importlib.abc` module.

- gh-121245: Fix a bug in the handling of the command history of the new
  :term:`REPL` that caused the history file to be wiped at REPL exit.

- gh-87744: Fix waitpid race while calling
  :meth:`~asyncio.subprocess.Process.send_signal` in asyncio. Patch by Kumar
  Aditya.

- gh-121018: Fixed other issues where :class:`argparse.ArgumentParser` did
  not honor ``exit_on_error=False``.

- gh-120678: Fix regression in the new REPL that meant that globals from
  files passed using the ``-i`` argument would not be included in the REPL's
  global namespace. Patch by Alex Waygood.

- gh-120782: Fix wrong references of the :mod:`datetime` types after
  reloading the module.

- gh-120713: :meth:`datetime.datetime.strftime` now 0-pads years with less
  than four digits for the format specifiers ``%Y`` and ``%G`` on Linux.
  Patch by Ben Hsing

- gh-117983: Defer the ``threading`` import in ``importlib.util`` until lazy
  loading is used.

- gh-119189: When using the ``**`` operator or :func:`pow` with
  :class:`~fractions.Fraction` as the base and an exponent that is not
  rational, a float, or a complex, the fraction is no longer converted to a
  float.

- gh-118714: Allow ``restart`` in post-mortem debugging of :mod:`pdb`.
  Removed restart message when the user quits pdb from post-mortem mode.

- gh-105623: Fix performance degradation in
  :class:`logging.handlers.RotatingFileHandler`. Patch by Craig Robson.

IDLE
----

- gh-78889: Stop Shell freezes by blocking user access to non-method
  sys.stdout.shell attributes, which are all private.

Documentation
-------------

- gh-121749: Fix documentation for :c:func:`PyModule_AddObjectRef`.

- gh-120012: Clarify the behaviours of :meth:`multiprocessing.Queue.empty`
  and :meth:`multiprocessing.SimpleQueue.empty` on closed queues. Patch by
  Bénédikt Tran.

Core and Builtins
-----------------

- gh-121860: Fix crash when rematerializing a managed dictionary after it
  was deleted.

- gh-121814: Fixed the SegFault when :c:func:`PyEval_SetTrace` is used with
  no Python frame on stack.

- gh-121295: Fix PyREPL console getting into a blocked state after
  interrupting a long paste

- gh-121794: Fix bug in free-threaded Python where a resurrected object
  could lead to a negative ref count assertion failure.

- gh-121657: Improve the :exc:`SyntaxError` message if the user tries to use
  :keyword:`yield from <yield>` outside a function.

- gh-121609: Fix pasting of characters containing unicode character joiners
  in the new REPL. Patch by Marta Gomez Macias

- gh-117482: Unexpected slot wrappers are no longer created for builtin
  static types in subinterpreters.

- gh-121499: Fix a bug affecting how multi-line history was being rendered
  in the new REPL after interacting with the new screen cache. Patch by
  Pablo Galindo

- gh-121497: Fix a bug that was preventing the REPL to correctly respect the
  history when an input hook was set. Patch by Pablo Galindo

- gh-121012: Tier 2 execution now ensures that list iterators remain
  exhausted, once they become exhausted.

- gh-121439: Allow tuples of length 20 in the freelist to be reused.

- gh-121368: Fix race condition in ``_PyType_Lookup`` in the free-threaded
  build due to a missing memory fence.  This could lead to
  ``_PyType_Lookup`` returning incorrect results on arm64.

- gh-121130: Fix f-strings with debug expressions in format specifiers.
  Patch by Pablo Galindo

- gh-121115: :c:func:`PyLong_AsNativeBytes` no longer uses
  :meth:`~object.__index__` methods by default. The
  ``Py_ASNATIVEBYTES_ALLOW_INDEX`` flag has been added to allow it.

C API
-----

- gh-89364: Export the :c:func:`PySignal_SetWakeupFd` function. Previously,
  the function was documented but it couldn't be used in 3rd party code.
  Patch by Victor Stinner.

- gh-113993: :c:func:`PyUnicode_InternInPlace` no longer prevents its
  argument from being garbage collected.

  Several functions that take ``char *`` are now documented as possibly
  preventing string objects from being garbage collected; refer to their
  documentation for details: :c:func:`PyUnicode_InternFromString`,
  :c:func:`PyDict_SetItemString`, :c:func:`PyObject_SetAttrString`,
  :c:func:`PyObject_DelAttrString`, :c:func:`PyUnicode_InternFromString`,
  and ``PyModule_Add*`` convenience functions.

- gh-113601: Removed debug build assertions related to interning strings,
  which were falsely triggered by stable ABI extensions.

- gh-112136: Restore the private ``_PyArg_Parser`` structure and the private
  ``_PyArg_ParseTupleAndKeywordsFast()`` function, previously removed in
  Python 3.13 alpha 1. Patch by Victor Stinner.

Build
-----

- gh-120371: Support WASI SDK 22 by explicitly skipping functions that are
  just stubs in wasi-libc.

- gh-121731: Fix mimalloc compile error on GNU/Hurd

- gh-121487: Fix deprecation warning for ATOMIC_VAR_INIT in mimalloc.

- gh-121467: Fix a Makefile bug that prevented mimalloc header files from
  being installed.

- gh-121103: On POSIX systems, excluding macOS framework installs, the lib
  directory for the free-threaded build now includes a "t" suffix to avoid
  conflicts with a co-located default build installation.

- gh-120831: The default minimum iOS version was increased to 13.0.

- gh-113565: Improve :mod:`curses` and :mod:`curses.panel` dependency checks
  in :program:`configure`.


What's New in Python 3.13.0 beta 3?
===================================

*Release date: 2024-06-27*

Core and Builtins
-----------------

- gh-120838: :c:func:`Py_Finalize()` and :c:func:`Py_FinalizeEx()` now
  always run with the main interpreter active.

- gh-113433: Subinterpreters now get cleaned up automatically during runtime
  finalization.

- gh-119462: Make sure that invariants of type versioning are maintained: *
  Superclasses always have their version number assigned before subclasses *
  The version tag is always zero if the tag is not valid. * The version tag
  is always non-zero if the tag is valid.

- gh-120437: Fix ``_CHECK_STACK_SPACE`` optimization problems introduced in
  :gh:`118322`.

- gh-120722: Correctly set the bytecode position on return instructions
  within lambdas. Patch by Jelle Zijlstra.

- gh-120367: Fix bug where compiler creates a redundant jump during
  pseudo-op replacement. Can only happen with a synthetic AST that has a try
  on the same line as the instruction following the exception handler.

- gh-113993: Strings interned with :func:`sys.intern` are again
  garbage-collected when no longer used, as per the documentation. Strings
  interned with the C function :c:func:`PyUnicode_InternInPlace` are still
  immortal. Internals of the string interning mechanism have been changed.
  This may affect performance and identities of :class:`str` objects.

- gh-120384: Fix an array out of bounds crash in ``list_ass_subscript``,
  which could be invoked via some specificly tailored input: including
  concurrent modification of a list object, where one thread assigns a slice
  and another clears it.

- gh-120367: Fix crash in compiler on code with redundant NOPs and JUMPs
  which show up after exception handlers are moved to the end of the code.

- gh-120380: Fix Python implementation of :class:`pickle.Pickler` for
  :class:`bytes` and :class:`bytearray` objects when using protocol version
  5. Patch by Bénédikt Tran.

- gh-120400: Support Linux perf profiler to see Python calls on RISC-V
  architecture.

- gh-120221: Deliver real signals on Ctrl-C and Ctrl-Z in the new REPL.
  Patch by Pablo Galindo

- gh-120346: Respect :envvar:`PYTHON_BASIC_REPL` when running in interative
  inspect mode (``python -i``). Patch by Pablo Galindo

- gh-93691: Fix source locations of instructions generated for the iterator
  of a for statement.

- gh-120198: Fix a crash when multiple threads read and write to the same
  ``__class__`` of an object concurrently.

- gh-120298: Fix use-after free in ``list_richcompare_impl`` which can be
  invoked via some specificly tailored evil input.

- gh-119666: Fix a compiler crash in the case where two comprehensions in
  class scope both reference ``__class__``.

- gh-120225: Fix crash in compiler on empty block at end of exception
  handler.

- gh-119933: Improve :exc:`SyntaxError` messages for invalid expressions in
  a type parameters bound, a type parameter constraint tuple or a default
  type parameter. Patch by Bénédikt Tran.

- bpo-24766: Fix handling of ``doc`` argument to subclasses of ``property``.

Library
-------

- gh-121027: Add a future warning in :meth:`!functools.partial.__get__`. In
  future Python versions :class:`functools.partial` will be a method
  descriptor.

- gh-121025: Improve the :meth:`~object.__repr__` of
  :class:`functools.partialmethod`. Patch by Bénédikt Tran.

- gh-121018: Fixed an issue where
  :meth:`!argparse.ArgumentParser.parses_args` did not honor
  ``exit_on_error=False`` when given unrecognized arguments. Patch by Ben
  Hsing.

- gh-119614: Fix truncation of strings with embedded null characters in some
  internal operations in :mod:`tkinter`.

- gh-120910: When reading installed files from an egg, use
  ``relative_to(walk_up=True)`` to honor files installed outside of the
  installation root.

- gh-120888: Upgrade pip wheel bundled with ensurepip (pip 24.1.1)

- gh-101830: Accessing the :mod:`tkinter` object's string representation no
  longer converts the underlying Tcl object to a string on Windows.

- gh-120811: Fix possible memory leak in :meth:`contextvars.Context.run`.

- gh-120769: Make empty line in :mod:`pdb` repeats the last command even
  when the command is from ``cmdqueue``.

- gh-120732: Fix ``name`` passing to :class:`unittest.mock.Mock` object when
  using :func:`unittest.mock.create_autospec`.

- gh-120683: Fix an error in :class:`logging.LogRecord`, when the integer
  part of the timestamp is rounded up, while the millisecond calculation
  truncates, causing the log timestamp to be wrong by up to 999 ms (affected
  roughly 1 in 8 million timestamps).

- gh-120633: Move scrollbar and remove tear-off menus in turtledemo.

- gh-120541: Improve the prompt in the "less" pager when :func:`help` is
  called with non-string argument.

- gh-120495: Fix incorrect exception handling in Tab Nanny. Patch by
  Wulian233.

- gh-120381: Correct :func:`inspect.ismethoddescriptor` to check also for
  the lack of :meth:`~object.__delete__`.  Patch by Jan Kaliszewski.

- gh-90425: The OS byte in gzip headers is now always set to 255 when using
  :func:`gzip.compress`.

- gh-120343: Fix column offset reporting for tokens that come after
  multiline f-strings in the :mod:`tokenize` module.

- gh-119600: Fix :func:`unittest.mock.patch` to not read attributes of the
  target when ``new_callable`` is set. Patch by Robert Collins.

- gh-114053: Fix edge-case bug where :func:`typing.get_type_hints` would
  produce incorrect results if type parameters in a class scope were
  overridden by assignments in a class scope and ``from __future__ import
  annotations`` semantics were enabled. Patch by Alex Waygood.

- gh-114053: Fix erroneous :exc:`NameError` when calling
  :func:`inspect.get_annotations` with ``eval_str=True``` on a class that
  made use of :pep:`695` type parameters in a module that had ``from
  __future__ import annotations`` at the top of the file. Patch by Alex
  Waygood.

- gh-120268: Prohibit passing ``None`` to pure-Python
  :meth:`datetime.date.fromtimestamp` to achieve consistency with
  C-extension implementation.

- gh-120244: Fix memory leak in :func:`re.sub` when the replacement string
  contains backreferences.

- gh-120211: Fix :mod:`tkinter.ttk` with Tcl/Tk 9.0.

- gh-71587: Fix crash in C version of :meth:`datetime.datetime.strptime`
  when called again on the restarted interpreter.

- gh-120161: :mod:`datetime` no longer crashes in certain complex reference
  cycle situations.

- gh-119698: Fix :meth:`symtable.Class.get_methods` and document its
  behaviour. Patch by Bénédikt Tran.

- gh-120121: Add :exc:`concurrent.futures.InvalidStateError` to module's
  ``__all__``.

- gh-119933: Add the :class:`symtable.SymbolTableType` enumeration to
  represent the possible outputs of the
  :class:`symtable.SymbolTable.get_type` method. Patch by Bénédikt Tran.

- gh-120108: Fix calling :func:`copy.deepcopy` on :mod:`ast` trees that have
  been modified to have references to parent nodes. Patch by Jelle Zijlstra.

- gh-112672: Support building :mod:`tkinter` with Tcl 9.0.

- gh-65454: :func:`unittest.mock.Mock.attach_mock` no longer triggers a call
  to a ``PropertyMock`` being attached.

- gh-81936: :meth:`!help` and :meth:`!showtopic` methods now respect a
  configured *output* argument to :class:`!pydoc.Helper` and not use the
  pager in such cases. Patch by Enrico Tröger.

- gh-119577: The :exc:`DeprecationWarning` emitted when testing the truth
  value of an :class:`xml.etree.ElementTree.Element` now describes
  unconditionally returning ``True`` in a future version rather than raising
  an exception in Python 3.14.

- gh-118908: Limit exposed globals from internal imports and definitions on
  new REPL startup. Patch by Eugene Triguba and Pablo Galindo.

- gh-119506: Fix :meth:`!io.TextIOWrapper.write` method breaks internal
  buffer when the method is called again during flushing internal buffer.

Build
-----

- gh-120671: Fix failing configure tests due to a missing space when
  appending to CFLAGS.

- gh-120602: Correctly handle LLVM installs with ``LLVM_VERSION_SUFFIX``
  when building with ``--enable-experimental-jit``.

- gh-120326: On Windows, fix build error when ``--disable-gil`` and
  ``--experimental-jit`` options are combined.

- gh-120291: Make the ``python-config`` shell script compatible with
  non-bash shells.

C API
-----

- gh-120642: Remove the private ``_Py_CODEUNIT`` type from the public C API.
  The internal ``pycore_code.h`` header should now be used to get this
  internal type. Patch by Victor Stinner.

- gh-120858: :c:func:`PyDict_Next` no longer locks the dictionary in the
  free-threaded build.  The locking needs to be done by the caller around
  the entire iteration loop.

- gh-120642: Remove the following unstable functions:

  * ``PyUnstable_Replace_Executor()``
  * ``PyUnstable_SetOptimizer()``
  * ``PyUnstable_GetOptimizer()``
  * ``PyUnstable_GetExecutor()``
  * ``PyUnstable_Optimizer_NewCounter()``
  * ``PyUnstable_Optimizer_NewUOpOptimizer()``

  Patch by Victor Stinner.

- gh-119344: The critical section API is now public as part of the
  non-limited C API.

- gh-118789: Add :c:func:`PyUnstable_Object_ClearWeakRefsNoCallbacks`, which
  clears weakrefs without calling their callbacks.

- gh-117511: Make the :c:type:`PyMutex` public in the non-limited C API.


What's New in Python 3.13.0 beta 2?
===================================

*Release date: 2024-06-05*

Security
--------

- gh-118773: Fixes creation of ACLs in :func:`os.mkdir` on Windows to work
  correctly on non-English machines.

- gh-118486: :func:`os.mkdir` on Windows now accepts *mode* of ``0o700`` to
  restrict the new directory to the current user. This fixes
  :cve:`2024-4030` affecting :func:`tempfile.mkdtemp` in scenarios where the
  base temporary directory is more permissive than the default.

Core and Builtins
-----------------

- gh-119724: Reverted improvements to error messages for ``elif``/``else``
  statements not matching any valid statements, which made in hard to locate
  the syntax errors inside those ``elif``/``else`` blocks.

- gh-119842: Honor :c:func:`PyOS_InputHook` in the new REPL. Patch by Pablo
  Galindo

- gh-119821: Fix execution of :ref:`annotation scopes <annotation-scopes>`
  within classes when ``globals`` is set to a non-dict. Patch by Jelle
  Zijlstra.

- gh-119548: Add a ``clear`` command to the REPL. Patch by Pablo Galindo

- gh-111999: Fix the signature of :meth:`str.format_map`.

- gh-119560: An invalid assert in beta 1 has been removed.  The assert would
  fail if ``PyState_FindModule()`` was used in an extension module's init
  function before the module def had been initialized.

- gh-119369: Fix deadlock during thread deletion in free-threaded build,
  which could occur when the GIL was enabled at runtime.

- gh-119525: Fix deadlock involving ``_PyType_Lookup()`` cache in the
  free-threaded build when the GIL is dynamically enabled at runtime.

- gh-119311: Fix bug where names are unexpectedly mangled in the bases of
  generic classes.

- gh-119395: Fix bug where names appearing after a generic class are mangled
  as if they are in the generic class.

- gh-119213: Non-builtin modules built with argument clinic were crashing if
  used in a subinterpreter before the main interpreter.  The objects that
  were causing the problem by leaking between interpreters carelessly have
  been fixed.

- gh-119011: Fixes ``type.__type_params__`` to return an empty tuple instead
  of a descriptor.

- gh-118692: Avoid creating unnecessary :exc:`StopIteration` instances for
  monitoring.

- gh-119049: Fix displaying the source line for warnings created by the C
  API if the :mod:`warnings` module had not yet been imported.

- gh-118844: Fix build failures when configuring with both ``--disable-gil``
  and ``--enable-experimental-jit``.

- gh-118921: Add ``copy()`` method for ``FrameLocalsProxy`` which returns a
  snapshot ``dict`` for local variables.

- gh-117657: Fix data races on the field that stores a pointer to the
  interpreter's main thread that occur in free-threaded builds.

- gh-118561: Fix race condition in free-threaded build where
  :meth:`!list.extend` could expose uninitialised memory to concurrent
  readers.

- gh-117195: Avoid assertion failure for debug builds when calling
  ``object.__sizeof__(1)``

Library
-------

- gh-119819: Fix regression to allow logging configuration with
  multiprocessing queue types.

- gh-117142: The :mod:`ctypes` module may now be imported in all
  subinterpreters, including those that have their own GIL.

- gh-118835: Fix _pyrepl crash when using custom prompt with ANSI escape
  codes.

- gh-117398: The ``_datetime`` module (C implementation for :mod:`datetime`)
  now supports being imported in multiple interpreters.

- gh-89727: Fix issue with :func:`shutil.rmtree` where a
  :exc:`RecursionError` is raised on deep directory trees.

- gh-89727: Partially fix issue with :func:`shutil.rmtree` where a
  :exc:`RecursionError` is raised on deep directory trees. A recursion error
  is no longer raised when :data:`!rmtree.avoids_symlink_attacks` is false.

- gh-119118: Fix performance regression in the :mod:`tokenize` module by
  caching the ``line`` token attribute and calculating the column offset
  more efficiently.

- gh-89727: Fix issue with :func:`os.fwalk` where a :exc:`RecursionError`
  was raised on deep directory trees by adjusting the implementation to be
  iterative instead of recursive.

- gh-119588: ``zipfile.Path.is_symlink`` now assesses if the given path is a
  symlink.

- gh-119555: Catch :exc:`SyntaxError` from :func:`compile` in the
  runsource() method of the InteractiveColoredConsole.  Patch by Sergey B
  Kirpichev.

- gh-113892: Now, the method ``sock_connect`` of
  :class:`asyncio.ProactorEventLoop` raises a :exc:`ValueError` if given
  socket is not in non-blocking mode, as well as in other loop
  implementations.

- gh-119443: The interactive REPL no longer runs with ``from __future__
  import annotations`` enabled. Patch by Jelle Zijlstra.

- gh-117398: Objects in the datetime C-API are now all statically allocated,
  which means better memory safety, especially when the module is reloaded.
  This should be transparent to users.

- gh-118894: :mod:`asyncio` REPL now has the same capabilities as PyREPL.

- gh-118911: In PyREPL, updated ``maybe-accept``'s logic so that if the user
  hits :kbd:`Enter` twice, they are able to terminate the block even if
  there's trailing whitespace. Also, now when the user hits arrow up, the
  cursor is on the last functional line. This matches IPython's behavior.
  Patch by Aya Elsayed.

- gh-111201: Remove dependency to :mod:`readline` from the new Python REPL.

- gh-119174: Fix high DPI causes turtledemo(turtle-graphics examples)
  windows blurry Patch by Wulian233 and Terry Jan Reedy

- gh-119121: Fix a NameError happening in
  ``asyncio.staggered.staggered_race``. This function is now tested.

- gh-119113: Fix issue where :meth:`pathlib.PurePath.with_suffix` didn't
  raise :exc:`TypeError` when given ``None`` as a suffix.

- gh-118643: Fix an AttributeError in the :mod:`email` module when re-fold a
  long address list. Also fix more cases of incorrect encoding of the
  address separator in the address list.

- gh-58933: Make :mod:`pdb` return to caller frame correctly when
  ``f_trace`` of the caller frame is not set

- gh-118895: Setting attributes on :data:`typing.NoDefault` now raises
  :exc:`AttributeError` instead of :exc:`TypeError`.

- gh-118868: Fixed issue where kwargs were no longer passed to the logging
  handler QueueHandler

- gh-118851: ``ctx`` arguments to the constructors of :mod:`ast` node
  classes now default to :class:`ast.Load() <ast.Load>`. Patch by Jelle
  Zijlstra.

- gh-118760: Restore the default value of ``tkiter.wantobjects`` to ``1``.

- gh-118760: Fix errors in calling Tkinter bindings on Windows.

- gh-118507: Fix :func:`os.path.isfile` on Windows for pipes. Speedup
  :func:`os.path.isjunction` and :func:`os.path.lexists` on Windows with a
  native implementation.

- gh-118772: Allow :class:`typing.TypeVar` instances without a default to
  follow instances without a default in some cases. Patch by Jelle Zijlstra.

- gh-110863: :func:`os.path.realpath` now suppresses any :exc:`OSError` from
  :func:`os.readlink` when *strict* mode is disabled (the default).

- gh-118263: Speed up :func:`os.path.splitroot` & :func:`os.path.normpath`
  with a direct C call.

- gh-118033: Fix :func:`dataclasses.dataclass` not creating a
  ``__weakref__`` slot when subclassing :class:`typing.Generic`.

- gh-106531: In :mod:`importlib.resources`, sync with `importlib_resources
  6.3.2
  <https://importlib-resources.readthedocs.io/en/latest/history.html#v6-3-2>`_,
  including: ``MultiplexedPath`` now expects ``Traversable`` paths,
  deprecating string arguments to ``MultiplexedPath``; Enabled support for
  resources in namespace packages in zip files; Fixed ``NotADirectoryError``
  when calling files on a subdirectory of a namespace package.

- gh-113978: Ignore warnings on text completion inside REPL.

- gh-103956: Fix lack of newline characters in :mod:`trace` module output
  when line tracing is enabled but source code line for current frame is not
  available.

- gh-92081: Fix missing spaces in email headers when the spaces are mixed
  with encoded 8-bit characters.

- gh-103194: Prepare Tkinter for C API changes in Tcl 8.7/9.0 to avoid
  :class:`!_tkinter.Tcl_Obj` being unexpectedly returned instead of
  :class:`bool`, :class:`str`, :class:`bytearray`, or :class:`int`.

- gh-87106: Fixed handling in :meth:`inspect.Signature.bind` of keyword
  arguments having the same name as positional-only arguments when a
  variadic keyword argument (e.g. ``**kwargs``) is present.

- bpo-45767: Fix integer conversion in :func:`os.major`, :func:`os.minor`,
  and :func:`os.makedev`. Support device numbers larger than ``2**63-1``.
  Support non-existent device number (``NODEV``).

- gh-67693: Fix :func:`urllib.parse.urlunparse` and
  :func:`urllib.parse.urlunsplit` for URIs with path starting with multiple
  slashes and no authority. Based on patch by Ashwin Ramaswami.

Tests
-----

- gh-119050: regrtest test runner: Add XML support to the refleak checker
  (-R option). Patch by Victor Stinner.

Build
-----

- gh-119729: On POSIX systems, the pkg-config (``.pc``) filenames now
  include the ABI flags, which may include debug ("d") and free-threaded
  ("t").  For example: * ``python-3.14.pc`` (default, non-debug build) *
  ``python-3.14d.pc`` (default, debug build) * ``python-3.14t.pc``
  (free-threaded build)

- gh-115119: Fall back to the bundled libmpdec if a system version cannot be
  found.

- gh-119132: Update :data:`sys.version` to identify whether the build is
  default build or free-threading build. Patch By Donghee Na.

- gh-118836: Fix an ``AssertionError`` when building with
  ``--enable-experimental-jit`` and the compiler emits a ``SHT_NOTE``
  section.

- gh-118943: Fix a possible race condition affecting parallel builds
  configured with ``--enable-experimental-jit``, in which compilation errors
  could be caused by an incompletely-generated header file.

Windows
-------

- gh-119679: Ensures correct import libraries are included in Windows
  installs.

- gh-119690: Adds Unicode support and fixes audit events for
  ``_winapi.CreateNamedPipe``.

- gh-111201: Add support for new pyrepl on Windows

- gh-119070: Fixes ``py.exe`` handling of shebangs like ``/usr/bin/env
  python3.12``, which were previously interpreted as ``python3.exe`` instead
  of ``python3.12.exe``.

- gh-117505: Fixes an issue with the Windows installer not running ensurepip
  in a fully isolated environment. This could cause unexpected interactions
  with the user site-packages.

- gh-118209: Avoid crashing in :mod:`mmap` on Windows when the mapped memory
  is inaccessible due to file system errors or access violations.

- gh-116145: Updated bundled Tcl/Tk to 8.6.14.

C API
-----

- gh-119585: Fix crash when a thread state that was created by
  :c:func:`PyGILState_Ensure` calls a destructor that during
  :c:func:`PyThreadState_Clear` that calls back into
  :c:func:`PyGILState_Ensure` and :c:func:`PyGILState_Release`. This might
  occur when in the free-threaded build or when using thread-local variables
  whose destructors call :c:func:`PyGILState_Ensure`.

- gh-119336: Restore the removed ``_PyLong_NumBits()`` function. It is used
  by the pywin32 project. Patch by Ethan Smith

- gh-119247: Added ``Py_BEGIN_CRITICAL_SECTION_SEQUENCE_FAST`` and
  ``Py_END_CRITICAL_SECTION_SEQUENCE_FAST`` macros to make it possible to
  use PySequence_Fast APIs safely when free-threaded, and update str.join to
  work without the GIL using them.

- gh-111389: Add :c:macro:`PyHASH_MULTIPLIER` constant: prime multiplier
  used in string and various other hashes. Patch by Victor Stinner.

- gh-116984: Make mimalloc includes relative to the current file to avoid
  embedders or extensions needing to include ``Internal/mimalloc`` if they
  are already including internal CPython headers.

- gh-118789: Restore ``_PyWeakref_ClearRef`` that was previously removed in
  Python 3.13 alpha 1.


What's New in Python 3.13.0 beta 1?
===================================

*Release date: 2024-05-08*

Security
--------

- gh-116741: Update bundled libexpat to 2.6.2

- gh-117233: Detect BLAKE2, SHA3, Shake, & truncated SHA512 support in the
  OpenSSL-ish libcrypto library at build time.  This allows :mod:`hashlib`
  to be used with libraries that do not to support every algorithm that
  upstream OpenSSL does.

Core and Builtins
-----------------

- gh-118414: Add instrumented opcodes to YIELD_VALUE assertion for tracing
  cases.

- gh-117953: When a builtin or extension module is imported for the first
  time, while a subinterpreter is active, the module's init function is now
  run by the main interpreter first before import continues in the
  subinterpreter. Consequently, single-phase init modules now fail in an
  isolated subinterpreter without the init function running under that
  interpreter, whereas before it would run under the subinterpreter *before*
  failing, potentially leaving behind global state and callbacks and
  otherwise leaving the module in an inconsistent state.

- gh-117549: Don't use designated initializer syntax in inline functions in
  internal headers. They cause problems for C++ or MSVC users who aren't yet
  using the latest C++ standard (C++20). While internal, pycore_backoff.h,
  is included (indirectly, via pycore_code.h) by some key 3rd party software
  that does so for speed.

- gh-95382: Improve performance of :func:`json.dumps` and :func:`json.dump`
  when using the argument *indent*. Depending on the data the encoding using
  :func:`json.dumps` with *indent* can be up to 2 to 3 times faster.

- gh-116322: In ``--disable-gil`` builds, the GIL will be enabled while
  loading C extension modules. If the module indicates that it supports
  running without the GIL, the GIL will be disabled once loading is
  complete. Otherwise, the GIL will remain enabled for the remainder of the
  interpreter's lifetime. This behavior does not apply if the GIL has been
  explicitly enabled or disabled with ``PYTHON_GIL`` or ``-Xgil``.

- gh-118513: Fix incorrect :exc:`UnboundLocalError` when two comprehensions
  in the same function both reference the same name, and in one
  comprehension the name is bound while in the other it's an implicit
  global.

- gh-118518: Allow the Linux perf support to work without frame pointers
  using perf's advanced JIT support. The feature is activated when using the
  ``PYTHON_PERF_JIT_SUPPORT`` environment variable or when running Python
  with ``-Xperf_jit``. Patch by Pablo Galindo.

- gh-117514: Add ``sys._is_gil_enabled()`` function that returns whether the
  GIL is currently enabled.  In the default build it always returns ``True``
  because the GIL is always enabled.  In the free-threaded build, it may
  return ``True`` or ``False``.

- gh-118164: Break a loop between the Python implementation of the
  :mod:`decimal` module and the Python code for integer to string
  conversion. Also optimize integer to string conversion for values in the
  range from 9_000 to 135_000 decimal digits.

- gh-118473: Fix :func:`sys.set_asyncgen_hooks` not to be partially set when
  raising :exc:`TypeError`.

- gh-118465: Compiler populates the new ``__firstlineno__`` field on a class
  with the line number of the first line of the class definition.

- gh-118492: Fix an issue where the type cache can expose a previously
  accessed attribute when a finalizer is run.

- gh-117714: update ``async_generator.athrow().close()`` and
  ``async_generator.asend().close()`` to close their section of the
  underlying async generator

- gh-111201: The :term:`interactive` interpreter is now implemented in
  Python, which allows for a number of new features like colors, multiline
  input, history viewing, and paste mode. Contributed by Pablo Galindo,
  Łukasz Langa and Lysandros Nikolaou based on code from the PyPy project.

- gh-74929: Implement PEP 667: converted :attr:`FrameType.f_locals
  <frame.f_locals>` and :c:func:`PyFrame_GetLocals` to return a
  write-through proxy object when the frame refers to a function or
  comprehension.

- gh-116767: Fix crash in compiler on 'async with' that has many context
  managers.

- gh-118335: Change how to use the tier 2 interpreter. Instead of running
  Python with ``-X uops`` or setting the environment variable
  ``PYTHON_UOPS=1``, this choice is now made at build time by configuring
  with ``--enable-experimental-jit=interpreter``.

  **Beware!** This changes the environment variable to enable or disable
  micro-ops to ``PYTHON_JIT``. The old ``PYTHON_UOPS`` is no longer used.

- gh-118306: Update JIT compilation to use LLVM 18

- gh-118160: :ref:`Annotation scopes <annotation-scopes>` within classes can
  now contain comprehensions. However, such comprehensions are not inlined
  into their parent scope at runtime. Patch by Jelle Zijlstra.

- gh-118272: Fix bug where ``generator.close`` does not free the generator
  frame's locals.

- gh-118216: Don't consider :mod:`__future__` imports with dots before the
  module name.

- gh-118074: Make sure that the Executor objects in the COLD_EXITS array
  aren't assumed to be GC-able (which would access bytes outside the
  object).

- gh-107674: Lazy load frame line number to improve performance of tracing

- gh-118082: Improve :exc:`SyntaxError` message for imports without names,
  like in ``from x import`` and ``import`` cases. It now points out to users
  that :keyword:`import` expects at least one name after it.

- gh-118090: Improve :exc:`SyntaxError` message for empty type param
  brackets.

- gh-117958: Added a ``get_jit_code()`` method to access JIT compiled
  machine code from the UOp Executor when the experimental JIT is enabled.
  Patch by Anthony Shaw.

- gh-117901: Add option for compiler's codegen to save nested instruction
  sequences for introspection.

- gh-116622: Redirect stdout and stderr to system log when embedded in an
  Android app.

- gh-109118: :ref:`annotation scope <annotation-scopes>` within class scopes
  can now contain lambdas.

- gh-117894: Prevent ``agen.aclose()`` objects being re-used after
  ``.throw()``.

- gh-117881: prevent concurrent access to an async generator via
  athrow().throw() or asend().throw()

- gh-117536: Fix a :exc:`RuntimeWarning` when calling
  ``agen.aclose().throw(Exception)``.

- gh-117755: Fix mimalloc allocator for huge memory allocation (around
  8,589,934,592 GiB) on s390x. Patch by Victor Stinner.

- gh-117750: Fix issue where an object's dict would get out of sync with the
  object's internal values when being cleared. ``obj.__dict__.clear()`` now
  clears the internal values, but leaves the dict attached to the object.

- gh-117431: Improve the performance of the following :class:`bytes` and
  :class:`bytearray` methods by adapting them to the
  :c:macro:`METH_FASTCALL` calling convention:

  * :meth:`!count`
  * :meth:`!find`
  * :meth:`!index`
  * :meth:`!rfind`
  * :meth:`!rindex`

- gh-117709: Speed up calls to :func:`str` with positional-only argument, by
  using the :pep:`590` ``vectorcall`` calling convention. Patch by Erlend
  Aasland.

- gh-117680: Give ``_PyInstructionSequence`` a Python interface and use it
  in tests.

- gh-115776: Statically allocated objects are, by definition, immortal so
  must be marked as such regardless of whether they are in extension modules
  or not.

- gh-117385: Remove unhandled ``PY_MONITORING_EVENT_BRANCH`` and
  ``PY_MONITORING_EVENT_EXCEPTION_HANDLED`` events from
  :func:`sys.settrace`.

- gh-116322: Extension modules may indicate to the runtime that they can run
  without the GIL. Multi-phase init modules do so by calling providing
  ``Py_MOD_GIL_NOT_USED`` for the ``Py_mod_gil`` slot, while single-phase
  init modules call ``PyUnstable_Module_SetGIL(mod, Py_MOD_GIL_NOT_USED)``
  from their init function.

- gh-116129: Implement :pep:`696`, adding support for defaults on type
  parameters. Patch by Jelle Zijlstra.

- gh-93502: Add two new functions to the C-API,
  :c:func:`PyRefTracer_SetTracer` and :c:func:`PyRefTracer_GetTracer`, that
  allows to track object creation and destruction the same way the
  :mod:`tracemalloc` module does. Patch by Pablo Galindo

- gh-107674: Improved the performance of :func:`sys.settrace` significantly

- gh-95754: Improve the error message when a script shadowing a module from
  the standard library causes :exc:`AttributeError` to be raised. Similarly,
  improve the error message when a script shadowing a third party module
  attempts to access an attribute from that third party module while still
  initialising.

- gh-99180: Elide uninformative traceback indicators in ``return`` and
  simple ``assignment`` statements. Patch by Pablo Galindo.

- gh-105879: Allow the *globals* and *locals* arguments to :func:`exec` and
  :func:`eval` to be passed as keywords.

Library
-------

- gh-118418: A :exc:`DeprecationWarning` is now emitted if you fail to pass
  a value to the new *type_params* parameter of ``typing._eval_type()`` or
  ``typing.ForwardRef._evaluate()``. (Using either of these private and
  undocumented functions is discouraged to begin with, but failing to pass a
  value to the ``type_params`` parameter may lead to incorrect behaviour on
  Python 3.12 or newer.)

- gh-118660: Add an optional second type parameter to
  :class:`typing.ContextManager` and :class:`typing.AsyncContextManager`,
  representing the return types of :meth:`~object.__exit__` and
  :meth:`~object.__aexit__` respectively. This parameter defaults to ``bool
  | None``.

- gh-118650: The ``enum`` module allows method named ``_repr_*`` to be
  defined on ``Enum`` types.

- gh-118648: Add type parameter defaults to :class:`typing.Generator` and
  :class:`typing.AsyncGenerator`.

- gh-101137: Mime type ``text/x-rst`` is now supported by :mod:`mimetypes`.

- gh-118164: The Python implementation of the ``decimal`` module could
  appear to hang in relatively small power cases (like ``2**117``) if
  context precision was set to a very high value. A different method to
  check for exactly representable results is used now that doesn't rely on
  computing ``10**precision`` (which could be effectively too large to
  compute).

- gh-111744: ``breakpoint()`` and ``pdb.set_trace()`` now enter the debugger
  immediately after the call rather than before the next line is executed.

- gh-118500: Add :mod:`pdb` support for zipapps

- gh-118406: Add signature for :class:`sqlite3.Connection` objects.

- gh-101732: Use a Y2038 compatible openssl time function when available.

- gh-118404: Fix :func:`inspect.signature` for non-comparable callables.

- gh-118402: Fix :func:`inspect.signature` for the result of the
  :func:`functools.cmp_to_key` call.

- gh-116622: On Android, :any:`sysconfig.get_platform` now returns the
  format specified by :pep:`738`.

- gh-118285: Allow to specify the signature of custom callable instances of
  extension type by the ``__text_signature__`` attribute. Specify signatures
  of :class:`operator.attrgetter`, :class:`operator.itemgetter`, and
  :class:`operator.methodcaller` instances.

- gh-118314: Fix an edge case in :func:`binascii.a2b_base64` strict mode,
  where excessive padding is not detected when no padding is necessary.

- gh-118271: Add the :class:`!PhotoImage` methods :meth:`!read` to read an
  image from a file and :meth:`!data` to get the image data. Add
  *background* and *grayscale* parameters to :class:`!PhotoImage` method
  :meth:`!write`.

- gh-118225: Add the :class:`!PhotoImage` method :meth:`!copy_replace` to
  copy a region from one image to other image, possibly with pixel zooming
  and/or subsampling. Add *from_coords* parameter to :class:`!PhotoImage`
  methods :meth:`!copy`, :meth:`!zoom` and :meth:`!subsample`. Add *zoom*
  and *subsample* parameters to :class:`!PhotoImage` method :meth:`!copy`.

- gh-118221: Fix a bug where :meth:`sqlite3.Connection.iterdump` could fail
  if a custom :attr:`row factory <sqlite3.Connection.row_factory>` was used.
  Patch by Erlend Aasland.

- gh-118013: Fix regression introduced in gh-103193 that meant that calling
  :func:`inspect.getattr_static` on an instance would cause a strong
  reference to that instance's class to persist in an internal cache in the
  :mod:`inspect` module. This caused unexpected memory consumption if the
  class was dynamically created, the class held strong references to other
  objects which took up a significant amount of memory, and the cache
  contained the sole strong reference to the class. The fix for the
  regression leads to a slowdown in :func:`!getattr_static`, but the
  function should still be significantly faster than it was in Python 3.11.
  Patch by Alex Waygood.

- gh-118218: Speed up :func:`itertools.pairwise` in the common case by up to
  1.8x.

- gh-117486: Improve the behavior of user-defined subclasses of
  :class:`ast.AST`. Such classes will now require no changes in the usual
  case to conform with the behavior changes of the :mod:`ast` module in
  Python 3.13. Patch by Jelle Zijlstra.

- gh-90848: Fixed :func:`unittest.mock.create_autospec` to configure parent
  mock with keyword arguments.

- gh-118168: Fix incorrect argument substitution when :data:`typing.Unpack`
  is used with the builtin :class:`tuple`. :data:`!typing.Unpack` now raises
  :exc:`TypeError` when used with certain invalid types. Patch by Jelle
  Zijlstra.

- gh-118131: Add command-line interface for the :mod:`random` module. Patch
  by Hugo van Kemenade.

- gh-118107: Fix :mod:`zipimport` reading of ZIP64 files with file entries
  that are too big or offset too far.

- gh-102511: Fix :func:`os.path.normpath` for UNC paths on Windows. Speed up
  :func:`os.path.splitroot` with a native implementation.

- gh-117535: Change the unknown filename of :mod:`warnings` from ``sys`` to
  ``<sys>`` to clarify that it's not a real filename.

- gh-114053: Fix erroneous :exc:`NameError` when calling
  :func:`typing.get_type_hints` on a class that made use of :pep:`695` type
  parameters in a module that had ``from __future__ import annotations`` at
  the top of the file. Patch by Alex Waygood.

- gh-116931: Add parameter *fileobj* check for
  :func:`tarfile.TarFile.addfile`

- gh-117995: Don't raise :exc:`DeprecationWarning` when a :term:`sequence`
  of parameters is used to bind indexed, nameless placeholders. See also
  :gh:`100668`.

- gh-80361: Fix TypeError in :func:`email.message.Message.get_payload` when
  the charset is :rfc:`2231` encoded.

- gh-86650: Fix IndexError when parse some emails with invalid Message-ID
  (including one-off addresses generated by Microsoft Outlook).

- gh-117691: Improve the error messages emitted by :mod:`tarfile`
  deprecation warnings relating to PEP 706. If a ``filter`` argument is not
  provided to ``extract()`` or ``extractall``, the deprecation warning now
  points to the line in the user's code where the relevant function was
  called. Patch by Alex Waygood.

- gh-115874: Fixed a possible segfault during garbage collection of
  ``_asyncio.FutureIter`` objects. Patch by Savannah Ostrowski.

- gh-115060: Speed up :meth:`pathlib.Path.glob` by omitting an initial
  :meth:`~pathlib.Path.is_dir` call. As a result of this change,
  :meth:`~pathlib.Path.glob` can no longer raise :exc:`OSError`.

- gh-77102: :mod:`site` module now parses ``.pth`` file with UTF-8 first,
  and :term:`locale encoding` if ``UnicodeDecodeError`` happened. It
  supported only locale encoding before.

- gh-76785: We've exposed the low-level :mod:`!_interpreters` module for the
  sake of the PyPI implementation of :pep:`734`.  It was sometimes available
  as the :mod:`!_xxsubinterpreters` module and was formerly used only for
  testing. For the most part, it should be considered an internal module,
  like :mod:`!_thread` and :mod:`!_imp`. See
  https://discuss.python.org/t/pep-734-multiple-interpreters-in-the-stdlib/41147/26.

- gh-115060: Speed up :meth:`pathlib.Path.glob` by not scanning directories
  for non-wildcard pattern segments.

- gh-117727: Speed up :meth:`pathlib.Path.iterdir` by using
  :func:`os.scandir` internally.

- gh-117586: Speed up :meth:`pathlib.Path.walk` by working with strings
  internally.

- gh-117722: Change the new multi-separator support in
  :meth:`asyncio.StreamReader.readuntil` to only accept tuples of separators
  rather than arbitrary iterables.

- gh-117692: Fixes a bug when :class:`doctest.DocTestFinder` was failing on
  wrapped ``builtin_function_or_method``.

- gh-117348: Largely restored import time performance of configparser by
  avoiding dataclasses.

- gh-117641: Speedup :func:`os.path.commonpath` on Unix.

- gh-117663: Fix ``_simple_enum`` to detect aliases when multiple arguments
  are present but only one is the member value.

- gh-117636: Speedup :func:`os.path.join`.

- gh-117618: Support ``package.module`` as ``filename`` for ``break``
  command of :mod:`pdb`

- gh-102247: the status codes enum with constants in http.HTTPStatus are
  updated to include the names from RFC9110. This RFC includes some HTTP
  statuses previously only used for WEBDAV and assigns more generic names to
  them.

  The old constants are preserved for backwards compatibility.

- gh-117607: Speedup :func:`os.path.relpath`.

- gh-117586: Speed up :meth:`pathlib.Path.glob` by working with strings
  internally.

- gh-117225: Add colour to doctest output. Patch by Hugo van Kemenade.

- gh-117566: :meth:`ipaddress.IPv6Address.is_loopback` will now return
  ``True`` for IPv4-mapped loopback addresses, i.e. addresses in the
  ``::ffff:127.0.0.0/104`` address space.

- gh-117546: Fix issue where :func:`os.path.realpath` stopped resolving
  symlinks after encountering a symlink loop on POSIX.

- gh-116720: Improved behavior of :class:`asyncio.TaskGroup` when an
  external cancellation collides with an internal cancellation. For example,
  when two task groups are nested and both experience an exception in a
  child task simultaneously, it was possible that the outer task group would
  misbehave, because its internal cancellation was swallowed by the inner
  task group.

  In the case where a task group is cancelled externally and also must raise
  an :exc:`ExceptionGroup`, it will now call the parent task's
  :meth:`~asyncio.Task.cancel` method. This ensures that a
  :exc:`asyncio.CancelledError` will be raised at the next :keyword:`await`,
  so the cancellation is not lost.

  An added benefit of these changes is that task groups now preserve the
  cancellation count (:meth:`asyncio.Task.cancelling`).

  In order to handle some corner cases, :meth:`asyncio.Task.uncancel` may
  now reset the undocumented ``_must_cancel`` flag when the cancellation
  count reaches zero.

- gh-117516: Add :data:`typing.TypeIs`, implementing :pep:`742`. Patch by
  Jelle Zijlstra.

- gh-117503: Fix support of non-ASCII user names in bytes paths in
  :func:`os.path.expanduser` on Posix.

- gh-117394: :func:`os.path.ismount` is now 2-3 times faster if the user has
  permissions.

- gh-117313: Only treat ``'\n'``, ``'\r'`` and ``'\r\n'`` as line separators
  in re-folding the :mod:`email` messages. Preserve control characters
  ``'\v'``, ``'\f'``, ``'\x1c'``, ``'\x1d'`` and ``'\x1e'`` and Unicode line
  separators ``'\x85'``, ``'\u2028'`` and ``'\u2029'`` as is.

- gh-117142: Convert :mod:`!_ctypes` to multi-phase initialisation
  (:pep:`489`).

- gh-66543: Add the :func:`mimetypes.guess_file_type` function which works
  with file path. Passing file path instead of URL in
  :func:`~mimetypes.guess_type` is :term:`soft deprecated`.

- gh-68583: webbrowser CLI: replace getopt with argparse, add long options.
  Patch by Hugo van Kemenade.

- gh-116871: Name suggestions for :exc:`AttributeError` and
  :exc:`ImportError` now only include underscored names if the original name
  was underscored.

- gh-116023: Don't show empty fields (value ``None`` or ``[]``) in
  :func:`ast.dump` by default. Add ``show_empty=False`` parameter to
  optionally show them.

- gh-115961: Added :attr:`!name` and :attr:`!mode` attributes for compressed
  and archived file-like objects in modules :mod:`bz2`, :mod:`lzma`,
  :mod:`tarfile` and :mod:`zipfile`. The value of the :attr:`!mode`
  attribute of :class:`gzip.GzipFile` was changed from integer (``1`` or
  ``2``) to string (``'rb'`` or ``'wb'``). The value of the :attr:`!mode`
  attribute of the readable file-like object returned by
  :meth:`zipfile.ZipFile.open` was changed from ``'r'`` to ``'rb'``.

- gh-82062: Fix :func:`inspect.signature` to correctly handle parameter
  defaults on methods in extension modules that use names defined in the
  module namespace.

- gh-83856: Honor :mod:`atexit` for all :mod:`multiprocessing` start methods

- gh-113081: Print colorized exception just like built-in traceback in
  :mod:`pdb`

- gh-112855: Speed up pickling of :class:`pathlib.PurePath` objects. Patch
  by Barney Gale.

- gh-111744: Support opcode events in :mod:`bdb`

- gh-109617: :mod:`!ncurses`: fixed a crash that could occur on macOS 13 or
  earlier when Python was built with Apple Xcode 15's SDK.

- gh-83151: Enabled arbitrary statements and evaluations in :mod:`pdb` shell
  to access the local variables of the current frame, which made it possible
  for multi-scope code like generators or nested function to work.

- gh-110209: Add :meth:`~object.__class_getitem__` to
  :class:`types.GeneratorType` and :class:`types.CoroutineType` for type
  hinting purposes. Patch by James Hilton-Balfe.

- gh-108191: The :class:`types.SimpleNamespace` now accepts an optional
  positional argument which specifies initial values of attributes as a dict
  or an iterable of key-value pairs.

- gh-62090: Fix assertion errors caused by whitespace in metavars or
  ``SUPPRESS``-ed groups in :mod:`argparse` by simplifying usage formatting.
  Patch by Ali Hamdan.

- gh-102402: Adjust ``logging.LogRecord`` to use ``time.time_ns()`` and fix
  minor bug related to floating-point math.

- gh-100242: Bring pure Python implementation ``functools.partial.__new__``
  more in line with the C-implementation by not just always checking for the
  presence of the attribute ``'func'`` on the first argument of ``partial``.
  Instead, both the Python version and the C version perform an
  ``isinstance(func, partial)`` check on the first argument of ``partial``.

- gh-99730: HEAD requests are no longer upgraded to GET request during
  redirects in urllib.

- gh-66410: Setting the :mod:`!tkinter` module global :data:`!wantobjects`
  to ``2`` before creating the :class:`~tkinter.Tk` object or call the
  :meth:`!wantobjects` method of the :class:`!Tk` object with argument ``2``
  makes now arguments to callbacks registered in the :mod:`tkinter` module
  to be passed as various Python objects (``int``, ``float``, ``bytes``,
  ``tuple``), depending on their internal representation in Tcl, instead of
  always ``str``. :data:`!tkinter.wantobjects` is now set to ``2`` by
  default.

- bpo-40943: Fix several IndexError when parse emails with truncated
  Message-ID, address, routes, etc, e.g. ``example@``.

- bpo-39324: Add mime type mapping for .md <-> text/markdown

- bpo-18108: :func:`shutil.chown` now supports *dir_fd* and
  *follow_symlinks* keyword arguments.

- bpo-30988: Fix parsing of emails with invalid address headers having a
  leading or trailing dot. Patch by tsufeki.

- bpo-32839: Add the :meth:`!after_info` method for Tkinter widgets.

Documentation
-------------

- gh-117928: The minimum Sphinx version required for the documentation is
  now 6.2.1.

Build
-----

- gh-118734: Fixes Windows build when invoked directly (not through the
  :file:`build.bat` script) without specifying a value for ``UseTIER2``.

- gh-115119: The :file:`configure` option :option:`--with-system-libmpdec`
  now defaults to ``yes``. The bundled copy of ``libmpdecimal`` will be
  removed in Python 3.15.

- gh-117845: Fix building against recent libedit versions by detecting
  readline hook signatures in :program:`configure`.

- gh-116622: A testbed project was added to run the test suite on Android.

- gh-117645: Increase WASI stack size from 512 KiB to 8 MiB and the initial
  memory from 10 MiB to 20 MiB. Patch by Victor Stinner.

- gh-115119: :program:`configure` now uses :program:`pkg-config` to detect
  :mod:`decimal` dependencies if the :option:`--with-system-libmpdec` option
  is given.

Windows
-------

- gh-115119: Update Windows installer to use libmpdecimal 4.0.0.

- gh-118486: :func:`os.mkdir` now accepts *mode* of ``0o700`` to restrict
  the new directory to the current user.

- gh-118347: Fixes launcher updates not being installed.

- gh-118293: The ``multiprocessing`` module now passes the
  ``STARTF_FORCEOFFFEEDBACK`` flag when spawning processes to tell Windows
  not to change the mouse cursor.

- gh-115009: Update Windows installer to use SQLite 3.45.3.

- gh-90329: Suppress the warning displayed on virtual environment creation
  when the requested and created paths differ only by a short (8.3 style)
  name. Warnings will continue to be shown if a junction or symlink in the
  path caused the venv to be created in a different location than originally
  requested.

- gh-117786: Fixes virtual environments not correctly launching when created
  from a Store install.

macOS
-----

- gh-115119: Update macOS installer to use libmpdecimal 4.0.0.

- gh-114099: iOS preprocessor symbol usage was made compatible with older
  macOS SDKs.

- gh-115009: Update macOS installer to use SQLite 3.45.3.

- gh-91629: Use :file:`~/.config/fish/conf.d` configs and
  :program:`fish_add_path` to set :envvar:`PATH` when installing for the
  Fish shell.

IDLE
----

- bpo-34774: Use user-selected color theme for Help => IDLE Doc.

C API
-----

- gh-118124: Fix :c:macro:`Py_BUILD_ASSERT` and
  :c:macro:`Py_BUILD_ASSERT_EXPR` for non-constant expressions: use
  ``static_assert()`` on C11 and newer. Patch by Victor Stinner.

- gh-110850: Add "Raw" variant of PyTime functions

  * :c:func:`PyTime_MonotonicRaw`
  * :c:func:`PyTime_PerfCounterRaw`
  * :c:func:`PyTime_TimeRaw`

  Patch by Victor Stinner.

- gh-117987: Restore functions removed in Python 3.13 alpha 1:

  * :c:func:`Py_SetPythonHome`
  * :c:func:`Py_SetProgramName`
  * :c:func:`PySys_SetArgvEx`
  * :c:func:`PySys_SetArgv`

  Patch by Victor Stinner.

- gh-117929: Restore removed :c:func:`PyEval_InitThreads` function. Patch by
  Victor Stinner.

- gh-117534: Improve validation logic in the C implementation of
  :meth:`datetime.datetime.fromisoformat` to better handle invalid years.
  Patch by Vlad Efanov.

- gh-68114: Fixed skipitem()'s handling of the old 'w' and 'w#' formatters.
  These are no longer supported and now raise an exception if used.

- gh-111997: Add a C-API for firing monitoring events.


What's New in Python 3.13.0 alpha 6?
====================================

*Release date: 2024-04-09*

Core and Builtins
-----------------

- gh-117494: Refactored the instruction sequence data structure out of
  compile.c into instruction_sequence.c.

- gh-116968: Introduce a unified 16-bit backoff counter type
  (``_Py_BackoffCounter``), shared between the Tier 1 adaptive specializer
  and the Tier 2 optimizer. The API used for adaptive specialization
  counters is changed but the behavior is (supposed to be) identical.

  The behavior of the Tier 2 counters is changed:

  * There are no longer dynamic thresholds (we never varied these).
  * All counters now use the same exponential backoff.
  * The counter for ``JUMP_BACKWARD`` starts counting down from 16.
  * The ``temperature`` in side exits starts counting down from 64.

- gh-117431: Improve the performance of the following :class:`bytes` and
  :class:`bytearray` methods by adapting them to the
  :c:macro:`METH_FASTCALL` calling convention:

  * :meth:`!endswith`
  * :meth:`!startswith`

- gh-117431: Improve the performance of the following :class:`str` methods
  by adapting them to the :c:macro:`METH_FASTCALL` calling convention:

  * :meth:`~str.count`
  * :meth:`~str.endswith`
  * :meth:`~str.find`
  * :meth:`~str.index`
  * :meth:`~str.rfind`
  * :meth:`~str.rindex`
  * :meth:`~str.startswith`

- gh-117411: Move ``PyFutureFeatures`` to an internal header and make it
  private.

- gh-109120: Added handle of incorrect star expressions, e.g ``f(3, *)``.
  Patch by Grigoryev Semyon

- gh-117266: Fix crashes for certain user-created subclasses of
  :class:`ast.AST`. Such classes are now expected to set the
  ``_field_types`` attribute.

- gh-99108: Updated the :mod:`hashlib` built-in `HACL\* project`_ C code
  from upstream that we use for many implementations when they are not
  present via OpenSSL in a given build.  This also avoids the rare potential
  for a C symbol name one definition rule linking issue.

  .. _HACL\* project: https://github.com/hacl-star/hacl-star

- gh-117108: Change the old space bit of objects in the young generation
  from 0 to gcstate->visited, so that any objects created during GC will
  have the old bit set correctly if they get moved into the old generation.

- gh-117108: The cycle GC now chooses the size of increments based on the
  total heap size, instead of the rate of object creation. This ensures that
  it can keep up with growing heaps.

- gh-116735: For ``INSTRUMENTED_CALL_FUNCTION_EX``, set ``arg0`` to
  ``sys.monitoring.MISSING`` instead of ``None`` for
  :monitoring-event:`CALL` event.

- gh-113964: Starting new threads and process creation through
  :func:`os.fork` are now only prevented once all non-daemon threads exit.

- gh-116626: Ensure ``INSTRUMENTED_CALL_FUNCTION_EX`` always emits
  :monitoring-event:`CALL`

- gh-116554: ``list.sort()`` now exploits more cases of partial ordering,
  particularly those with long descending runs with sub-runs of equal
  values. Those are recognized as single runs now (previously, each block of
  repeated values caused a new run to be created).

- gh-114099: Added a Loader that can discover extension modules in an
  iOS-style Frameworks folder.

- gh-115775: Compiler populates the new ``__static_attributes__`` field on a
  class with the names of attributes of this class which are accessed
  through self.X from any function in its body.

- gh-115776: The array of values, the ``PyDictValues`` struct is now
  embedded in the object during allocation. This provides better performance
  in the common case, and does not degrade as much when the object's
  ``__dict__`` is materialized.

- gh-108362: Implement an incremental cyclic garbage collector. By
  collecting the old generation in increments, there is no need for a full
  heap scan. This can hugely reduce maximum pause time for programs with
  large heaps.

  Reduce the number of generations from three to two. The old generation is
  split into two spaces, "visited" and "pending".

  Collection happens in two steps:: * An increment is formed from the young
  generation and a small part of the pending space. * This increment is
  scanned and the survivors moved to the end of the visited space.

  When the collecting space becomes empty, the two spaces are swapped.

- gh-109870: Dataclasses now calls :func:`exec` once per dataclass, instead
  of once per method being added.  This can speed up dataclass creation by
  up to 20%.

- gh-97901: Mime type ``text/rtf`` is now supported by :mod:`mimetypes`.

- bpo-24612: Improve the :exc:`SyntaxError` that happens when 'not' appears
  after an operator. Patch by Pablo Galindo

Library
-------

- gh-117648: Improve performance of :func:`os.path.join` and
  :func:`os.path.expanduser`.

- gh-117584: Raise :exc:`TypeError` for non-paths in
  :func:`posixpath.relpath`.

- gh-117467: Preserve mailbox ownership when rewriting in
  :func:`mailbox.mbox.flush`. Patch by Tony Mountifield.

- gh-114848: Raise :exc:`FileNotFoundError` when ``getcwd()`` returns
  '(unreachable)', which can happen on Linux >= 2.6.36 with glibc < 2.27.

- gh-117459: :meth:`asyncio.asyncio.run_coroutine_threadsafe` now keeps the
  traceback of :class:`CancelledError`, :class:`TimeoutError` and
  :class:`InvalidStateError` which are raised in the coroutine.

- gh-117381: Fix error message for :func:`ntpath.commonpath`.

- gh-117337: Deprecate undocumented :func:`!glob.glob0` and
  :func:`!glob.glob1` functions. Use :func:`glob.glob` and pass a directory
  to its *root_dir* argument instead.

- gh-117349: Optimise several functions in :mod:`os.path`.

- gh-117348: Refactored :meth:`configparser.RawConfigParser._read` to reduce
  cyclometric complexity and improve comprehensibility.

- gh-117335: Raise TypeError for non-sequences for
  :func:`ntpath.commonpath`.

- gh-66449: :class:`configparser.ConfigParser` now accepts unnamed sections
  before named ones, if configured to do so.

- gh-88014: In documentation of :class:`gzip.GzipFile` in module gzip,
  explain data type of optional constructor argument *mtime*, and recommend
  ``mtime = 0`` for generating deterministic streams.

- gh-117310: Fixed an unlikely early & extra ``Py_DECREF`` triggered crash
  in :mod:`ssl` when creating a new ``_ssl._SSLContext`` if CPython was
  built implausibly such that the default cipher list is empty **or** the
  SSL library it was linked against reports a failure from its C
  ``SSL_CTX_set_cipher_list()`` API.

- gh-117294: A ``DocTestCase`` now reports as skipped if all examples in the
  doctest are skipped.

- gh-98966: In :mod:`subprocess`, raise a more informative message when
  ``stdout=STDOUT``.

- gh-117225: doctest: only print "and X failed" when non-zero, don't
  pluralise "1 items". Patch by Hugo van Kemenade.

- gh-117205: Speed up :func:`compileall.compile_dir` by 20% when using
  multiprocessing by increasing ``chunksize``.

- gh-117178: Fix regression in lazy loading of self-referential modules,
  introduced in gh-114781.

- gh-112383: Fix :mod:`dis` module's handling of ``ENTER_EXECUTOR``
  instructions.

- gh-117182: Lazy-loading of modules that modify their own ``__class__`` no
  longer reverts the ``__class__`` to :class:`types.ModuleType`.

- gh-117084: Fix :mod:`zipfile` extraction for directory entries with the
  name containing backslashes on Windows.

- gh-117114: Make :func:`os.path.isdevdrive` available on all platforms. For
  those that do not offer Dev Drives, it will always return ``False``.

- gh-117110: Fix a bug that prevents subclasses of :class:`typing.Any` to be
  instantiated with arguments. Patch by Chris Fu.

- gh-109653: Deferred select imports in importlib.metadata and
  importlib.resources for a 14% speedup.

- gh-70647: Start the deprecation period for the current behavior of
  :func:`datetime.datetime.strptime` and :func:`time.strptime` which always
  fails to parse a date string with a :exc:`ValueError` involving a day of
  month such as ``strptime("02-29", "%m-%d")`` when a year is **not**
  specified and the date happen to be February 29th.  This should help avoid
  users finding new bugs every four years due to a natural mistaken
  assumption about the API when parsing partial date values.

- gh-116987: Fixed :func:`inspect.findsource` for class code objects.

- gh-114099: Modify standard library to allow for iOS platform differences.

- gh-90872: On Windows, :meth:`subprocess.Popen.wait` no longer calls
  ``WaitForSingleObject()`` with a negative timeout: pass ``0`` ms if the
  timeout is negative. Patch by Victor Stinner.

- gh-116957: configparser: Don't leave ConfigParser values in an invalid
  state (stored as a list instead of a str) after an earlier read raised
  DuplicateSectionError or DuplicateOptionError.

- gh-115538: :class:`!_io.WindowsConsoleIO` now emit a warning if a boolean
  value is passed as a filedescriptor argument.

- gh-90095: Ignore empty lines and comments in ``.pdbrc``

- gh-106531: Refreshed zipfile._path from `zipp 3.18
  <https://zipp.readthedocs.io/en/latest/history.html#v3-18-0>`_, providing
  better compatibility for PyPy, better glob performance for deeply nested
  zipfiles, and providing internal access to ``CompleteDirs.inject`` for use
  in other tests (like importlib.resources).

- gh-63207: On Windows, :func:`time.time` now uses the
  ``GetSystemTimePreciseAsFileTime()`` clock to have a resolution better
  than 1 us, instead of the ``GetSystemTimeAsFileTime()`` clock which has a
  resolution of 15.6 ms. Patch by Victor Stinner.

- gh-116764: Restore support of ``None`` and other false values in
  :mod:`urllib.parse` functions :func:`~urllib.parse.parse_qs` and
  :func:`~urllib.parse.parse_qsl`. Also, they now raise a TypeError for
  non-zero integers and non-empty sequences.

- gh-116811: In ``PathFinder.invalidate_caches``, delegate to
  ``MetadataPathFinder.invalidate_caches``.

- gh-116647: Fix recursive child in dataclasses

- gh-113171: Fixed various false positives and false negatives in

  * :attr:`ipaddress.IPv4Address.is_private` (see these docs for details)
  * :attr:`ipaddress.IPv4Address.is_global`
  * :attr:`ipaddress.IPv6Address.is_private`
  * :attr:`ipaddress.IPv6Address.is_global`

  Also in the corresponding :class:`ipaddress.IPv4Network` and
  :class:`ipaddress.IPv6Network` attributes.

- gh-63283: In :mod:`encodings.idna`, any capitalization of the ACE prefix
  (``xn--``) is now acceptable. Patch by Pepijn de Vos and Zackery Spytz.

- gh-71042: Add :func:`platform.android_ver`, which provides device and OS
  information on Android.

- gh-73468: Added new :func:`math.fma` function, wrapping C99's ``fma()``
  operation: fused multiply-add function. Patch by Mark Dickinson and Victor
  Stinner.

- gh-116608: The :mod:`importlib.resources` functions
  :func:`~importlib.resources.is_resource`,
  :func:`~importlib.resources.open_binary`,
  :func:`~importlib.resources.open_text`, :func:`~importlib.resources.path`,
  :func:`~importlib.resources.read_binary`, and
  :func:`~importlib.resources.read_text` are un-deprecated, and support
  subdirectories via multiple positional arguments. The
  :func:`~importlib.resources.contents` function also allows subdirectories,
  but remains deprecated.

- gh-116484: Change automatically generated :class:`tkinter.Checkbutton`
  widget names to avoid collisions with automatically generated
  :class:`tkinter.ttk.Checkbutton` widget names within the same parent
  widget.

- gh-114314: In :mod:`ctypes`, ctype data is now stored in type objects
  directly rather than in a dict subclass. This is an internal change that
  should not affect usage.

- gh-116401: Fix blocking :func:`os.fwalk` and :func:`shutil.rmtree` on
  opening named pipe.

- gh-71052: Implement :func:`ctypes.util.find_library` on Android.

- gh-90535: Fix support of *interval* values > 1 in
  :class:`logging.TimedRotatingFileHandler` for ``when='MIDNIGHT'`` and
  ``when='Wx'``.

- gh-113308: Remove some internal protected parts from :mod:`uuid`:
  ``_has_uuid_generate_time_safe``, ``_netbios_getnode``,
  ``_ipconfig_getnode``, and ``_load_system_functions``. They were unused.

- gh-115627: Fix the :mod:`ssl` module error handling of connection
  terminate by peer. It now throws an OSError with the appropriate error
  code instead of an EOFError.

- gh-114847: Speed up :func:`os.path.realpath` on non-Windows platforms.

- gh-114271: Fix a race in ``threading.Thread.join()``.

  ``threading._MainThread`` now always represents the main thread of the
  main interpreter.

  ``PyThreadState.on_delete`` and ``PyThreadState.on_delete_data`` have been
  removed.

- gh-113538: Add :meth:`asyncio.Server.close_clients` and
  :meth:`asyncio.Server.abort_clients` methods which allow to more
  forcefully close an asyncio server.

- gh-85287: Changes Unicode codecs to return UnicodeEncodeError or
  UnicodeDecodeError, rather than just UnicodeError.

- gh-113548: :mod:`pdb` now allows CLI arguments to ``pdb -m``.

- gh-112948: Make completion of :mod:`pdb` similar to Python REPL

- gh-105866: Fixed ``_get_slots`` bug which caused error when defining
  dataclasses with slots and a weakref_slot.

- gh-96471: Add :py:class:`asyncio.Queue` termination with
  :py:meth:`~asyncio.Queue.shutdown` method.

- gh-89739: The :mod:`zipimport` module can now read ZIP64 files.

- bpo-33533: :func:`asyncio.as_completed` now returns an object that is both
  an asynchronous iterator and plain iterator. The new asynchronous
  iteration pattern allows for easier correlation between prior tasks and
  their completed results. This is a closer match to
  :func:`concurrent.futures.as_completed`'s iteration pattern. Patch by
  Justin Arthur.

- bpo-27578: :func:`inspect.getsource` (and related functions) work with
  empty module files, returning ``'\n'`` (or reasonable equivalent) instead
  of raising ``OSError``. Patch by Kernc.

- bpo-37141: Accept an iterable of separators in
  :meth:`asyncio.StreamReader.readuntil`, stopping when one of them is
  encountered.

- gh-66543: Make :func:`mimetypes.guess_type` properly parsing of URLs with
  only a host name, URLs containing fragment or query, and filenames with
  only a UNC sharepoint on Windows. Based on patch by Dong-hee Na.

- bpo-15010: :meth:`unittest.TestLoader.discover` now saves the original
  value of ``unittest.TestLoader._top_level_dir`` and restores it at the end
  of the call.

Documentation
-------------

- gh-115977: Remove compatibility references to Emscripten.

- gh-114099: Add an iOS platform guide, and flag modules not available on
  iOS.

- gh-91565: Changes to documentation files and config outputs to reflect the
  new location for reporting bugs - i.e. GitHub rather than bugs.python.org.

Tests
-----

- gh-83434: Disable JUnit XML output (``--junit-xml=FILE`` command line
  option) in regrtest when hunting for reference leaks (``-R`` option).
  Patch by Victor Stinner.

- gh-117187: Fix XML tests for vanilla Expat <2.6.0.

- gh-116333: Tests of TLS related things (error codes, etc) were updated to
  be more lenient about specific error message strings and behaviors as seen
  in the BoringSSL and AWS-LC forks of OpenSSL.

- gh-117089: Consolidated tests for importlib.metadata in their own
  ``metadata`` package.

- gh-115979: Update test_importlib so that it passes under WASI SDK 21.

- gh-112536: Add --tsan to test.regrtest for running TSAN tests in
  reasonable execution times. Patch by Donghee Na.

- gh-116307: Added import helper ``isolated_modules`` as ``CleanImport``
  does not remove modules imported during the context. Use it in
  importlib.resources tests to avoid leaving ``mod`` around to impede
  importlib.metadata tests.

Build
-----

- gh-114736: Have WASI builds use WASI SDK 21.

- gh-115983: Skip building test modules that must be built as shared under
  WASI.

- gh-71052: Add Android build script and instructions.

Windows
-------

- gh-117267: Ensure ``DirEntry.stat().st_ctime`` behaves consistently with
  :func:`os.stat` during the deprecation period of ``st_ctime`` by
  containing the same value as ``st_birthtime``. After the deprecation
  period, ``st_ctime`` will be the metadata change time (or unavailable
  through ``DirEntry``), and only ``st_birthtime`` will contain the creation
  time.

- gh-116195: Improves performance of :func:`os.getppid` by using an
  alternate system API when available. Contributed by vxiiduu.

- gh-88494: On Windows, :func:`time.monotonic` now uses the
  ``QueryPerformanceCounter()`` clock to have a resolution better than 1 us,
  instead of the ``GetTickCount64()`` clock which has a resolution of 15.6
  ms. Patch by Victor Stinner.

- gh-116773: Fix instances of ``<_overlapped.Overlapped object at 0xXXX>
  still has pending operation at deallocation, the process may crash``.

- gh-91227: Fix the asyncio ProactorEventLoop implementation so that sending
  a datagram to an address that is not listening does not prevent receiving
  any more datagrams.

- gh-115119: Switched from vendored ``libmpdecimal`` code to a
  separately-hosted external package in the ``cpython-source-deps``
  repository when building the ``_decimal`` module.

C API
-----

- gh-117642: Fix :pep:`737` implementation for ``%#T`` and ``%#N``.

- gh-87193: :c:func:`_PyBytes_Resize` can now be called for bytes objects
  with reference count > 1, including 1-byte bytes objects. It creates a new
  bytes object and destroys the old one if it has reference count > 1.

- gh-117021: Fix integer overflow in :c:func:`PyLong_AsPid` on non-Windows
  64-bit platforms.

- gh-115756: :c:func:`!PyCode_GetFirstFree` is an ustable API now and has
  been renamed to :c:func:`PyUnstable_Code_GetFirstFree`. (Contributed by
  Bogdan Romanyuk in :gh:`115781`)

- gh-116869: Add ``test_cext`` test: build a C extension to check if the
  Python C API emits C compiler warnings. Patch by Victor Stinner.

- gh-116869: Make the C API compatible with
  ``-Werror=declaration-after-statement`` compiler flag again. Patch by
  Victor Stinner.

- gh-116936: Add :c:func:`PyType_GetModuleByDef` to the limited C API. Patch
  by Victor Stinner.

- gh-116809: Restore removed private ``_PyErr_ChainExceptions1()`` function.
  Patch by Victor Stinner.

- gh-115754: In the limited C API version 3.13, getting ``Py_None``,
  ``Py_False``, ``Py_True``, ``Py_Ellipsis`` and ``Py_NotImplemented``
  singletons is now implemented as function calls at the stable ABI level to
  hide implementation details. Getting these constants still return borrowed
  references. Patch by Victor Stinner.

- gh-115754: Add :c:func:`Py_GetConstant` and
  :c:func:`Py_GetConstantBorrowed` functions to get constants. For example,
  ``Py_GetConstant(Py_CONSTANT_ZERO)`` returns a :term:`strong reference` to
  the constant zero. Patch by Victor Stinner.

- gh-111696: Add support for ``%T``, ``%T#``, ``%N`` and ``%N#`` formats to
  :c:func:`PyUnicode_FromFormat`: format the fully qualified name of an
  object type and of a type: call :c:func:`PyType_GetModuleName`. See
  :pep:`737` for more information. Patch by Victor Stinner.

- gh-111696: Add :c:func:`PyType_GetModuleName` function to get the type's
  module name. Equivalent to getting the ``type.__module__`` attribute.
  Patch by Eric Snow and Victor Stinner.

- gh-111696: Add :c:func:`PyType_GetFullyQualifiedName` function to get the
  type's fully qualified name. Equivalent to
  ``f"{type.__module__}.{type.__qualname__}"``, or ``type.__qualname__`` if
  ``type.__module__`` is not a string or is equal to ``"builtins"``. Patch
  by Victor Stinner.

- gh-85283: The ``fcntl``, ``grp``, ``pwd``, ``termios``, ``_statistics``
  and ``_testconsole`` C extensions are now built with the :ref:`limited C
  API <limited-c-api>`. Patch by Victor Stinner.

- gh-111140: Add additional flags to :c:func:`PyLong_AsNativeBytes` and
  :c:func:`PyLong_FromNativeBytes` to allow the caller to determine how to
  handle edge cases around values that fill the entire buffer.

- gh-113024: Add :c:func:`PyObject_GenericHash` function.


What's New in Python 3.13.0 alpha 5?
====================================

*Release date: 2024-03-12*

Security
--------

- gh-115398: Allow controlling Expat >=2.6.0 reparse deferral
  (:cve:`2023-52425`) by adding five new methods:

  * :meth:`xml.etree.ElementTree.XMLParser.flush`
  * :meth:`xml.etree.ElementTree.XMLPullParser.flush`
  * :meth:`xml.parsers.expat.xmlparser.GetReparseDeferralEnabled`
  * :meth:`xml.parsers.expat.xmlparser.SetReparseDeferralEnabled`
  * :meth:`xml.sax.expatreader.ExpatParser.flush`

- gh-114572: :meth:`ssl.SSLContext.cert_store_stats` and
  :meth:`ssl.SSLContext.get_ca_certs` now correctly lock access to the
  certificate store, when the :class:`ssl.SSLContext` is shared across
  multiple threads.

Core and Builtins
-----------------

- gh-116604: Respect the status of the garbage collector when indirect calls
  are made via :c:func:`PyErr_CheckSignals` and the evaluation breaker.
  Patch by Pablo Galindo

- gh-112087: :class:`list` is now compatible with the implementation of
  :pep:`703`.

- gh-116381: Add specialization for ``CONTAINS_OP``.

- gh-116296: Fix possible refleak in :meth:`!object.__reduce__` internal
  error handling.

- gh-115823: Properly calculate error ranges in the parser when raising
  :exc:`SyntaxError` exceptions caused by invalid byte sequences. Patch by
  Pablo Galindo

- gh-115778: Add ``tierN`` annotation for instruction definition in
  interpreter DSL.

- gh-115733: Fix crash when calling ``next()`` on exhausted list iterators.

- gh-115700: The regen-cases build stage now works on Windows.

- gh-115347: Fix bug where docstring was replaced by a redundant NOP when
  Python is run with ``-OO``.

- gh-115323: Make error message more meaningful for when
  :meth:`bytearray.extend` is called with a :class:`str` object.

- gh-112175: Every ``PyThreadState`` now has its own ``eval_breaker``,
  allowing specific threads to be interrupted.

- gh-115154: Fix a bug that was causing the :func:`tokenize.untokenize`
  function to handle unicode named literals incorrectly. Patch by Pablo
  Galindo

- gh-112433: Add ability to force alignment of :mod:`ctypes.Structure` by
  way of the new ``_align_`` attribute on the class.

- gh-104090: The multiprocessing resource tracker now exits with non-zero
  status code if a resource leak was detected. It still exits with status
  code 0 otherwise.

- gh-105858: Improve the constructors for :mod:`ast` nodes. Arguments of
  list types now default to an empty list if omitted, and optional fields
  default to ``None``. AST nodes now have an ``__annotations__`` attribute
  with the expected types of their attributes. Passing unrecognized extra
  arguments to AST nodes is deprecated and will become an error in Python
  3.15. Omitting a required argument to an AST node is deprecated and will
  become an error in Python 3.15. Patch by Jelle Zijlstra.

- gh-101860: Expose ``__name__`` attribute on property.

- gh-96497: Fix incorrect resolution of mangled class variables used in
  assignment expressions in comprehensions.

Library
-------

- gh-116600: Fix :func:`repr` for global :class:`~enum.Flag` members.

- gh-116349: :func:`platform.java_ver` is deprecated and will be removed in
  3.15. It was largely untested, had a confusing API, and was only useful
  for Jython support.

- gh-116143: Fix a race in pydoc ``_start_server``, eliminating a window in
  which ``_start_server`` can return a thread that is "serving" but without
  a ``docserver`` set.

- gh-116127: :mod:`typing`: implement :pep:`705` which adds
  :data:`typing.ReadOnly` support to :class:`typing.TypedDict`.

- gh-116325: :mod:`typing`: raise :exc:`SyntaxError` instead of
  :exc:`AttributeError` on forward references as empty strings.

- gh-115957: When ``asyncio.TaskGroup.create_task`` is called on an inactive
  ``asyncio.TaskGroup``, the given coroutine will be closed (which prevents
  a ``RuntimeWarning``).

- gh-115978: Disable preadv(), readv(), pwritev(), and writev() on WASI.

  Under wasmtime for WASI 0.2, these functions don't pass test_posix
  (https://github.com/bytecodealliance/wasmtime/issues/7830).

- gh-88352: Fix the computation of the next rollover time in the
  :class:`logging.TimedRotatingFileHandler` handler.
  :meth:`!computeRollover` now always returns a timestamp larger than the
  specified time and works correctly during the DST change.
  :meth:`!doRollover` no longer overwrite the already rolled over file,
  saving from data loss when run at midnight or during repeated time at the
  DST change.

- gh-87115: Set ``__main__.__spec__`` to ``None`` when running a script with
  :mod:`pdb`

- gh-76511: Fix UnicodeEncodeError in :meth:`email.Message.as_string` that
  results when a message that claims to be in the ascii character set
  actually has non-ascii characters. Non-ascii characters are now replaced
  with the U+FFFD replacement character, like in the ``replace`` error
  handler.

- gh-89547: Add support for nested typing special forms like
  Final[ClassVar[int]].

- gh-65824: Improve the ``less`` prompt in :mod:`pydoc`.

- gh-116040: [Enum] fix by-value calls when second value is falsey; e.g.
  Cardinal(1, 0)

- gh-115821: [Enum] Improve error message when calling super().__new__() in
  custom __new__.

- gh-85644: Use the ``XDG_CURRENT_DESKTOP`` environment variable in
  :mod:`webbrowser` to check desktop. Prefer it to the deprecated
  ``GNOME_DESKTOP_SESSION_ID`` for GNOME detection.

- gh-75988: Fixed :func:`unittest.mock.create_autospec` to pass the call
  through to the wrapped object to return the real result.

- gh-115881: Fix issue where :func:`ast.parse` would incorrectly flag
  conditional context managers (such as ``with (x() if y else z()): ...``)
  as invalid syntax if ``feature_version=(3, 8)`` was passed. This reverts
  changes to the grammar made as part of gh-94949.

- gh-115886: Fix silent truncation of the name with an embedded null
  character in :class:`multiprocessing.shared_memory.SharedMemory`.

- gh-115532: Add kernel density estimation to the statistics module.

- gh-115714: On WASI, the :mod:`time` module no longer get process time
  using ``times()`` or ``CLOCK_PROCESS_CPUTIME_ID``, system API is that is
  unreliable and is likely to be removed from WASI. The affected clock
  functions fall back to calling ``clock()``.

- gh-115809: Improve algorithm for computing which rolled-over log files to
  delete in :class:`logging.TimedRotatingFileHandler`. It is now reliable
  for handlers without ``namer`` and with arbitrary deterministic ``namer``
  that leaves the datetime part in the file name unmodified.

- gh-74668: :mod:`urllib.parse` functions :func:`~urllib.parse.parse_qs` and
  :func:`~urllib.parse.parse_qsl` now support bytes arguments containing raw
  and percent-encoded non-ASCII data.

- gh-67044: :func:`csv.writer` now always quotes or escapes ``'\r'`` and
  ``'\n'``, regardless of *lineterminator* value.

- gh-115712: Restore support of space delimiter with
  ``skipinitialspace=True`` in :mod:`csv`. :func:`csv.writer` now quotes
  empty fields if delimiter is a space and skipinitialspace is true and
  raises exception if quoting is not possible.

- gh-112364: Fixed :func:`ast.unparse` to handle format_spec with ``"``,
  ``'`` or ``\\``. Patched by Frank Hoffmann.

- gh-112997: Stop logging potentially sensitive callback arguments in
  :mod:`asyncio` unless debug mode is active.

- gh-114914: Fix an issue where an abandoned :class:`StreamWriter` would not
  be garbage collected.

- gh-111358: Fix a bug in
  :meth:`asyncio.BaseEventLoop.shutdown_default_executor` to ensure the
  timeout passed to the coroutine behaves as expected.

- gh-115618: Fix improper decreasing the reference count for ``None``
  argument in :class:`property` methods :meth:`~property.getter`,
  :meth:`~property.setter` and :meth:`~property.deleter`.

- gh-112720: Refactor :class:`dis.ArgResolver` to make it possible to
  subclass and change the way jump args are interpreted.

- gh-112006: Fix :func:`inspect.unwrap` for types with the ``__wrapper__``
  data descriptor. Fix :meth:`inspect.Signature.from_callable` for builtins
  :func:`classmethod` and :func:`staticmethod`.

- gh-101293: Support callables with the ``__call__()`` method and types with
  ``__new__()`` and ``__init__()`` methods set to class methods, static
  methods, bound methods, partial functions, and other types of methods and
  descriptors in :meth:`inspect.Signature.from_callable`.

- gh-103092: Isolate :mod:`!_lsprof` (apply :pep:`687`).

- gh-113942: :mod:`pydoc` no longer skips global functions implemented as
  builtin methods, such as :class:`~type.MethodDescriptorType` and
  :class:`~type.WrapperDescriptorType`.

- gh-115256: Added DeprecationWarning when accessing the tarfile attribute
  of TarInfo objects. The attribute is never used internally and is only
  attached to TarInfos when the tarfile is opened in write-mode, not
  read-mode. The attribute creates an unnecessary reference cycle which may
  cause corruption when not closing the handle after writing a tarfile.

- gh-115197: ``urllib.request`` no longer resolves the hostname before
  checking it against the system's proxy bypass list on macOS and Windows.

- gh-113812: :meth:`DatagramTransport.sendto` will now send zero-length
  datagrams if called with an empty bytes object. The transport flow control
  also now accounts for the datagram header when calculating the buffer
  size.

- gh-114763: Protect modules loaded with :class:`importlib.util.LazyLoader`
  from race conditions when multiple threads try to access attributes before
  the loading is complete.

- gh-114709: :func:`posixpath.commonpath` now raises a :exc:`ValueError`
  exception when passed an empty iterable. Previously, :exc:`IndexError` was
  raised.

  :func:`posixpath.commonpath` now raises a :exc:`TypeError` exception when
  passed ``None``. Previously, :exc:`ValueError` was raised.

- gh-114610: Fix bug where :meth:`pathlib.PurePath.with_stem` converted a
  non-empty path suffix to a stem when given an empty *stem* argument. It
  now raises :exc:`ValueError`, just like
  :meth:`pathlib.PurePath.with_suffix` does when called on a path with an
  empty stem, given a non-empty *suffix* argument.

- gh-107361: Add :data:`ssl.VERIFY_X509_PARTIAL_CHAIN` and
  :data:`VERIFY_X509_STRICT` to the default SSL context created with
  :func:`ssl.create_default_context`.

- gh-112281: Allow creating :ref:`union of types<types-union>` for
  :class:`typing.Annotated` with unhashable metadata.

- gh-111775: Fix :meth:`importlib.resources.simple.ResourceHandle.open` for
  text mode, added missed ``stream`` argument.

- gh-90095: Make .pdbrc and -c work with any valid pdb commands.

- gh-107625: Raise :exc:`configparser.ParsingError` from
  :meth:`~configparser.ConfigParser.read` and
  :meth:`~configparser.ConfigParser.read_file` methods of
  :class:`configparser.ConfigParser` if a key without a corresponding value
  is continued (that is, followed by an indented line).

- gh-107155: Fix incorrect output of ``help(x)`` where ``x`` is a
  :keyword:`lambda` function, which has an ``__annotations__`` dictionary
  attribute with a ``"return"`` key.

- gh-57141: Add option for *non-shallow* comparisons to
  :class:`filecmp.dircmp` like :func:`filecmp.cmp`. Original patch by Steven
  Ward. Enhanced by Tobias Rautenkranz

- gh-69990: :meth:`Profile.print_stats` has been improved to accept multiple
  sort arguments. Patched by Chiu-Hsiang Hsu and Furkan Onder.

- gh-104061: Add :data:`socket.SO_BINDTOIFINDEX` constant.

- gh-60346: Fix ArgumentParser inconsistent with parse_known_args.

- gh-102389: Add ``windows_31j`` to aliases for ``cp932`` codec

- gh-72249: :func:`functools.partial`s of :func:`repr` has been improved to
  include the :term:`module` name. Patched by Furkan Onder and Anilyka
  Barry.

- gh-100985: Update HTTPSConnection to consistently wrap IPv6 Addresses when
  using a proxy.

- gh-100884: email: fix misfolding of comma in address-lists over multiple
  lines in combination with unicode encoding.

- gh-95782: Fix :func:`io.BufferedReader.tell`,
  :func:`io.BufferedReader.seek`, :func:`!_pyio.BufferedReader.tell`,
  :func:`io.BufferedRandom.tell`, :func:`io.BufferedRandom.seek` and
  :func:`!_pyio.BufferedRandom.tell` being able to return negative offsets.

- gh-96310: Fix a traceback in :mod:`argparse` when all options in a
  mutually exclusive group are suppressed.

- gh-93205: Fixed a bug in
  :class:`logging.handlers.TimedRotatingFileHandler` where multiple rotating
  handler instances pointing to files with the same name but different
  extensions would conflict and not delete the correct files.

- bpo-31116: Add Z85 encoding to ``base64``.

- bpo-44865: Add missing call to localization function in :mod:`argparse`.

- bpo-43952: Fix :meth:`multiprocessing.connection.Listener.accept` to
  accept empty bytes as authkey. Not accepting empty bytes as key causes it
  to hang indefinitely.

- bpo-42125: linecache: get module name from ``__spec__`` if available. This
  allows getting source code for the ``__main__`` module when a custom
  loader is used.

- bpo-41122: Failing to pass arguments properly to
  :func:`functools.singledispatchmethod` now throws a TypeError instead of
  hitting an index out of bounds internally.

- bpo-40818: The asyncio REPL now runs :data:`sys.__interactivehook__` on
  startup. The default implementation of :data:`sys.__interactivehook__`
  provides auto-completion to the asyncio REPL. Patch contributed by Rémi
  Lapeyre.

- bpo-33775: Add 'default' and 'version' help text for localization in
  argparse.

Documentation
-------------

- gh-115399: Document :cve:`2023-52425` of Expat <2.6.0 under "XML
  vulnerabilities".

- gh-109653: Improve import time of :mod:`uuid` on Linux.

Tests
-----

- gh-71052: Add test exclusions to support running the test suite on
  Android.

- gh-71052: Enable ``test_concurrent_futures`` on platforms that support
  threading but not multiprocessing.

- gh-115796: Make '_testinternalcapi.assemble_code_object' construct the
  exception table for the code object.

- gh-115720: Leak tests (``-R``, ``--huntrleaks``) now show a summary of the
  number of leaks found in each iteration.

- gh-115122: Add ``--bisect`` option to regrtest test runner: run failed
  tests with ``test.bisect_cmd`` to identify failing tests. Patch by Victor
  Stinner.

- gh-115596: Fix ``ProgramPriorityTests`` in ``test_os`` permanently
  changing the process priority.

- gh-115556: On Windows, commas passed in arguments to
  ``Tools\buildbot\test.bat`` and ``PCbuild\\rt.bat`` are now properly
  handled.

- gh-115420: Fix translation of exception handler targets by
  ``_testinternalcapi.optimize_cfg``.

- gh-115376: Fix segfault in ``_testinternalcapi.compiler_codegen`` on bad
  input.

Build
-----

- gh-116313: Get WASI builds to work under wasmtime 18 w/ WASI 0.2/preview2
  primitives.

- gh-71052: Change Android's :data:`sys.platform` from ``"linux"`` to
  ``"android"``.

- gh-116117: Backport ``libb2``'s PR #42 to fix compiling CPython on 32-bit
  Windows with ``clang-cl``.

- gh-71052: Fix several Android build issues

- gh-114099: A testbed project was added to run the test suite on iOS.

- gh-115350: Fix building ctypes module with -DWIN32_LEAN_AND_MEAN defined

- gh-111225: Link extension modules against libpython on Android.

- gh-115737: The install name for libPython is now correctly set for
  non-framework macOS builds.

- gh-114099: Makefile targets were added to support compiling an
  iOS-compatible framework build.

Windows
-------

- gh-116012: Ensure the value of ``GetLastError()`` is preserved across GIL
  operations.

- gh-115582: Building extensions intended for free-threaded builds of
  CPython now require compiling with ``/DPy_GIL_DISABLED`` manually when
  using a regular install. This is expected to change in future releases.

- gh-115554: The installer now has more strict rules about updating the
  :ref:`launcher`. In general, most users only have a single launcher
  installed and will see no difference. When multiple launchers have been
  installed, the option to install the launcher is disabled until all but
  one have been removed. Downgrading the launcher (which was never allowed)
  is now more obviously blocked.

- gh-115543: :ref:`launcher` can now detect Python 3.13 when installed from
  the Microsoft Store, and will install Python 3.12 by default when
  :envvar:`PYLAUNCHER_ALLOW_INSTALL` is set.

macOS
-----

- gh-116145: Update macOS installer to Tcl/Tk 8.6.14.

IDLE
----

- gh-88516: On macOS show a proxy icon in the title bar of editor windows to
  match platform behaviour.

Tools/Demos
-----------

- gh-100176: Remove outdated Tools/{io,cc,string}bench

- bpo-45101: Add consistency in usage message IO between 2 versions of
  python-config.

C API
-----

- gh-114626: Add again ``_PyCFunctionFastWithKeywords`` name, removed in
  Python 3.13 alpha 4 by mistake.  Keep the old private
  ``_PyCFunctionFastWithKeywords`` name (Python 3.7) as an alias to the new
  public name ``PyCFunctionFastWithKeywords`` (Python 3.13a4). Patch by
  Victor Stinner.

- gh-111418: Add :c:macro:`PyHASH_MODULUS`, :c:macro:`PyHASH_BITS`,
  :c:macro:`PyHASH_INF` and :c:macro:`PyHASH_IMAG` C macros.  Patch by
  Sergey B Kirpichev.


What's New in Python 3.13.0 alpha 4?
====================================

*Release date: 2024-02-15*

Security
--------

- gh-115399: Update bundled libexpat to 2.6.0

- gh-115243: Fix possible crashes in :meth:`collections.deque.index` when
  the deque is concurrently modified.

Core and Builtins
-----------------

- gh-112087: For an empty reverse iterator for list will be reduced to
  :func:`reversed`. Patch by Donghee Na

- gh-114570: Add :exc:`PythonFinalizationError` exception. This exception
  derived from :exc:`RuntimeError` is raised when an operation is blocked
  during the :term:`Python finalization <interpreter shutdown>`. Patch by
  Victor Stinner.

- gh-114695: Add :func:`sys._clear_internal_caches`, which clears all
  internal performance-related caches (and deprecate the less-general
  :func:`sys._clear_type_cache` function).

- gh-114828: Fix compilation crashes in uncommon code examples using
  :func:`super` inside a comprehension in a class body.

- gh-112069: Adapt :class:`set` and :class:`frozenset` methods to Argument
  Clinic.

- gh-115011: Setters for members with an unsigned integer type now support
  the same range of valid values for objects that has a
  :meth:`~object.__index__` method as for :class:`int`.

- gh-114887: Changed socket type validation in
  :meth:`~asyncio.loop.create_datagram_endpoint` to accept all non-stream
  sockets. This fixes a regression in compatibility with raw sockets.

- gh-114944: Fixes a race between ``PyParkingLot_Park`` and
  ``_PyParkingLot_UnparkAll``.

- gh-113462: Limit the number of versions that a single class can use.
  Prevents a few wayward classes using up all the version numbers.

- gh-76763: The :func:`chr` builtin function now always raises
  :exc:`ValueError` for values outside the valid range. Previously it raised
  :exc:`OverflowError` for very large or small values.

- gh-114806: No longer specialize calls to classes, if those classes have
  metaclasses. Fixes bug where the ``__call__`` method of the metaclass was
  not being called.

- gh-107944: Improve error message for function calls with bad keyword
  arguments via getargs

- gh-112529: The free-threaded build no longer allocates space for the
  ``PyGC_Head`` structure in objects that support cyclic garbage collection.
  A number of other fields and data structures are used as replacements,
  including ``ob_gc_bits``, ``ob_tid``, and mimalloc internal data
  structures.

- gh-114456: Lower the recursion limit under a debug build of WASI.

- gh-114083: Compiler applies folding of LOAD_CONST with following
  instruction in a separate pass before other optimisations. This enables
  jump threading in certain circumstances.

- gh-114388: Fix a :exc:`RuntimeWarning` emitted when assign an integer-like
  value that is not an instance of :class:`int` to an attribute that
  corresponds to a C struct member of :ref:`type <PyMemberDef-types>` T_UINT
  and T_ULONG. Fix a double :exc:`RuntimeWarning` emitted when assign a
  negative integer value to an attribute that corresponds to a C struct
  member of type T_UINT.

- gh-114265: Compiler propagates line numbers before optimization, leading
  to more optimization opportunities and removing the need for the
  ``guarantee_lineno_for_exits`` hack.

- gh-112529: The free-threaded build now has its own thread-safe GC
  implementation that uses mimalloc to find GC tracked objects. It is
  non-generational, unlike the existing GC implementation.

- gh-114050: Fix segmentation fault caused by an incorrect format string in
  ``TypeError`` exception when more than two arguments are passed to
  ``int``.

- gh-112354: The ``END_FOR`` instruction now pops only one value. This is to
  better support side exits in loops.

- gh-113884: Make :class:`queue.SimpleQueue` thread safe when the GIL is
  disabled.

- gh-114058: Implement the foundations of the Tier 2 redundancy eliminator.

- gh-113939: frame.clear(): Clear frame.f_locals as well, and not only the
  fast locals. This is relevant once frame.f_locals was accessed, which
  would contain also references to all the locals.

- gh-112050: Convert :class:`collections.deque` to use Argument Clinic.

- gh-112050: Make methods on :class:`collections.deque` thread-safe when the
  GIL is disabled.

- gh-113464: Add an option (``--enable-experimental-jit`` for
  ``configure``-based builds or ``--experimental-jit`` for ``PCbuild``-based
  ones) to build an *experimental* just-in-time compiler, based on
  `copy-and-patch <https://fredrikbk.com/publications/copy-and-patch.pdf>`_

- gh-113055: Make interp->obmalloc a pointer. For interpreters that share
  state with the main interpreter, this points to the same static memory
  structure. For interpreters with their own obmalloc state, it is heap
  allocated. Add free_obmalloc_arenas() which will free the obmalloc arenas
  and radix tree structures for interpreters with their own obmalloc state.

- gh-55664: Add warning when creating :class:`type` using a namespace
  dictionary with non-string keys. Patched by Daniel Urban and Furkan Onder.

- gh-104530: Use native Win32 condition variables.

Library
-------

- gh-115392: Fix a bug in :mod:`doctest` where incorrect line numbers would
  be reported for decorated functions.

- gh-114563: Fix several :func:`format` bugs when using the C implementation
  of :class:`~decimal.Decimal`: * memory leak in some rare cases when using
  the ``z`` format option (coerce negative 0) * incorrect output when
  applying the ``z`` format option to type ``F`` (fixed-point with capital
  ``NAN`` / ``INF``) * incorrect output when applying the ``#`` format
  option (alternate form)

- gh-102840: Fix confused traceback when floordiv, mod, or divmod operations
  happens between instances of :class:`fractions.Fraction` and
  :class:`complex`.

- gh-115165: Most exceptions are now ignored when attempting to set the
  ``__orig_class__`` attribute on objects returned when calling
  :mod:`typing` generic aliases (including generic aliases created using
  :data:`typing.Annotated`). Previously only :exc:`AttributeError` was
  ignored. Patch by Dave Shawley.

- gh-112903: Fix "issubclass() arg 1 must be a class" errors in certain
  cases of multiple inheritance with generic aliases (regression in early
  3.13 alpha releases).

- gh-115133: Fix tests for :class:`~xml.etree.ElementTree.XMLPullParser`
  with Expat 2.6.0.

- gh-115059: :meth:`io.BufferedRandom.read1` now flushes the underlying
  write buffer.

- gh-79382: Trailing ``**`` no longer allows to match files and non-existing
  paths in recursive :func:`~glob.glob`.

- gh-67837: Avoid race conditions in the creation of directories during
  concurrent extraction in :mod:`tarfile` and :mod:`zipfile`.

- gh-115060: Speed up :meth:`pathlib.Path.glob` by removing redundant regex
  matching.

- gh-97928: Partially revert the behavior of :meth:`tkinter.Text.count`. By
  default it preserves the behavior of older Python versions, except that
  setting ``wantobjects`` to 0 no longer has effect. Add a new parameter
  *return_ints*: specifying ``return_ints=True`` makes ``Text.count()``
  always returning the single count as an integer instead of a 1-tuple or
  ``None``.

- gh-114628: When csv.Error is raised when handling TypeError, do not print
  the TypeError traceback.

- gh-85984: Added ``_POSIX_VDISABLE`` from C's ``<unistd.h>`` to
  :mod:`termios`.

- gh-114965: Update bundled pip to 24.0

- gh-114959: :mod:`tarfile` no longer ignores errors when trying to extract
  a directory on top of a file.

- gh-114894: Add :meth:`array.array.clear`.

- gh-114071: Support tuple subclasses using auto() for enum member value.

- gh-109475: Fix support of explicit option value "--" in :mod:`argparse`
  (e.g. ``--option=--``).

- gh-49766: Fix :class:`~datetime.date`-:class:`~datetime.datetime`
  comparison. Now the special comparison methods like ``__eq__`` and
  ``__lt__`` return :data:`NotImplemented` if one of comparands is
  :class:`!date` and other is :class:`!datetime` instead of ignoring the
  time part and the time zone or forcefully return "not equal" or raise
  :exc:`TypeError`. It makes comparison of :class:`!date` and
  :class:`!datetime` subclasses more symmetric and allows to change the
  default behavior by overriding the special comparison methods in
  subclasses.

- gh-110190: Fix ctypes structs with array on Windows ARM64 platform by
  setting ``MAX_STRUCT_SIZE`` to 32 in stgdict. Patch by Diego Russo

- gh-114678: Ensure that deprecation warning for 'N' specifier in
  :class:`~decimal.Decimal` format is not raised for cases where 'N' appears
  in other places in the format specifier. Based on patch by Stefan Krah.

- gh-70303: Return both files and directories from :meth:`pathlib.Path.glob`
  if a pattern ends with "``**``". Previously only directories were
  returned.

- gh-109653: Improve import time of :mod:`importlib.metadata` and
  :mod:`email.utils`.

- gh-113280: Fix a leak of open socket in rare cases when error occurred in
  :class:`ssl.SSLSocket` creation.

- gh-77749: :meth:`email.policy.EmailPolicy.fold` now always encodes
  non-ASCII characters in headers if :attr:`~email.policy.EmailPolicy.utf8`
  is false.

- gh-83383: Synchronization of the :mod:`dbm.dumb` database is now no-op if
  there was no modification since opening or last synchronization. The
  directory file for a newly created empty :mod:`dbm.dumb` database is now
  created immediately after opening instead of deferring this until
  synchronizing or closing.

- gh-91602: Add *filter* keyword-only parameter to
  :meth:`sqlite3.Connection.iterdump` for filtering database objects to
  dump. Patch by Mariusz Felisiak.

- gh-112451: Prohibit subclassing pure-Python :class:`datetime.timezone`.
  This is consistent with C-extension implementation. Patch by Mariusz
  Felisiak.

- gh-69893: Add the :meth:`!close` method for the iterator returned by
  :func:`xml.etree.ElementTree.iterparse`.

- gh-109653: Reduce the import time of :mod:`threading` module by ~50%.
  Patch by Daniel Hollas.

- gh-114492: Make the result of :func:`termios.tcgetattr` reproducible on
  Alpine Linux. Previously it could leave a random garbage in some fields.

- gh-114315: Make :class:`threading.Lock` a real class, not a factory
  function. Add ``__new__`` to ``_thread.lock`` type.

- gh-100414: Add :mod:`dbm.sqlite3` as a backend to :mod:`dbm`, and make it
  the new default :mod:`!dbm` backend. Patch by Raymond Hettinger and Erlend
  E. Aasland.

- gh-113267: Revert changes in :gh:`106584` which made calls of
  ``TestResult`` methods ``startTest()`` and ``stopTest()`` unbalanced.

- gh-75128: Ignore an :exc:`OSError` in
  :meth:`asyncio.BaseEventLoop.create_server` when IPv6 is available but the
  interface cannot actually support it.

- gh-114423: ``_DummyThread`` entries in ``threading._active`` are now
  automatically removed when the related thread dies.

- gh-114257: Dismiss the :exc:`FileNotFound` error in
  :func:`ctypes.util.find_library` and just return ``None`` on Linux.

- gh-114321: Expose more platform specific constants in the :mod:`fcntl`
  module on Linux, macOS, FreeBSD and NetBSD.

- gh-114328: The :func:`tty.setcbreak` and new :func:`tty.cfmakecbreak` no
  longer clears the terminal input ICRLF flag. This fixes a regression
  introduced in 3.12 that no longer matched how OSes define cbreak mode in
  their ``stty(1)`` manual pages.

- gh-114281: Remove type hints from ``Lib/asyncio/staggered.py``. The
  annotations in the `typeshed <https://github.com/python/typeshed>`__
  project should be used instead.

- gh-101438: Avoid reference cycle in ElementTree.iterparse. The iterator
  returned by ``ElementTree.iterparse`` may hold on to a file descriptor.
  The reference cycle prevented prompt clean-up of the file descriptor if
  the returned iterator was not exhausted.

- gh-114198: The signature for the ``__replace__`` method on
  :mod:`dataclasses` now has the first argument named ``self``, rather than
  ``obj``.

- gh-104522: :exc:`OSError` raised when run a subprocess now only has
  *filename* attribute set to *cwd* if the error was caused by a failed
  attempt to change the current directory.

- gh-114149: Enum: correctly handle tuple subclasses in custom ``__new__``.

- gh-83648: Support deprecation of options, positional arguments and
  subcommands in :mod:`argparse`.

- gh-114087: Speed up ``dataclasses.asdict`` up to 1.35x.

- gh-109534: Fix a reference leak in
  :class:`asyncio.selector_events.BaseSelectorEventLoop` when SSL handshakes
  fail. Patch contributed by Jamie Phan.

- gh-79634: Accept :term:`path-like objects <path-like object>` as patterns
  in :meth:`pathlib.Path.glob` and :meth:`~pathlib.Path.rglob`.

- gh-112202: Ensure that a :func:`asyncio.Condition.notify` call does not
  get lost if the awakened ``Task`` is simultaneously cancelled or
  encounters any other error.

- gh-113951: Fix the behavior of ``tag_unbind()`` methods of
  :class:`tkinter.Text` and :class:`tkinter.Canvas` classes with three
  arguments. Previously, ``widget.tag_unbind(tag, sequence, funcid)``
  destroyed the current binding for *sequence*, leaving *sequence* unbound,
  and deleted the *funcid* command. Now it removes only *funcid* from the
  binding for *sequence*, keeping other commands, and deletes the *funcid*
  command. It leaves *sequence* unbound only if *funcid* was the last bound
  command.

- gh-97959: Fix rendering class methods, bound methods, method and function
  aliases in :mod:`pydoc`. Class methods no longer have "method of
  builtins.type instance" note. Corresponding notes are now added for class
  and unbound methods. Method and function aliases now have references to
  the module or the class where the origin was defined if it differs from
  the current. Bound methods are now listed in the static methods section.
  Methods of builtin classes are now supported as well as methods of Python
  classes.

- gh-113796: Add more validation checks in the :class:`csv.Dialect`
  constructor. :exc:`ValueError` is now raised if the same character is used
  in different roles.

- gh-113732: Fix support of :data:`~csv.QUOTE_NOTNULL` and
  :data:`~csv.QUOTE_STRINGS` in :func:`csv.reader`.

- gh-113225: Speed up :meth:`pathlib.Path.walk` by using
  :attr:`os.DirEntry.path` where possible.

- gh-89039: When replace() method is called on a subclass of datetime, date
  or time, properly call derived constructor. Previously, only the base
  class's constructor was called.

  Also, make sure to pass non-zero fold values when creating subclasses in
  various methods. Previously, fold was silently ignored.

- gh-112919: Speed-up :func:`datetime.datetime.replace`,
  :func:`datetime.date.replace` and :func:`datetime.time.replace`.

- gh-59013: Set breakpoint on the first executable line of the function,
  instead of the line of function definition when the user do ``break func``
  using :mod:`pdb`

- gh-112343: Improve handling of pdb convenience variables to avoid
  replacing string contents.

- gh-112240: Add option to calendar module CLI to specify the weekday to
  start each week. Patch by Steven Ward.

- gh-111741: Recognise ``image/webp`` as a standard format in the
  :mod:`mimetypes` module.

- gh-43457: Fix the :mod:`tkinter` widget method :meth:`!wm_attributes`. It
  now accepts the attribute name without the minus prefix to get window
  attributes and allows to specify attributes and values to set as keyword
  arguments. Add new optional keyword argument *return_python_dict*: calling
  ``w.wm_attributes(return_python_dict=True)`` returns the attributes as a
  dict instead of a tuple. Calling ``w.wm_attributes()`` now returns a tuple
  instead of string if *wantobjects* was set to 0.

- gh-82626: Many functions now emit a warning if a boolean value is passed
  as a file descriptor argument.

- gh-111051: Added check for file modification during debugging with
  :mod:`pdb`

- gh-110345: Show the Tcl/Tk patchlevel (rather than version) in
  :meth:`tkinter._test`.

- gh-38807: Fix race condition in :mod:`trace`. Instead of checking if a
  directory exists and creating it, directly call :func:`os.makedirs` with
  the kwarg ``exist_ok=True``.

- gh-75705: Set unixfrom envelope in :class:`mailbox.mbox` and
  :class:`mailbox.MMDF`.

- gh-106233: Fix stacklevel in ``InvalidTZPathWarning`` during
  :mod:`zoneinfo` module import.

- gh-105102: Allow :class:`ctypes.Union` to be nested in
  :class:`ctypes.Structure` when the system endianness is the opposite of
  the classes.

- gh-104282: Fix null pointer dereference in
  :func:`lzma._decode_filter_properties` due to improper handling of BCJ
  filters with properties of zero length. Patch by Radislav Chugunov.

- gh-96471: Add :py:class:`queue.Queue` termination with
  :py:meth:`~queue.Queue.shutdown`.

- gh-101599: Changed argparse flag options formatting to remove redundancy.

- gh-85984: Add POSIX pseudo-terminal functions :func:`os.posix_openpt`,
  :func:`os.grantpt`, :func:`os.unlockpt`, and :func:`os.ptsname`.

- gh-102512: When :func:`os.fork` is called from a foreign thread (aka
  ``_DummyThread``), the type of the thread in a child process is changed to
  ``_MainThread``. Also changed its name and daemonic status, it can be now
  joined.

- gh-88569: Add :func:`os.path.isreserved`, which identifies reserved
  pathnames such as "NUL", "AUX" and "CON". This function is only available
  on Windows.

  Deprecate :meth:`pathlib.PurePath.is_reserved`.

- bpo-38364: The ``inspect`` functions ``isgeneratorfunction``,
  ``iscoroutinefunction``, ``isasyncgenfunction`` now support
  ``functools.partialmethod`` wrapped functions the same way they support
  ``functools.partial``.

Documentation
-------------

- gh-115233: Fix an example for :class:`~logging.LoggerAdapter` in the
  Logging Cookbook.

- gh-114123: Move the :mod:`csv` module docstring to the :mod:`!csv` module
  instead of reexporting it from the internal :mod:`!_csv` module, and
  remove ``__doc__`` from ``csv.__all__``.

  Move :attr:`!csv.__version__` to the :mod:`!csv` module instead of
  reexporting it from the internal :mod:`!_csv` module, and remove
  ``__version__`` from ``csv.__all__``.

Tests
-----

- gh-114099: Added test exclusions required to run the test suite on iOS.

- gh-105089: Fix
  ``test.test_zipfile.test_core.TestWithDirectory.test_create_directory_with_write``
  test in AIX by doing a bitwise AND of 0xFFFF on mode , so that it will be
  in sync with ``zinfo.external_attr``

Build
-----

- gh-115167: Avoid vendoring ``vcruntime140_threads.dll`` when building with
  Visual Studio 2022 version 17.8.

- gh-113632: Promote WASI to a tier 2 platform and drop Emscripten from tier
  3 in configure.ac.

- gh-114099: configure and Makefile were refactored to accommodate framework
  builds on Apple platforms other than macOS.

- gh-114875: Add :c:func:`!getgrent` as a prerequisite for building the
  :mod:`grp` module.

Windows
-------

- gh-115049: Fixes ``py.exe`` launcher failing when run as users without
  user profiles.

- gh-115009: Update Windows installer to use SQLite 3.45.1.

- gh-109991: Update Windows build to use OpenSSL 3.0.13.

- gh-111239: Update Windows builds to use zlib v1.3.1.

- gh-100107: The ``py.exe`` launcher will no longer attempt to run the
  Microsoft Store redirector when launching a script containing a
  ``/usr/bin/env`` shebang

- gh-112984: Adds free-threaded binaries to Windows installer as an optional
  component.

- gh-89240: Allows :mod:`multiprocessing` to create pools of greater than 62
  processes.

macOS
-----

- gh-115009: Update macOS installer to use SQLite 3.45.1.

- gh-109991: Update macOS installer to use OpenSSL 3.0.13.

- gh-114490: Add Mach-O linkage support for :func:`platform.architecture`.

- gh-87804: On macOS the result of ``os.statvfs`` and ``os.fstatvfs`` now
  correctly report the size of very large disks, in previous versions the
  reported number of blocks was wrong for disks with at least 2**32 blocks.

IDLE
----

- gh-96905: In idlelib code, stop redefining built-ins 'dict' and 'object'.

- gh-103820: Revise IDLE bindings so that events from mouse button 4/5 on
  non-X11 windowing systems (i.e. Win32 and Aqua) are not mistaken for
  scrolling.

Tools/Demos
-----------

- gh-113516: Don't set ``LDSHARED`` when building for WASI.

- gh-109991: Update GitHub CI workflows to use OpenSSL 3.0.13 and
  multissltests to use 1.1.1w, 3.0.13, 3.1.5, and 3.2.1.

- gh-115015: Fix a bug in Argument Clinic that generated incorrect code for
  methods with no parameters that use the :ref:`METH_METHOD | METH_FASTCALL
  | METH_KEYWORDS <METH_METHOD-METH_FASTCALL-METH_KEYWORDS>` calling
  convention. Only the positional parameter count was checked; any keyword
  argument passed would be silently accepted.

C API
-----

- gh-111140: Adds :c:func:`PyLong_AsNativeBytes`,
  :c:func:`PyLong_FromNativeBytes` and
  :c:func:`PyLong_FromUnsignedNativeBytes` functions.

- gh-114685: :c:func:`PyBuffer_FillInfo` now raises a :exc:`SystemError` if
  called with :c:macro:`PyBUF_READ` or :c:macro:`PyBUF_WRITE` as flags.
  These flags should only be used with the ``PyMemoryView_*`` C API.

- gh-114685: :c:func:`PyObject_GetBuffer` now raises a :exc:`SystemError` if
  called with :c:macro:`PyBUF_READ` or :c:macro:`PyBUF_WRITE` as flags.
  These flags should only be used with the ``PyMemoryView_*`` C API.

- gh-114626: Add ``PyCFunctionFast`` and ``PyCFunctionFastWithKeywords``
  typedefs (identical to the existing ``_PyCFunctionFast`` and
  ``_PyCFunctionFastWithKeywords`` typedefs, just without a leading ``_``
  prefix).

- gh-114329: Add :c:func:`PyList_GetItemRef`, which is similar to
  :c:func:`PyList_GetItem` but returns a :term:`strong reference` instead of
  a :term:`borrowed reference`.

- gh-110850: Add PyTime C API:

  * :c:type:`PyTime_t` type.
  * :c:var:`PyTime_MIN` and :c:var:`PyTime_MAX` constants.
  * :c:func:`PyTime_AsSecondsDouble`,
    :c:func:`PyTime_Monotonic`, :c:func:`PyTime_PerfCounter`, and
    :c:func:`PyTime_Time` functions.

  Patch by Victor Stinner.

- gh-112066: Add :c:func:`PyDict_SetDefaultRef`: insert a key and value into
  a dictionary if the key is not already present. This is similar to
  :meth:`dict.setdefault`, but returns an integer value indicating if the
  key was already present. It is also similar to
  :c:func:`PyDict_SetDefault`, but returns a strong reference instead of a
  borrowed reference.


What's New in Python 3.13.0 alpha 3?
====================================

*Release date: 2024-01-17*

Security
--------

- gh-113659: Skip ``.pth`` files with names starting with a dot or hidden
  file attribute.

- gh-112302: Created a Software Bill-of-Materials document and tooling for
  tracking dependencies.

Core and Builtins
-----------------

- gh-107901: Compiler duplicates basic blocks that have an eval breaker
  check, no line number, and multiple predecessors.

- gh-107901: A jump leaving an exception handler back to normal code no
  longer checks the eval breaker.

- gh-113655: Set the C recursion limit to 4000 on Windows, and 10000 on
  Linux/OSX. This seems to be near the sweet spot to maintain safety, but
  not compromise backwards compatibility.

- gh-113710: Add typed stack effects to the interpreter DSL, along with
  various instruction annotations.

- gh-77046: On Windows, file descriptors wrapping Windows handles are now
  created non inheritable by default (:pep:`446`). Patch by Zackery Spytz
  and Victor Stinner.

- gh-113853: Guarantee that all executors make progress. This then
  guarantees that tier 2 execution always makes progress.

- gh-113753: Fix an issue where the finalizer of ``PyAsyncGenASend`` objects
  might not be called if they were allocated from a free list.

- gh-107901: Compiler changed so that synthetic jumps which are not at loop
  end no longer check the eval breaker.

- gh-113703: Fix a regression in the :mod:`codeop` module that was causing
  it to incorrectly identify incomplete f-strings. Patch by Pablo Galindo

- gh-89811: Check for a valid ``tp_version_tag`` before performing bytecode
  specializations that rely on this value being usable.

- gh-111488: Changed error message in case of no 'in' keyword after 'for' in
  list comprehensions

- gh-113657: Fix an issue that caused important instruction pointer updates
  to be optimized out of tier two traces.

- gh-113603: Fixed bug where a redundant NOP is not removed, causing an
  assertion to fail in the compiler in debug mode.

- gh-113602: Fix an error that was causing the parser to try to overwrite
  existing errors and crashing in the process. Patch by Pablo Galindo

- gh-113486: No longer issue spurious ``PY_UNWIND`` events for optimized
  calls to classes.

- gh-113297: Fix segfault in the compiler on with statement with 19 context
  managers.

- gh-113212: Improve :py:class:`super` error messages.

- gh-111375: Only use ``NULL`` in the exception stack to indicate an
  exception was handled. Patch by Carey Metcalfe.

- gh-112215: Increase the C recursion limit by a factor of 3 for non-debug
  builds, except for webassembly and s390 platforms which are unchanged.
  This mitigates some regressions in 3.12 with deep recursion mixing builtin
  (C) and Python code.

- gh-113054: Fixed bug where a redundant NOP is not removed, causing an
  assertion to fail in the compiler in debug mode.

- gh-106905: Use per AST-parser state rather than global state to track
  recursion depth within the AST parser to prevent potential race condition
  due to simultaneous parsing.

  The issue primarily showed up in 3.11 by multithreaded users of
  :func:`ast.parse`.  In 3.12 a change to when garbage collection can be
  triggered prevented the race condition from occurring.

- gh-108866: Change the API and contract of ``_PyExecutorObject`` to return
  the next_instr pointer, instead of the frame, and to always execute at
  least one instruction.

- gh-90350: Optimize builtin functions :func:`min` and :func:`max`.

- gh-112943: Correctly compute end column offsets for multiline tokens in
  the :mod:`tokenize` module. Patch by Pablo Galindo

- gh-112125: Fix ``None.__ne__(None)`` returning ``NotImplemented`` instead
  of ``False``.

- gh-74616: :func:`input` now raises a ValueError when output on the
  terminal if the prompt contains embedded null characters instead of
  silently truncating it.

- gh-112716: Fix SystemError in the ``import`` statement and in
  ``__reduce__()`` methods of builtin types when ``__builtins__`` is not a
  dict.

- gh-112730: Use color to highlight error locations in tracebacks. Patch by
  Pablo Galindo

- gh-112625: Fixes a bug where a bytearray object could be cleared while
  iterating over an argument in the ``bytearray.join()`` method that could
  result in reading memory after it was freed.

- gh-112660: Do not clear unexpected errors during formatting error messages
  for ImportError and AttributeError for modules.

- gh-105967: Workaround a bug in Apple's macOS platform zlib library where
  :func:`zlib.crc32` and :func:`binascii.crc32` could produce incorrect
  results on multi-gigabyte inputs. Including when using :mod:`zipfile` on
  zips containing large data.

- gh-95754: Provide a better error message when accessing invalid attributes
  on partially initialized modules. The origin of the module being accessed
  is now included in the message to help with the common issue of shadowing
  other modules.

- gh-112217: Add check for the type of ``__cause__`` returned from calling
  the type ``T`` in ``raise from T``.

- gh-111058: Change coro.cr_frame/gen.gi_frame to return ``None`` after the
  coroutine/generator has been closed. This fixes a bug where
  :func:`~inspect.getcoroutinestate` and :func:`~inspect.getgeneratorstate`
  return the wrong state for a closed coroutine/generator.

- gh-112388: Fix an error that was causing the parser to try to overwrite
  tokenizer errors. Patch by pablo Galindo

- gh-112387: Fix error positions for decoded strings with backwards tokenize
  errors. Patch by Pablo Galindo

- gh-99606: Make code generated for an empty f-string identical to the code
  of an empty normal string.

- gh-112367: Avoid undefined behaviour when using the perf trampolines by
  not freeing the code arenas until shutdown. Patch by Pablo Galindo

- gh-112320: The Tier 2 translator now tracks the confidence level for
  staying "on trace" (i.e. not exiting back to the Tier 1 interpreter) for
  branch instructions based on the number of bits set in the branch
  "counter". Trace translation ends when the confidence drops below 1/3rd.

- gh-109598:
  :c:func:`PyComplex_RealAsDouble`/:c:func:`PyComplex_ImagAsDouble` now
  tries to convert an object to a :class:`complex` instance using its
  ``__complex__()`` method before falling back to the ``__float__()``
  method. Patch by Sergey B Kirpichev.

- gh-94606: Fix UnicodeEncodeError when :func:`email.message.get_payload`
  reads a message with a Unicode surrogate character and the message content
  is not well-formed for surrogateescape encoding. Patch by Sidney
  Markowitz.

- bpo-21861: Use the object's actual class name in
  :meth:`!_io.FileIO.__repr__`, :meth:`!_io._WindowsConsoleIO` and
  :meth:`!_io.TextIOWrapper.__repr__`, to make these methods subclass
  friendly.

- bpo-45369: Remove LibreSSL workarounds as per :pep:`644`.

- bpo-34392: Added :func:`sys._is_interned`.

Library
-------

- gh-114077: Fix possible :exc:`OverflowError` in
  :meth:`socket.socket.sendfile` when pass *count* larger than 2 GiB on
  32-bit platform.

- gh-111803: :mod:`plistlib` now supports loading more deeply nested lists
  in binary format.

- gh-114014: Fixed a bug in :class:`fractions.Fraction` where an invalid
  string using ``d`` in the decimals part creates a different error compared
  to other invalid letters/characters. Patch by Jeremiah Gabriel Pascual.

- gh-108364: :meth:`sqlite3.Connection.iterdump` now ensures that foreign
  key support is disabled before dumping the database schema, if there is
  any foreign key violation. Patch by Erlend E. Aasland and Mariusz
  Felisiak.

- gh-113971: The :class:`zipfile.ZipInfo` previously protected
  ``._compresslevel`` attribute has been made public as ``.compress_level``
  with the old ``_compresslevel`` name remaining available as a property to
  retain compatibility.

- gh-113877: Fix :mod:`tkinter` method ``winfo_pathname()`` on 64-bit
  Windows.

- gh-113868: Added :data:`mmap.MAP_NORESERVE`, :data:`mmap.MAP_NOEXTEND`,
  :data:`mmap.MAP_HASSEMAPHORE`, :data:`mmap.MAP_NOCACHE`,
  :data:`mmap.MAP_JIT`, :data:`mmap.MAP_RESILIENT_CODESIGN`,
  :data:`mmap.MAP_RESILIENT_MEDIA`, :data:`mmap.MAP_32BIT`,
  :data:`mmap.MAP_TRANSLATED_ALLOW_EXECUTE`, :data:`mmap.MAP_UNIX03` and
  :data:`mmap.MAP_TPRO`. All of them are ``mmap(2)`` flags on macOS.

- gh-113848: :func:`asyncio.TaskGroup` and :func:`asyncio.timeout` context
  managers now handle :exc:`~asyncio.CancelledError` subclasses as well as
  exact :exc:`!CancelledError`.

- gh-113661: unittest runner: Don't exit 5 if tests were skipped. The
  intention of exiting 5 was to detect issues where the test suite wasn't
  discovered at all. If we skipped tests, it was correctly discovered.

- gh-96037: Insert :exc:`TimeoutError` in the context of the exception that
  was raised during exiting an expired :func:`asyncio.timeout` block.

- gh-113781: Silence unraisable AttributeError when warnings are emitted
  during Python finalization.

- gh-113238: Add ``Anchor`` to ``importlib.resources`` (in order for the
  code to comply with the documentation)

- gh-111693: :func:`asyncio.Condition.wait` now re-raises the same
  :exc:`CancelledError` instance that may have caused it to be interrupted.
  Fixed race condition in :func:`asyncio.Semaphore.acquire` when interrupted
  with a :exc:`CancelledError`.

- gh-113791: Add ``CLOCK_MONOTONIC_RAW_APPROX`` and
  ``CLOCK_UPTIME_RAW_APPROX`` to :mod:`time` on macOS. These are clocks
  available on macOS 10.12 or later.

- gh-112932: Restore the ability for :mod:`zipfile` to ``extractall`` from
  zip files with a "/" directory entry in them as is commonly added to zips
  by some wiki or bug tracker data exporters.

- gh-113568: Raise deprecation warnings from :class:`pathlib.PurePath` and
  not its private base class ``PurePathBase``.

- gh-113594: Fix :exc:`UnicodeEncodeError` in :mod:`email` when re-fold
  lines that contain unknown-8bit encoded part followed by non-unknown-8bit
  encoded part.

- gh-113538: In :meth:`asyncio.StreamReaderProtocol.connection_made`, there
  is callback that logs an error if the task wrapping the "connected
  callback" fails. This callback would itself fail if the task was
  cancelled. Prevent this by checking whether the task was cancelled first.
  If so, close the transport but don't log an error.

- gh-113626: Add support for the *allow_code* argument in the :mod:`marshal`
  module. Passing ``allow_code=False`` prevents serialization and
  de-serialization of code objects which is incompatible between Python
  versions.

- gh-85567: Fix resource warnings for unclosed files in :mod:`pickle` and
  :mod:`pickletools` command line interfaces.

- gh-113537: Support loads ``str`` in :func:`plistlib.loads`.

- gh-89850: Add default implementations of
  :meth:`pickle.Pickler.persistent_id` and
  :meth:`pickle.Unpickler.persistent_load` methods in the C implementation.
  Calling ``super().persistent_id()`` and ``super().persistent_load()`` in
  subclasses of the C implementation of :class:`pickle.Pickler` and
  :class:`pickle.Unpickler` classes no longer causes infinite recursion.

- gh-113569: Indicate if there were no actual calls in unittest
  :meth:`~unittest.mock.Mock.assert_has_calls` failure.

- gh-101225: Increase the backlog for
  :class:`multiprocessing.connection.Listener` objects created by
  :mod:`multiprocessing.manager` and :mod:`multiprocessing.resource_sharer`
  to significantly reduce the risk of getting a connection refused error
  when creating a :class:`multiprocessing.connection.Connection` to them.

- gh-113568: Raise audit events from :class:`pathlib.Path` and not its
  private base class ``PathBase``.

- gh-113543: Make sure that ``webbrowser.MacOSXOSAScript`` sends
  ``webbrowser.open`` audit event.

- gh-113028: When a second reference to a string appears in the input to
  :mod:`pickle`, and the Python implementation is in use, we are guaranteed
  that a single copy gets pickled and a single object is shared when
  reloaded. Previously, in protocol 0, when a string contained certain
  characters (e.g. newline) it resulted in duplicate objects.

- gh-113421: Fix multiprocessing logger for ``%(filename)s``.

- gh-111784: Fix segfaults in the ``_elementtree`` module. Fix first
  segfault during deallocation of ``_elementtree.XMLParser`` instances by
  keeping strong reference to ``pyexpat`` module in module state for capsule
  lifetime. Fix second segfault which happens in the same deallocation
  process  by keeping strong reference to ``_elementtree`` module in
  ``XMLParser`` structure for ``_elementtree`` module lifetime.

- gh-113407: Fix import of :mod:`unittest.mock` when CPython is built
  without docstrings.

- gh-113320: Fix regression in Python 3.12 where :class:`~typing.Protocol`
  classes that were not marked as :func:`runtime-checkable
  <typing.runtime_checkable>` would be unnecessarily introspected,
  potentially causing exceptions to be raised if the protocol had
  problematic members. Patch by Alex Waygood.

- gh-53502: Add a new option ``aware_datetime`` in :mod:`plistlib` to loads
  or dumps aware datetime.

- gh-113358: Fix rendering tracebacks with exceptions with a broken
  __getattr__

- gh-113214: Fix an ``AttributeError`` during asyncio SSL protocol aborts in
  SSL-over-SSL scenarios.

- gh-113246: Update bundled pip to 23.3.2.

- gh-87264: Fixed tarfile list() method to show file type.

- gh-112182: :meth:`asyncio.futures.Future.set_exception` now transforms
  :exc:`StopIteration` into :exc:`RuntimeError` instead of hanging or other
  misbehavior. Patch contributed by Jamie Phan.

- gh-113225: Speed up :meth:`pathlib.Path.glob` by using
  :attr:`os.DirEntry.path` where possible.

- gh-113149: Improve error message when a JSON array or object contains a
  trailing comma. Patch by Carson Radtke.

- gh-113117: The :mod:`subprocess` module can now use the
  :func:`os.posix_spawn` function with ``close_fds=True`` on platforms where
  ``posix_spawn_file_actions_addclosefrom_np`` is available. Patch by Jakub
  Kulik.

- gh-113199: Make ``http.client.HTTPResponse.read1`` and
  ``http.client.HTTPResponse.readline`` close IO after reading all data when
  content length is known. Patch by Illia Volochii.

- gh-113191: Add support of :func:`os.fchmod` and a file descriptor in
  :func:`os.chmod` on Windows.

- gh-113188: Fix :func:`shutil.copymode` and :func:`shutil.copystat` on
  Windows. Previously they worked differently if *dst* is a symbolic link:
  they modified the permission bits of *dst* itself rather than the file it
  points to if *follow_symlinks* is true or *src* is not a symbolic link,
  and did not modify the permission bits if *follow_symlinks* is false and
  *src* is a symbolic link.

- gh-113119: :func:`os.posix_spawn` now accepts ``env=None``, which makes
  the newly spawned process use the current process environment. Patch by
  Jakub Kulik.

- gh-113202: Add a ``strict`` option to ``batched()`` in the ``itertools``
  module.

- gh-61648: Detect line numbers of properties in doctests.

- gh-113175: Sync with importlib_metadata 7.0, including improved type
  annotations, fixed issue with symlinked packages in
  ``package_distributions``, added ``EntryPoints.__repr__``, introduced the
  ``diagnose`` script, added ``Distribution.origin`` property, and removed
  deprecated ``EntryPoint`` access by numeric index (tuple behavior).

- gh-59616: Add support of :func:`os.lchmod` and the *follow_symlinks*
  argument in :func:`os.chmod` on Windows. Note that the default value of
  *follow_symlinks* in :func:`!os.lchmod` is ``False`` on Windows.

- gh-112559: :func:`signal.signal` and :func:`signal.getsignal` no longer
  call ``repr`` on callable handlers. :func:`asyncio.run` and
  :meth:`asyncio.Runner.run` no longer call ``repr`` on the task results.
  Patch by Yilei Yang.

- gh-112962: :mod:`dis` module functions add cache information to the
  :class:`~dis.Instruction` instance rather than creating fake
  :class:`~dis.Instruction` instances to represent the cache entries.

- gh-112989: Reduce overhead to connect sockets with :mod:`asyncio`
  SelectorEventLoop.

- gh-112970: Use :c:func:`!closefrom` on Linux where available (e.g.
  glibc-2.34), rather than only FreeBSD.

- gh-110190: Fix ctypes structs with array on PPC64LE platform by setting
  ``MAX_STRUCT_SIZE`` to 64 in stgdict. Patch by Diego Russo.

- gh-112540: The statistics.geometric_mean() function now returns zero for
  datasets containing a zero.  Formerly, it would raise an exception.

- gh-87286: Added :const:`LOG_FTP`, :const:`LOG_NETINFO`,
  :const:`LOG_REMOTEAUTH`, :const:`LOG_INSTALL`, :const:`LOG_RAS`, and
  :const:`LOG_LAUNCHD` tot the :mod:`syslog` module, all of them constants
  on used on macOS.

- gh-112800: Fix :mod:`asyncio` ``SubprocessTransport.close()`` not to throw
  ``PermissionError`` when used with setuid executables.

- gh-51944: Add the following constants to the :mod:`termios` module. These
  values are present in macOS system headers: ``ALTWERASE``, ``B14400``,
  ``B28800``, ``B7200``, ``B76800``, ``CCAR_OFLOW``, ``CCTS_OFLOW``,
  ``CDSR_OFLOW``, ``CDTR_IFLOW``, ``CIGNORE``, ``CRTS_IFLOW``, ``EXTPROC``,
  ``IUTF8``, ``MDMBUF``, ``NL2``, ``NL3``, ``NOKERNINFO``, ``ONOEOT``,
  ``OXTABS``, ``VDSUSP``, ``VSTATUS``.

- gh-79325: Fix an infinite recursion error in
  :func:`tempfile.TemporaryDirectory` cleanup on Windows.

- gh-94692: :func:`shutil.rmtree` now only catches OSError exceptions.
  Previously a symlink attack resistant version of ``shutil.rmtree()`` could
  ignore or pass to the error handler arbitrary exception when invalid
  arguments were provided.

- gh-112736: The use of del-safe symbols in ``subprocess`` was refactored to
  allow for use in cross-platform build environments.

- gh-112727: Speed up :meth:`pathlib.Path.absolute`. Patch by Barney Gale.

- gh-74690: Speedup :func:`issubclass` checks against simple
  :func:`runtime-checkable protocols <typing.runtime_checkable>` by around
  6%. Patch by Alex Waygood.

- gh-74690: Speedup :func:`isinstance` checks by roughly 20% for
  :func:`runtime-checkable protocols <typing.runtime_checkable>` that only
  have one callable member. Speedup :func:`issubclass` checks for these
  protocols by roughly 10%. Patch by Alex Waygood.

- gh-112645: Remove deprecation error on passing ``onerror`` to
  :func:`shutil.rmtree`.

- gh-112640: Add ``kwdefaults`` parameter to :data:`types.FunctionType` to
  set default keyword argument values.

- gh-112622: Ensure ``name`` parameter is passed to event loop in
  :func:`asyncio.create_task`.

- gh-112618: Fix a caching bug relating to :data:`typing.Annotated`.
  ``Annotated[str, True]`` is no longer identical to ``Annotated[str, 1]``.

- gh-112334: Fixed a performance regression in 3.12's :mod:`subprocess` on
  Linux where it would no longer use the fast-path ``vfork()`` system call
  when it could have due to a logic bug, instead falling back to the safe
  but slower ``fork()``.

  Also fixed a second 3.12.0 potential security bug.  If a value of
  ``extra_groups=[]`` was passed to :mod:`subprocess.Popen` or related APIs,
  the underlying ``setgroups(0, NULL)`` system call to clear the groups list
  would not be made in the child process prior to ``exec()``.

  This was identified via code inspection in the process of fixing the first
  bug.

- gh-110190: Fix ctypes structs with array on Arm platform by setting
  ``MAX_STRUCT_SIZE`` to 32 in stgdict. Patch by Diego Russo.

- gh-81194: Fix a crash in :func:`socket.if_indextoname` with specific value
  (UINT_MAX). Fix an integer overflow in :func:`socket.if_indextoname` on
  64-bit non-Windows platforms.

- gh-112578: Fix a spurious :exc:`RuntimeWarning` when executing the
  :mod:`zipfile` module.

- gh-112516: Update the bundled copy of pip to version 23.3.1.

- gh-112510: Add :data:`readline.backend` for the backend readline uses
  (``editline`` or ``readline``)

- gh-112328: [Enum] Make ``EnumDict``, ``EnumDict.member_names``,
  ``EnumType._add_alias_`` and ``EnumType._add_value_alias_`` public.

- gh-112509: Fix edge cases that could cause a key to be present in both the
  ``__required_keys__`` and ``__optional_keys__`` attributes of a
  :class:`typing.TypedDict`. Patch by Jelle Zijlstra.

- gh-101336: Add ``keep_alive`` keyword parameter for
  :meth:`AbstractEventLoop.create_server` and
  :meth:`BaseEventLoop.create_server`.

- gh-63284: Added support for TLS-PSK (pre-shared key) mode to the
  :mod:`ssl` module.

- gh-112414: Fix regression in Python 3.12 where calling :func:`repr` on a
  module that had been imported using a custom :term:`loader` could fail
  with :exc:`AttributeError`. Patch by Alex Waygood.

- gh-112358: Revert change to :class:`struct.Struct` initialization that
  broke some cases of subclassing.

- gh-112405: Optimize :meth:`pathlib.PurePath.relative_to`. Patch by Alex
  Waygood.

- gh-94722: Fix bug where comparison between instances of
  :class:`~doctest.DocTest` fails if one of them has ``None`` as its lineno.

- gh-112361: Speed up a small handful of :mod:`pathlib` methods by removing
  some temporary objects.

- gh-112345: Improve error message when trying to call :func:`issubclass`
  against a :class:`typing.Protocol` that has non-method members. Patch by
  Randolf Scholz.

- gh-112137: Change :mod:`dis` output to display no-lineno as "--" instead
  of "None".

- gh-112332: Deprecate the ``exc_type`` field of
  :class:`traceback.TracebackException`. Add ``exc_type_str`` to replace it.

- gh-81620: Add extra tests for :func:`random.binomialvariate`

- gh-112292: Fix a crash in :mod:`readline` when imported from a sub
  interpreter. Patch by Anthony Shaw

- gh-77621: Slightly improve the import time of the :mod:`pathlib` module by
  deferring some imports. Patch by Barney Gale.

- gh-112137: Change :mod:`dis` output to display logical labels for jump
  targets instead of offsets.

- gh-112139: Add :meth:`Signature.format` to format signatures to string
  with extra options. And use it in :mod:`pydoc` to render more readable
  signatures that have new lines between parameters.

- gh-112105: Make :func:`readline.set_completer_delims` work with libedit

- gh-106922: Display multiple lines with ``traceback`` when errors span
  multiple lines.

- gh-111874: When creating a :class:`typing.NamedTuple` class, ensure
  :func:`~object.__set_name__` is called on all objects that define
  ``__set_name__`` and exist in the values of the ``NamedTuple`` class's
  class dictionary. Patch by Alex Waygood.

- gh-68166: Add support of the "vsapi" element type in
  :meth:`tkinter.ttk.Style.element_create`.

- gh-110275: Named tuple's methods ``_replace()`` and ``__replace__()`` now
  raise TypeError instead of ValueError for invalid keyword arguments.

- gh-99367: Do not mangle ``sys.path[0]`` in :mod:`pdb` if safe_path is set

- gh-111615: Fix a regression caused by a fix to gh-93162 whereby you
  couldn't configure a :class:`QueueHandler` without specifying handlers.

- gh-75666: Fix the behavior of :mod:`tkinter` widget's ``unbind()`` method
  with two arguments. Previously, ``widget.unbind(sequence, funcid)``
  destroyed the current binding for *sequence*, leaving *sequence* unbound,
  and deleted the *funcid* command. Now it removes only *funcid* from the
  binding for *sequence*, keeping other commands, and deletes the *funcid*
  command. It leaves *sequence* unbound only if *funcid* was the last bound
  command.

- gh-67790: Implement basic formatting support (minimum width, alignment,
  fill) for :class:`fractions.Fraction`.

- gh-111049: Fix crash during garbage collection of the :class:`io.BytesIO`
  buffer object.

- gh-102980: Redirect the output of ``interact`` command of :mod:`pdb` to
  the same channel as the debugger. Add tests and improve docs.

- gh-102988: :func:`email.utils.getaddresses` and
  :func:`email.utils.parseaddr` now return ``('', '')`` 2-tuples in more
  situations where invalid email addresses are encountered instead of
  potentially inaccurate values. Add optional *strict* parameter to these
  two functions: use ``strict=False`` to get the old behavior, accept
  malformed inputs. ``getattr(email.utils, 'supports_strict_parsing',
  False)`` can be use to check if the *strict* parameter is available. Patch
  by Thomas Dwyer and Victor Stinner to improve the :cve:`2023-27043` fix.

- gh-52161: :meth:`cmd.Cmd.do_help` now cleans docstrings with
  :func:`inspect.cleandoc` before writing them. Patch by Filip Łapkiewicz.

- gh-82300: Add ``track`` parameter to
  :class:`multiprocessing.shared_memory.SharedMemory` that allows using
  shared memory blocks without having to register with the POSIX resource
  tracker that automatically releases them upon process exit.

- gh-110109: Add private ``pathlib._PurePathBase`` class: a base class for
  :class:`pathlib.PurePath` that omits certain magic methods. It may be made
  public (along with ``_PathBase``) in future.

- gh-109858: Protect :mod:`zipfile` from "quoted-overlap" zipbomb. It now
  raises BadZipFile when try to read an entry that overlaps with other entry
  or central directory.

- gh-109786: Fix possible reference leaks and crash when re-enter the
  ``__next__()`` method of :class:`itertools.pairwise`.

- gh-91539: Small (10 - 20%) and trivial performance improvement of
  :func:`urllib.request.getproxies_environment`, typically useful when there
  are many environment variables to go over.

- gh-103363: Add *follow_symlinks* keyword-only argument to
  :meth:`pathlib.Path.owner` and :meth:`~pathlib.Path.group`, defaulting to
  ``True``.

- gh-102130: Support tab completion in :mod:`cmd` for ``editline``.

- gh-99437: :func:`runpy.run_path` now decodes path-like objects, making
  sure __file__ and sys.argv[0] of the module being run are always strings.

- gh-104003: Add :func:`warnings.deprecated`, a decorator to mark deprecated
  functions to static type checkers and to warn on usage of deprecated
  classes and functions. See :pep:`702`. Patch by Jelle Zijlstra.

- gh-103708: Make hardcoded python name, a configurable parameter so that
  different implementations of python can override it instead of making huge
  diffs in sysconfig.py

- gh-66515: :class:`mailbox.MH` now supports folders that do not contain a
  ``.mh_sequences`` file (e.g. Claws Mail IMAP-cache folders). Patch by
  Serhiy Storchaka.

- gh-83162: Renamed :exc:`!re.error` to :exc:`PatternError` for clarity, and
  kept :exc:`!re.error` for backward compatibility. Patch by Matthias
  Bussonnier and Adam Chhina.

- gh-91133: Fix a bug in :class:`tempfile.TemporaryDirectory` cleanup, which
  now no longer dereferences symlinks when working around file system
  permission errors.

- bpo-43153: On Windows, ``tempfile.TemporaryDirectory`` previously masked a
  ``PermissionError`` with ``NotADirectoryError`` during directory cleanup.
  It now correctly raises ``PermissionError`` if errors are not ignored.
  Patch by Andrei Kulakov and Ken Jin.

- bpo-32731: :func:`getpass.getuser` now raises :exc:`OSError` for all
  failures rather than :exc:`ImportError` on systems lacking the :mod:`pwd`
  module or :exc:`KeyError` if the password database is empty.

- bpo-34321: :class:`mmap.mmap` now has a *trackfd* parameter on Unix; if it
  is ``False``, the file descriptor specified by *fileno* will not be
  duplicated.

- bpo-35332: The :func:`shutil.rmtree` function now ignores errors when
  calling :func:`os.close` when *ignore_errors* is ``True``, and
  :func:`os.close` no longer retried after error.

- bpo-35928: :class:`io.TextIOWrapper` now correctly handles the decoding
  buffer after ``read()`` and ``write()``.

- bpo-26791: :func:`shutil.move` now moves a symlink into a directory when
  that directory is the target of the symlink.  This provides the same
  behavior as the mv shell command.  The previous behavior raised an
  exception.  Patch by Jeffrey Kintscher.

- bpo-41422: Fixed memory leaks of :class:`pickle.Pickler` and
  :class:`pickle.Unpickler` involving cyclic references via the internal
  memo mapping.

- bpo-19821: The :func:`!pydoc.ispackage` function has been deprecated.

- bpo-40262: The :meth:`ssl.SSLSocket.recv_into` method no longer requires
  the *buffer* argument to implement ``__len__`` and supports buffers with
  arbitrary item size.

- bpo-39912: :func:`warnings.filterwarnings` and
  :func:`warnings.simplefilter` now raise appropriate exceptions instead of
  ``AssertionError``. Patch contributed by Rémi Lapeyre.

- bpo-37260: Fixed a race condition in :func:`shutil.rmtree` in which
  directory entries removed by another process or thread while
  ``shutil.rmtree()`` is running can cause it to raise FileNotFoundError.
  Patch by Jeffrey Kintscher.

- bpo-36959: Fix some error messages for invalid ISO format string
  combinations in ``strptime()`` that referred to directives not contained
  in the format string. Patch by Gordon P. Hemsley.

- bpo-18060: Fixed a class inheritance issue that can cause segfaults when
  deriving two or more levels of subclasses from a base class of Structure
  or Union.

- bpo-29779: Add a new :envvar:`PYTHON_HISTORY` environment variable to set
  the location of a ``.python_history`` file.

- bpo-21360: :class:`mailbox.Maildir` now ignores files with a leading dot.

Documentation
-------------

- gh-111699: Relocate ``smtpd`` deprecation notice to its own section rather
  than under ``locale`` in What's New in Python 3.12 document

- gh-110746: Improved markup for valid options/values for methods
  ttk.treeview.column and ttk.treeview.heading, and for Layouts.

- gh-95649: Document that the :mod:`asyncio` module contains code taken from
  `v0.16.0 of the uvloop project
  <https://github.com/MagicStack/uvloop/tree/v0.16.0>`_, as well as the
  required MIT licensing information.

Tests
-----

- gh-111798: Disable ``test_super_deep()`` from ``test_call`` under pydebug
  builds on WASI; the stack depth is too small to make the test useful.

- gh-111801: Lower the recursion limit in ``test_isinstance`` for
  ``test_infinitely_many_bases()``. This prevents a stack overflow on a
  pydebug build of WASI.

- gh-111802: Specify a low recursion depth for ``test_bad_getattr()`` in
  ``test.pickletester`` to avoid exhausting the stack under a pydebug build
  for WASI.

- gh-44626: Fix :func:`os.path.isabs` incorrectly returning ``True`` when
  given a path that starts with exactly one (back)slash on Windows.

  Fix :meth:`pathlib.PureWindowsPath.is_absolute` incorrectly returning
  ``False`` for some paths beginning with two (back)slashes.

- gh-113633: Use module state for the _testcapi extension module.

- gh-109980: Fix ``test_tarfile_vs_tar`` in ``test_shutil`` for macOS, where
  system tar can include more information in the archive than
  :mod:`shutil.make_archive`.

- gh-112769: The tests now correctly compare zlib version when
  :const:`zlib.ZLIB_RUNTIME_VERSION` contains non-integer suffixes. For
  example zlib-ng defines the version as ``1.3.0.zlib-ng``.

- gh-112334: Adds a regression test to verify that ``vfork()`` is used when
  expected by :mod:`subprocess` on vfork enabled POSIX systems (Linux).

- gh-108927: Fixed order dependence in running tests in the same process
  when a test that has submodules (e.g. test_importlib) follows a test that
  imports its submodule (e.g. test_importlib.util) and precedes a test (e.g.
  test_unittest or test_compileall) that uses that submodule.

- bpo-40648: Test modes that file can get with chmod() on Windows.

Build
-----

- gh-114013: Fix ``Tools/wasm/wasi.py`` to not include the path to
  ``python.wasm`` as part of ``HOSTRUNNER``. The environment variable is
  meant to specify how to run the WASI host only, having ``python.wasm`` and
  relevant flags appended to the ``HOSTRUNNER``. This fixes ``make test``
  work.

- gh-113258: Changed the Windows build to write out generated frozen modules
  into the build tree instead of the source tree.

- gh-112305: Fixed the ``check-clean-src`` step performed on out of tree
  builds to detect errant ``$(srcdir)/Python/frozen_modules/*.h`` files and
  recommend appropriate source tree cleanup steps to get a working build
  again.

- gh-112536: Add support for thread sanitizer (TSAN)

- gh-112867: Fix the build for the case that WITH_PYMALLOC_RADIX_TREE=0 set.

- gh-103065: Introduce ``Tools/wasm/wasi.py`` to simplify doing a WASI
  build.

- bpo-11102: The :func:`os.major`, :func:`os.makedev`, and :func:`os.minor`
  functions are now available on HP-UX v3.

- bpo-36351: Do not set ipv6type when cross-compiling.

Windows
-------

- gh-114096: Process privileges that are activated for creating directory
  junctions are now restored afterwards, avoiding behaviour changes in other
  parts of the program.

- gh-111877: :func:`os.stat` calls were returning incorrect time values for
  files that could not be accessed directly.

- gh-111973: Update Windows installer to use SQLite 3.44.2.

- gh-113009: :mod:`multiprocessing`: On Windows, fix a race condition in
  ``Process.terminate()``: no longer set the ``returncode`` attribute to
  always call ``WaitForSingleObject()`` in ``Process.wait()``.  Previously,
  sometimes the process was still running after ``TerminateProcess()`` even
  if ``GetExitCodeProcess()`` is not ``STILL_ACTIVE``. Patch by Victor
  Stinner.

- gh-86179: Fixes path calculations when launching Python on Windows through
  a symlink.

- gh-71383: Update Tcl/Tk in Windows installer to 8.6.13 with a patch to
  suppress incorrect ThemeChanged warnings.

- gh-111650: Ensures the ``Py_GIL_DISABLED`` preprocessor variable is
  defined in :file:`pyconfig.h` so that extension modules written in C are
  able to use it.

- gh-112278: Reduce the time cost for some functions in :mod:`platform` on
  Windows if current user has no permission to the WMI.

- gh-73427: Deprecate :func:`sys._enablelegacywindowsfsencoding`. Use
  :envvar:`PYTHONLEGACYWINDOWSFSENCODING` instead. Patch by Inada Naoki.

- gh-87868: Correctly sort and remove duplicate environment variables in
  :py:func:`!_winapi.CreateProcess`.

- bpo-37308: Fix mojibake in :class:`mmap.mmap` when using a non-ASCII
  *tagname* argument on Windows.

macOS
-----

- gh-113666: Add the following constants to module :mod:`stat`:
  ``UF_SETTABLE``, ``UF_TRACKED``, ``UF_DATAVAULT``, ``SF_SUPPORTED``,
  ``SF_SETTABLE``, ``SF_SYNTHETIC``, ``SF_RESTRICTED``, ``SF_FIRMLINK`` and
  ``SF_DATALESS``. The values ``UF_SETTABLE``, ``SF_SUPPORTED``,
  ``SF_SETTABLE`` and ``SF_SYNTHETIC`` are only available on macOS.

- gh-113536: :func:`os.waitid` is now available on macOS

- gh-110459: Running ``configure ... --with-openssl-rpath=X/Y/Z`` no longer
  fails to detect OpenSSL on macOS.

- gh-74573: Document that :mod:`dbm.ndbm` can silently corrupt DBM files on
  updates when exceeding undocumented platform limits, and can crash
  (segmentation fault) when reading such a corrupted file. (FB8919203)

- gh-65701: The :program:`freeze` tool doesn't work with framework builds of
  Python. Document this and bail out early when running the tool with such a
  build.

- gh-87277: webbrowser: Don't look for X11 browsers on macOS. Those are
  generally not used and probing for them can result in starting XQuartz
  even if it isn't used otherwise.

- gh-111973: Update macOS installer to use SQLite 3.44.2.

- gh-108269: Set ``CFBundleAllowMixedLocalizations`` to true in the
  Info.plist for the framework, embedded Python.app and IDLE.app with
  framework installs on macOS.  This allows applications to pick up the
  user's preferred locale when that's different from english.

- gh-102362: Make sure the result of :func:`sysconfig.get_plaform` includes
  at least a major and minor versions, even if ``MACOSX_DEPLOYMENT_TARGET``
  is set to only a major version during build to match the format expected
  by pip.

- gh-110017: Disable a signal handling stress test on macOS due to a bug in
  macOS (FB13453490).

- gh-110820: Make sure the preprocessor definitions for
  ``ALIGNOF_MAX_ALIGN_T``, ``SIZEOF_LONG_DOUBLE`` and
  ``HAVE_GCC_ASM_FOR_X64`` are correct for Universal 2 builds on macOS.

- gh-109981: Use ``/dev/fd`` on macOS to determine the number of open files
  in ``test.support.os_helper.fd_count`` to avoid a crash with "guarded"
  file descriptors when probing for open files.

IDLE
----

- gh-72284: Improve the lists of features, editor key bindings, and shell
  key bingings in the IDLE doc.

- gh-113903: Fix rare failure of test.test_idle, in test_configdialog.

- gh-113729: Fix the "Help -> IDLE Doc" menu bug in 3.11.7 and 3.12.1.

- gh-113269: Fix test_editor hang on macOS Catalina.

- gh-112898: Fix processing unsaved files when quitting IDLE on macOS.

- bpo-13586: Enter the selected text when opening the "Replace" dialog.

C API
-----

- gh-106560: Fix redundant declarations in the public C API. Declare
  PyBool_Type, PyLong_Type and PySys_Audit() only once. Patch by Victor
  Stinner.

- gh-112438: Fix support of format units "es", "et", "es#", and "et#" in
  nested tuples in :c:func:`PyArg_ParseTuple`-like functions.

- gh-111545: Add :c:func:`Py_HashPointer` function to hash a pointer. Patch
  by Victor Stinner.

- gh-65210: Change the declaration of the *keywords* parameter of
  :c:func:`PyArg_ParseTupleAndKeywords` and
  :c:func:`PyArg_VaParseTupleAndKeywords` for better compatibility with C++.


What's New in Python 3.13.0 alpha 2?
====================================

*Release date: 2023-11-22*

Core and Builtins
-----------------

- gh-112243: Don't include comments in f-string debug expressions. Patch by
  Pablo Galindo

- gh-112287: Slightly optimize the Tier 2 (uop) interpreter by only loading
  ``oparg`` and ``operand`` when needed. Also double the trace size limit
  again, to 512 this time.

- gh-112266: Change docstrings of :attr:`~object.__dict__` and
  :attr:`~object.__weakref__`.

- gh-111807: Lower the max parser stack depth to 1000 under WASI debug
  builds.

- gh-111798: When Python is built in debug mode, set the C recursion limit
  to 500 instead of 1500. A debug build is likely built with low
  optimization level which implies higher stack memory usage than a release
  build. Patch by Victor Stinner.

- gh-106529: Enable translating unspecialized ``FOR_ITER`` to Tier 2.

- gh-111916: Make hashlib related modules thread-safe without the GIL

- gh-81137: Deprecate assignment to a function's ``__code__`` field when the
  new code object is of a mismatched type (e.g., from a generator to a plain
  function).

- gh-79932: Raise exception if :meth:`frame.clear` is called on a suspended
  frame.

- gh-81925: Implement native thread ids for GNU KFreeBSD.

- gh-111843: Use exponential backoff to reduce the number of failed tier 2
  optimization attempts by over 99%.

- gh-110829: Joining a thread now ensures the underlying OS thread has
  exited. This is required for safer fork() in multi-threaded processes.

- gh-109369: Make sure that tier 2 traces are de-optimized if the code is
  instrumented

- gh-111772: Specialize slot loads and stores for _Py_T_OBJECT as well as
  Py_T_OBJECT_EX

- gh-111666: Speed up :meth:`BaseExceptionGroup.derive`,
  :meth:`BaseExceptionGroup.subgroup`, and :meth:`BaseExceptionGroup.split`
  by changing how they parse passed arguments.

- gh-111654: Fix runtime crash when some error happens in opcode
  ``LOAD_FROM_DICT_OR_DEREF``.

- gh-111623: Add support for sharing tuples between interpreters using the
  cross-interpreter API.  Patch by Anthony Shaw.

- gh-111354: The oparg of :opcode:`YIELD_VALUE` is now ``1`` if the
  instruction is part of a yield-from or await, and ``0`` otherwise.

  The SUSPENDED frame state is now split into ``SUSPENDED`` and
  ``SUSPENDED_YIELD_FROM``. This simplifies the code in ``_PyGen_yf``.

- gh-111520: Merge the Tier 1 (bytecode) and Tier 2 (micro-ops) interpreters
  together, moving the Tier 2 interpreter loop and switch into
  ``_PyEval_EvalFrameDefault()`` in ``Python/ceval.c``. The
  ``Python/executor.c`` file is gone. Also the ``TIER_ONE`` and ``TIER_TWO``
  macros are now handled by the code generator.

  **Beware!** This changes the environment variables to enable micro-ops and
  their debugging to ``PYTHON_UOPS`` and ``PYTHON_LLTRACE``.

- gh-109181: Speed up :class:`Traceback` object creation by lazily compute
  the line number. Patch by Pablo Galindo

- gh-111420: Allow type comments in parenthesized ``with`` statements

- gh-111438: Add support for sharing floats between interpreters using the
  cross-interpreter API.  Patch by Anthony Shaw.

- gh-111435: Add support for sharing of ``True`` and ``False`` between
  interpreters using the cross-interpreter API.  Patch by Anthony Shaw.

- gh-102388: Fix a bug where ``iso2022_jp_3`` and ``iso2022_jp_2004`` codecs
  read out of bounds

- gh-111366: Fix an issue in the :mod:`codeop` that was causing
  :exc:`SyntaxError` exceptions raised in the presence of invalid syntax to
  not contain precise error messages. Patch by Pablo Galindo

- gh-111380: Fix a bug that was causing :exc:`SyntaxWarning` to appear twice
  when parsing if invalid syntax is encountered later. Patch by Pablo
  galindo

- gh-111374: Added a new environment variable
  :envvar:`PYTHON_FROZEN_MODULES`. It determines whether or not frozen
  modules are ignored by the import machinery, equivalent of the :option:`-X
  frozen_modules <-X>` command-line option.

- gh-111354: Remove ``oparg`` from :opcode:`YIELD_VALUE`. Change ``oparg``
  of :opcode:`RESUME` to include information about the except-depth. These
  changes make it possible to simplify the code in generator close.

- gh-94438: Fix a regression that prevented jumping across ``is None`` and
  ``is not None`` when debugging. Patch by Savannah Ostrowski.

- gh-67224: Show source lines in tracebacks when using the ``-c`` option
  when running Python. Patch by Pablo Galindo

- gh-111123: Fix a bug where a :keyword:`global` declaration in an
  :keyword:`except` block is rejected when the global is used in the
  :keyword:`else` block.

- gh-110938: Fix error messages for indented blocks with functions and
  classes with generic type parameters. Patch by Pablo Galindo

- gh-109214: Remove unnecessary instruction pointer updates before returning
  from frames.

- gh-110912: Correctly display the traceback for :exc:`MemoryError`
  exceptions using the :mod:`traceback` module. Patch by Pablo Galindo

- gh-109894: Fixed crash due to improperly initialized static
  :exc:`MemoryError` in subinterpreter.

- gh-110892: Return ``NULL`` for ``PyTrace_RETURN`` events caused by an
  exception

- gh-110864: Fix argument parsing by ``_PyArg_UnpackKeywordsWithVararg`` for
  functions defining pos-or-keyword, vararg, and kw-only parameters.

- gh-109094: Replace ``prev_instr`` on the interpreter frame by
  ``instr_ptr`` which points to the beginning of the instruction that is
  currently executing (or will execute once the frame resumes).

- gh-110805: Allow the repl to show source code and complete tracebacks.
  Patch by Pablo Galindo

- gh-110722: Add :envvar:`PYTHON_PRESITE=package.module` to import a module
  early in the interpreter lifecycle before ``site.py`` is executed.  Python
  needs to be :ref:`built in debug mode <debug-build>` for this option to
  exist.

- gh-110481: Implement biased reference counting in ``--disable-gil``
  builds.

- gh-110543: Fix regression in Python 3.12 where
  :meth:`types.CodeType.replace` would produce a broken code object if
  called on a module or class code object that contains a comprehension.
  Patch by Jelle Zijlstra.

- gh-89519: Removed chained :class:`classmethod` descriptors (introduced in
  :issue:`19072`).  This can no longer be used to wrap other descriptors
  such as :class:`property`.  The core design of this feature was flawed and
  caused a number of downstream problems.  To "pass-through" a
  :class:`classmethod`, consider using the :attr:`!__wrapped__` attribute
  that was added in Python 3.10.

- gh-103615: Use local events for opcode tracing

- bpo-46657: Add mimalloc memory allocator support.

- gh-106718: When PyConfig.stdlib_dir is explicitly set, it's now respected
  and won't be overridden by PyConfig.home.

- gh-106905: Fix incorrect SystemError about AST constructor recursion depth
  mismatch.

- gh-100445: Improve error message for unterminated strings with escapes.

- bpo-45759: Improved error messages for ``elif``/``else`` statements not
  matching any valid statements. Patch by Jeremiah Vivian.

Library
-------

- gh-111942: Fix SystemError in the TextIOWrapper constructor with
  non-encodable "errors" argument in non-debug mode.

- gh-111995: Added the ``NI_IDN`` constant to the :mod:`socket` module when
  present in C at build time for use with :func:`socket.getnameinfo`.

- gh-109538: Issue warning message instead of having :class:`RuntimeError`
  be displayed when event loop has already been closed at
  :meth:`StreamWriter.__del__`.

- gh-111942: Fix crashes in :meth:`io.TextIOWrapper.reconfigure` when pass
  invalid arguments, e.g. non-string encoding.

- gh-111460: :mod:`curses`: restore wide character support (including
  :func:`curses.unget_wch` and :meth:`~curses.window.get_wch`) on macOS,
  which was unavailable due to a regression in Python 3.12.

- gh-103791: :class:`contextlib.suppress` now supports suppressing
  exceptions raised as part of a :exc:`BaseExceptionGroup`, in addition to
  the recent support for :exc:`ExceptionGroup`.

- gh-111835: The :class:`mmap.mmap` class now has an
  :meth:`~mmap.mmap.seekable` method that can be used when a seekable
  file-like object is required. The :meth:`~mmap.mmap.seek` method now
  returns the new absolute position. Patch by Donghee Na.

- gh-111804: Remove posix.fallocate() under WASI as the underlying
  posix_fallocate() is not available in WASI preview2.

- gh-111841: Fix truncating arguments on an embedded null character in
  :meth:`os.putenv` and :meth:`os.unsetenv` on Windows.

- gh-111768: :func:`wsgiref.util.is_hop_by_hop` is now exposed correctly in
  ``__all__``.

- gh-80731: Avoid executing the default function in :class:`cmd.Cmd` in an
  except block

- gh-111541: Fix :mod:`doctest` for :exc:`SyntaxError` not-builtin
  subclasses.

- gh-111719: Add extra argument validation for ``alias`` command in
  :mod:`pdb`

- gh-111482: :mod:`time`: Make :func:`time.clock_gettime` and
  :func:`time.clock_gettime_ns` functions up to 2x faster by faster calling
  convention. Patch by Victor Stinner.

- gh-110894: Call loop exception handler for exceptions in
  ``client_connected_cb`` of :func:`asyncio.start_server` so that
  applications can handle it. Patch by Kumar Aditya.

- gh-111531: Fix reference leaks in ``bind_class()`` and ``bind_all()``
  methods of :mod:`tkinter` widgets.

- gh-111246: :meth:`asyncio.loop.create_unix_server` will now automatically
  remove the Unix socket when the server is closed.

- gh-111356: Added :func:`io.text_encoding`, :data:`io.DEFAULT_BUFFER_SIZE`,
  and :class:`io.IncrementalNewlineDecoder` to ``io.__all__``.

- gh-66425: Remove the code to set the REMOTE_HOST header from wsgiref
  module, as it is unreachable. This header is used for performance reasons,
  which is not necessary in the wsgiref module.

- gh-111429: Speed up :meth:`pathlib.PurePath.relative_to` and
  :meth:`~pathlib.PurePath.is_relative_to`.

- gh-111342: Fixed typo in :func:`math.sumprod`.

- gh-68166: Remove mention of not supported "vsapi" element type in
  :meth:`tkinter.ttk.Style.element_create`. Add tests for
  ``element_create()`` and other ``ttk.Style`` methods. Add examples for
  ``element_create()`` in the documentation.

- gh-111388: Add ``show_group`` parameter to
  :func:`traceback.format_exception_only`, which allows to format
  :exc:`ExceptionGroup` instances.

- gh-79033: Another attempt at fixing :func:`asyncio.Server.wait_closed`. It
  now blocks until both conditions are true: the server is closed, *and*
  there are no more active connections. (This means that in some cases where
  in 3.12.0 this function would *incorrectly* have returned immediately, it
  will now block; in particular, when there are no active connections but
  the server hasn't been closed yet.)

- gh-111259: Optimize recursive wildcards in :mod:`pathlib`.

- gh-111295: Fix :mod:`time` not checking for errors when initializing.

- gh-111253: Add error checking during :mod:`!_socket` module init.

- gh-111251: Fix :mod:`!_blake2` not checking for errors when initializing.

- gh-111233: Fix :mod:`select` not checking for errors when initializing.

- gh-111230: Fix :mod:`ssl` not checking for errors when initializing.

- gh-111174: Fix crash in :meth:`io.BytesIO.getbuffer` called repeatedly for
  empty BytesIO.

- gh-111187: Postpone removal version for locale.getdefaultlocale() to
  Python 3.15.

- gh-111159: Fix :mod:`doctest` output comparison for exceptions with notes.

- gh-110910: Fix invalid state handling in :class:`asyncio.TaskGroup` and
  :class:`asyncio.Timeout`. They now raise proper RuntimeError if they are
  improperly used and are left in consistent state after this.

- gh-111092: Make turtledemo run without default root enabled.

- gh-110944: Support alias and convenience vars for :mod:`pdb` completion

- gh-110745: Added *newline* parameter to :meth:`pathlib.Path.read_text`.
  Patch by Junya Okabe.

- gh-84583: Make :mod:`pdb` enter post-mortem mode even for
  :exc:`SyntaxError`

- gh-80675: Set ``f_trace_lines = True`` on all frames upon
  :func:`pdb.set_trace`

- gh-110771: Expose the setup and cleanup portions of
  ``asyncio.run_forever()`` as the standalone methods
  ``asyncio.run_forever_setup()`` and ``asyncio.run_forever_cleanup()``.
  This allows for tighter integration with GUI event loops.

- gh-110774: Support setting the :class:`asyncio.Runner` loop_factory kwarg
  in :class:`unittest.IsolatedAsyncioTestCase`

- gh-110392: Fix :func:`tty.setraw` and :func:`tty.setcbreak`: previously
  they returned partially modified list of the original tty attributes.
  :func:`tty.cfmakeraw` and :func:`tty.cfmakecbreak` now make a copy of the
  list of special characters before modifying it.

- gh-59013: Make line number of function breakpoint more precise in
  :mod:`pdb`

- gh-88434: Emit deprecation warning for non-integer numbers in
  :mod:`gettext` functions and methods that consider plural forms even if
  the translation was not found.

- gh-110395: Ensure that :func:`select.kqueue` objects correctly appear as
  closed in forked children, to prevent operations on an invalid file
  descriptor.

- gh-110196: Add ``__reduce__`` method to :class:`IPv6Address` in order to
  keep ``scope_id``

- gh-109747: Improve errors for unsupported look-behind patterns. Now
  re.error is raised instead of OverflowError or RuntimeError for too large
  width of look-behind pattern.

- gh-109466: Add the :attr:`ipaddress.IPv4Address.ipv6_mapped` property,
  which returns the IPv4-mapped IPv6 address.

- gh-85098: Implement the CLI of the :mod:`symtable` module and improve the
  repr of :class:`~symtable.Symbol`.

- gh-108791: Improved error handling in :mod:`pdb` command line interface,
  making it produce more concise error messages.

- gh-105931: Change :mod:`compileall` to only strip the stripdir prefix from
  the full path recorded in the compiled ``.pyc`` file, when the prefix
  matches the start of the full path in its entirety. When the prefix does
  not match, no stripping is performed and a warning to this effect is
  displayed.

  Previously all path components of the stripdir prefix that matched the
  full path were removed, while those that did not match were left alone
  (including ones interspersed between matching components).

- gh-107431: Make the ``DictProxy`` and ``ListProxy`` types in
  :mod:`multiprocessing.managers` :ref:`Generic Alias
  Types<types-genericalias>` for ``[]`` use in typing contexts.

- gh-72904: Add :func:`glob.translate`. This function converts a pathname
  with shell-style wildcards to a regular expression.

- gh-90026: Define ``USE_XATTRS`` on Cygwin so that XATTR-related functions
  in the :mod:`os` module become available.

- gh-90890: New methods :meth:`mailbox.Maildir.get_info`,
  :meth:`mailbox.Maildir.set_info`, :meth:`mailbox.Maildir.get_flags`,
  :meth:`mailbox.Maildir.set_flags`, :meth:`mailbox.Maildir.add_flag`,
  :meth:`mailbox.Maildir.remove_flag`. These methods speed up accessing a
  message's info and/or flags and are useful when it is not necessary to
  access the message's contents, as when iterating over a Maildir to find
  messages with specific flags.

- gh-102956: Fix returning of empty byte strings after seek in zipfile
  module

- gh-102895: Added a parameter ``local_exit`` for :func:`code.interact` to
  prevent ``exit()`` and ``quit`` from closing ``sys.stdin`` and raise
  ``SystemExit``.

- gh-97928: Change the behavior of :meth:`tkinter.Text.count`. It now always
  returns an integer if one or less counting options are specified.
  Previously it could return a single count as a 1-tuple, an integer (only
  if option ``"update"`` was specified) or ``None`` if no items found. The
  result is now the same if ``wantobjects`` is set to ``0``.

- gh-96954: Switch the storage of the unicode codepoint names to use a
  different data-structure, a `directed acyclic word graph
  <https://en.wikipedia.org/wiki/Deterministic_acyclic_finite_state_automaton>`_.
  This makes the unicodedata shared library about 440 KiB smaller.
  Contributed by Carl Friedrich Bolz-Tereick using code from the PyPy
  project.

- gh-73561: Omit the interface scope from an IPv6 address when used as Host
  header by :mod:`http.client`.

- gh-86826: :mod:`zipinfo` now supports the full range of values in the TZ
  string determined by RFC 8536 and detects all invalid formats. Both Python
  and C implementations now raise exceptions of the same type on invalid
  data.

Tests
-----

- gh-111808: Make the default value of ``test.support.infinite_recursion()``
  to be conditional based on whether optimizations were used when compiling
  the interpreter. This helps with platforms like WASI whose stack size is
  greatly restricted in debug builds.

- gh-110722: Gathering line coverage of standard libraries within the
  regression test suite is now precise, as well as much faster. Patch by
  Łukasz Langa.

- gh-110367: Make regrtest ``--verbose3`` option compatible with
  ``--huntrleaks -jN`` options. The ``./python -m test -j1 -R 3:3
  --verbose3`` command now works as expected. Patch by Victor Stinner.

- gh-111165: Remove no longer used functions ``run_unittest()`` and
  ``run_doctest()`` from the :mod:`test.support` module.

- gh-110932: Fix regrtest if the ``SOURCE_DATE_EPOCH`` environment variable
  is defined: use the variable value as the random seed. Patch by Victor
  Stinner.

- gh-110995: test_gdb: Fix detection of gdb built without Python scripting
  support. Patch by Victor Stinner.

- gh-110918: Test case matching patterns specified by options ``--match``,
  ``--ignore``, ``--matchfile`` and ``--ignorefile`` are now tested in the
  order of specification, and the last match determines whether the test
  case be run or ignored.

- gh-108747: Add unit test for ``usercustomize`` and ``sitecustomize`` hooks
  from :class:`site`.

Build
-----

- gh-96954: Make ``make regen-unicodedata`` work for out-of-tree builds of
  CPython.

- gh-112088: Add ``Tools/build/regen-configure.sh`` script to regenerate the
  ``configure`` with an Ubuntu container image. The
  ``quay.io/tiran/cpython_autoconf:271`` container image
  (`tiran/cpython_autoconf <https://github.com/tiran/cpython_autoconf>`_) is
  no longer used. Patch by Victor Stinner.

- gh-111046: For wasi-threads, memory is now exported to fix compatibility
  issues with some wasm runtimes.

- gh-110828: AIX 32bit needs ``-latomic`` to build the :mod:`!_testcapi`
  extension module.

- gh-85283: The ``errno``, ``md5``, ``resource``, ``winsound``,
  ``_ctypes_test``, ``_multiprocessing.posixshmem``, ``_scproxy``,
  ``_stat``, ``_testimportmultiple`` and ``_uuid`` C extensions are now
  built with the :ref:`limited C API <limited-c-api>`. Patch by Victor
  Stinner.

Windows
-------

- gh-111856: Fixes :func:`~os.fstat` on file systems that do not support
  file ID requests. This includes FAT32 and exFAT.

- gh-111293: Fix :data:`os.DirEntry.inode` dropping higher 64 bits of a file
  id on some filesystems on Windows.

- gh-110913: WindowsConsoleIO now correctly chunks large buffers without
  splitting up UTF-8 sequences.

macOS
-----

- gh-59703: For macOS framework builds, in ``getpath.c`` use the system
  ``dladdr`` function to find the path to the shared library rather than
  depending on deprecated macOS APIs.

- gh-110950: Update macOS installer to include an upstream Tcl/Tk fix for
  the ``Secure coding is not enabled for restorable state!`` warning
  encountered in Tkinter on macOS 14 Sonoma.

- gh-111015: Ensure that IDLE.app and Python Launcher.app are installed with
  appropriate permissions on macOS builds.

- gh-71383: Update macOS installer to include an upstream Tcl/Tk fix for the
  ``ttk::ThemeChanged`` error encountered in Tkinter.

- gh-92603: Update macOS installer to include a fix accepted by upstream
  Tcl/Tk for a crash encountered after the first :meth:`tkinter.Tk` instance
  is destroyed.

IDLE
----

- bpo-35668: Add docstrings to the IDLE debugger module. Fix two bugs:
  initialize ``Idb.botframe`` (should be in Bdb); in ``Idb.in_rpc_code``,
  check whether ``prev_frame`` is ``None`` before trying to use it. Greatly
  expand test_debugger.

Tools/Demos
-----------

- gh-111903: Argument Clinic now supports the ``@critical_section``
  directive that instructs Argument Clinic to generate a critical section
  around the function call, which locks the ``self`` object in
  ``--disable-gil`` builds. Patch by Sam Gross.

C API
-----

- gh-112026: Add again the private ``_PyThreadState_UncheckedGet()``
  function as an alias to the new public
  :c:func:`PyThreadState_GetUnchecked` function. Patch by Victor Stinner.

- gh-112026: Restore the removed ``_PyDict_GetItemStringWithError()``
  function. It is used by numpy. Patch by Victor Stinner.

- gh-112026: Restore removed private C API functions, macros and structures
  which have no simple replacement for now:

  * _PyDict_GetItem_KnownHash()
  * _PyDict_NewPresized()
  * _PyHASH_BITS
  * _PyHASH_IMAG
  * _PyHASH_INF
  * _PyHASH_MODULUS
  * _PyHASH_MULTIPLIER
  * _PyLong_Copy()
  * _PyLong_FromDigits()
  * _PyLong_New()
  * _PyLong_Sign()
  * _PyObject_CallMethodId()
  * _PyObject_CallMethodNoArgs()
  * _PyObject_CallMethodOneArg()
  * _PyObject_CallOneArg()
  * _PyObject_EXTRA_INIT
  * _PyObject_FastCallDict()
  * _PyObject_GetAttrId()
  * _PyObject_Vectorcall()
  * _PyObject_VectorcallMethod()
  * _PyStack_AsDict()
  * _PyThread_CurrentFrames()
  * _PyUnicodeWriter structure
  * _PyUnicodeWriter_Dealloc()
  * _PyUnicodeWriter_Finish()
  * _PyUnicodeWriter_Init()
  * _PyUnicodeWriter_Prepare()
  * _PyUnicodeWriter_PrepareKind()
  * _PyUnicodeWriter_WriteASCIIString()
  * _PyUnicodeWriter_WriteChar()
  * _PyUnicodeWriter_WriteLatin1String()
  * _PyUnicodeWriter_WriteStr()
  * _PyUnicodeWriter_WriteSubstring()
  * _PyUnicode_AsString()
  * _PyUnicode_FromId()
  * _PyVectorcall_Function()
  * _Py_IDENTIFIER()
  * _Py_c_abs()
  * _Py_c_diff()
  * _Py_c_neg()
  * _Py_c_pow()
  * _Py_c_prod()
  * _Py_c_quot()
  * _Py_c_sum()
  * _Py_static_string()
  * _Py_static_string_init()

  Patch by Victor Stinner.

- gh-112026: Add again ``<ctype.h>`` and ``<unistd.h>`` includes in
  ``Python.h``, but don't include them in the limited C API version 3.13 and
  newer. Patch by Victor Stinner.

- gh-111956: Add internal-only one-time initialization API: ``_PyOnceFlag``
  and ``_PyOnceFlag_CallOnce``.

- gh-111262: Add :c:func:`PyDict_Pop` and :c:func:`PyDict_PopString`
  functions: remove a key from a dictionary and optionally return the
  removed value. This is similar to :meth:`dict.pop`, but without the
  default value and not raising :exc:`KeyError` if the key missing. Patch by
  Stefan Behnel and Victor Stinner.

- gh-111863: Rename ``Py_NOGIL`` to ``Py_GIL_DISABLED``. Patch by Hugo van
  Kemenade.

- gh-111138: Add :c:func:`PyList_Extend` and :c:func:`PyList_Clear`
  functions: similar to Python ``list.extend()`` and ``list.clear()``
  methods. Patch by Victor Stinner.

- gh-108765: On Windows, ``Python.h`` no longer includes the ``<stddef.h>``
  standard header file. If needed, it should now be included explicitly.
  Patch by Victor Stinner.

- gh-111569: Implement "Python Critical Sections" from :pep:`703`. These are
  macros to help replace the GIL with per-object locks in the
  ``--disable-gil`` build of CPython. The macros are no-ops in the default
  build.

- gh-111506: In the limited C API version 3.13, :c:func:`Py_SET_REFCNT`
  function is now implemented as an opaque function call. Patch by Victor
  Stinner.

- gh-108082: Add :c:func:`PyErr_FormatUnraisable` function.

- gh-110964: Move the undocumented private _PyArg functions and
  _PyArg_Parser structure to internal C API (``pycore_modsupport.h``). Patch
  by Victor Stinner.

- gh-110815: Support non-ASCII keyword names in
  :c:func:`PyArg_ParseTupleAndKeywords`.

- gh-109587: Introduced :c:func:`PyUnstable_PerfTrampoline_CompileCode`,
  :c:func:`PyUnstable_PerfTrampoline_SetPersistAfterFork` and
  :c:func:`PyUnstable_CopyPerfMapFile`. These functions allow extension
  modules to initialize trampolines eagerly, after the application is
  "warmed up". This makes it possible to have perf-trampolines running in an
  always-enabled fashion.

- gh-85283: Add the :c:func:`PySys_Audit` function to the limited C API.
  Patch by Victor Stinner.

- gh-85283: Add :c:func:`PyMem_RawMalloc`, :c:func:`PyMem_RawCalloc`,
  :c:func:`PyMem_RawRealloc` and :c:func:`PyMem_RawFree` to the limited C
  API. Patch by Victor Stinner.

- gh-106672: Functions :c:func:`PyDict_GetItem`,
  :c:func:`PyDict_GetItemString`, :c:func:`PyMapping_HasKey`,
  :c:func:`PyMapping_HasKeyString`, :c:func:`PyObject_HasAttr`,
  :c:func:`PyObject_HasAttrString`, and :c:func:`PySys_GetObject`, which
  clear all errors occurred during calling the function, report now them
  using :func:`sys.unraisablehook`.

- gh-67565: Remove redundant C-contiguity check in :file:`getargs.c`,
  :mod:`binascii`, :mod:`ssl` and Argument Clinic. Patched by Stefan Krah
  and Furkan Onder


What's New in Python 3.13.0 alpha 1?
====================================

*Release date: 2023-10-13*

Security
--------

- gh-108310: Fixed an issue where instances of :class:`ssl.SSLSocket` were
  vulnerable to a bypass of the TLS handshake and included protections (like
  certificate verification) and treating sent unencrypted data as if it were
  post-handshake TLS encrypted data.  Security issue reported as
  :cve:`2023-40217` by Aapo Oksman. Patch by Gregory P. Smith.

- gh-107774: PEP 669 specifies that ``sys.monitoring.register_callback``
  will generate an audit event. Pre-releases of Python 3.12 did not generate
  the audit event. This is now fixed.

- gh-102988: Reverted the :mod:`email.utils` security improvement change
  released in 3.12beta4 that unintentionally caused
  :mod:`email.utils.getaddresses` to fail to parse email addresses with a
  comma in the quoted name field. See :gh:`106669`.

- gh-99108: Refresh our new HACL* built-in :mod:`hashlib` code from
  upstream. Built-in SHA2 should be faster and an issue with SHA3 on 32-bit
  platforms is fixed.

- gh-102509: Start initializing ``ob_digit`` during creation of
  :c:type:`PyLongObject` objects. Patch by Illia Volochii.

Core and Builtins
-----------------

- gh-110782: Fix crash when :class:`typing.TypeVar` is constructed with a
  keyword argument. Patch by Jelle Zijlstra.

- gh-110752: Reset ``ceval.eval_breaker`` in :func:`interpreter_clear`

- gh-110721: Use the :mod:`traceback` implementation for the default
  :c:func:`PyErr_Display` functionality. Patch by Pablo Galindo

- gh-110696: Fix incorrect error message for invalid argument unpacking.
  Patch by Pablo Galindo

- gh-104169: Split the tokenizer into two separate directories: - One part
  includes the actual lexeme producing logic and lives in ``Parser/lexer``.
  - The second part wraps the lexer according to the different tokenization
  modes   we have (string, utf-8, file, interactive, readline) and lives in
  ``Parser/tokenizer``.

- gh-110688: Remove undocumented ``test_c_api`` method from :class:`set`,
  which was only defined for testing purposes under ``Py_DEBUG``. Now we
  have proper CAPI tests.

- gh-104584: Fix a reference leak when running with :envvar:`PYTHONUOPS` or
  :option:`-X uops <-X>` enabled.

- gh-110514: Add ``PY_THROW`` to :func:`sys.setprofile` events

- gh-110489: Optimise :func:`math.ceil` when the input is exactly a float,
  resulting in about a 10% improvement.

- gh-110455: Guard ``assert(tstate->thread_id > 0)`` with ``#ifndef
  HAVE_PTHREAD_STUBS``. This allows for for pydebug builds to work under
  WASI which (currently) lacks thread support.

- gh-110309: Remove unnecessary empty constant nodes in the ast of f-string
  specs.

- gh-110259: Correctly identify the format spec in f-strings (with single or
  triple quotes) that have multiple lines in the expression part and include
  a formatting spec. Patch by Pablo Galindo

- gh-110237: Fix missing error checks for calls to ``PyList_Append`` in
  ``_PyEval_MatchClass``.

- gh-110164: regrtest: If the ``SOURCE_DATE_EPOCH`` environment variable is
  defined, regrtest now disables tests randomization. Patch by Victor
  Stinner.

- gh-109889: Fix the compiler's redundant NOP detection algorithm to skip
  over NOPs with no line number when looking for the next instruction's
  lineno.

- gh-109853: ``sys.path[0]`` is now set correctly for subinterpreters.

- gh-109923: Set line number on the ``POP_TOP`` that follows a
  ``RETURN_GENERATOR``.

- gh-105716: Subinterpreters now correctly handle the case where they have
  threads running in the background.  Before, such threads would interfere
  with cleaning up and destroying them, as well as prevent running another
  script.

- gh-109369: The internal eval_breaker and supporting flags, plus the
  monitoring version have been merged into a single atomic integer to speed
  up checks.

- gh-109823: Fix bug where compiler does not adjust labels when removing an
  empty basic block which is a jump target.

- gh-109793: The main thread no longer exits prematurely when a
  subinterpreter is cleaned up during runtime finalization.  The bug was a
  problem particularly because, when triggered, the Python process would
  always return with a 0 exitcode, even if it failed.

- gh-109719: Fix missing jump target labels when compiler reorders cold/warm
  blocks.

- gh-109595: Add :option:`-X cpu_count <-X>`  command line option to
  override return results of :func:`os.cpu_count` and
  :func:`os.process_cpu_count`. This option is useful for users who need to
  limit CPU resources of a container system without having to modify the
  container (application code). Patch by Donghee Na.

- gh-109627: Fix bug where the compiler does not assign a new jump target
  label to a duplicated small exit block.

- gh-109596: Fix some tokens in the grammar that were incorrectly marked as
  soft keywords. Also fix some repeated rule names and ensure that repeated
  rules are not allowed. Patch by Pablo Galindo

- gh-109496: On a Python built in debug mode, :c:func:`Py_DECREF()` now
  calls ``_Py_NegativeRefcount()`` if the object is a dangling pointer to
  deallocated memory: memory filled with ``0xDD`` "dead byte" by the debug
  hook on memory allocators. The fix is to check the reference count
  *before* checking for ``_Py_IsImmortal()``. Patch by Victor Stinner.

- gh-107265: Deopt opcodes hidden by the executor when base opcode is needed

- gh-109371: Deopted instructions correctly for tool initialization and
  modified the incorrect assertion in instrumentation, when a previous tool
  already sets INSTRUCTION events

- gh-105658: Fix bug where the line trace of an except block ending with a
  conditional includes an excess event with the line of the conditional
  expression.

- gh-109219: Fix compiling type param scopes that use a name which is also
  free in an inner scope.

- gh-109351: Fix crash when compiling an invalid AST involving a named
  (walrus) expression.

- gh-109341: Fix crash when compiling an invalid AST involving a
  :class:`ast.TypeAlias`.

- gh-109195: Fix source location for the ``LOAD_*`` instruction preceding a
  ``LOAD_SUPER_ATTR`` to load the ``super`` global (or shadowing variable)
  so that it encompasses only the name ``super`` and not the following
  parentheses.

- gh-109256: Opcode IDs for specialized opcodes are allocated in their own
  range to improve stability of the IDs for the 'real' opcodes.

- gh-109216: Fix possible memory leak in :opcode:`BUILD_MAP`.

- gh-109207: Fix a SystemError in ``__repr__`` of symtable entry object.

- gh-109179: Fix bug where the C traceback display drops notes from
  :exc:`SyntaxError`.

- gh-109118: Disallow nested scopes (lambdas, generator expressions, and
  comprehensions) within PEP 695 annotation scopes that are nested within
  classes.

- gh-109156: Add tests for de-instrumenting instructions while keeping the
  instrumentation for lines

- gh-109114: Relax the detection of the error message for invalid lambdas
  inside f-strings to not search for arbitrary replacement fields to avoid
  false positives. Patch by Pablo Galindo

- gh-105848: Add a new :opcode:`CALL_KW` opcode, used for calls containing
  keyword arguments. Also, fix a possible crash when jumping over method
  calls in a debugger.

- gh-109052: Use the base opcode when comparing code objects to avoid
  interference from instrumentation

- gh-109118: Fix interpreter crash when a NameError is raised inside the
  type parameters of a generic class.

- gh-88943: Improve syntax error for non-ASCII character that follows a
  numerical literal. It now points on the invalid non-ASCII character, not
  on the valid numerical literal.

- gh-108976: Fix crash that occurs after de-instrumenting a code object in a
  monitoring callback.

- gh-108732: Make iteration variables of module- and class-scoped
  comprehensions visible to pdb and other tools that use ``frame.f_locals``
  again.

- gh-108959: Fix caret placement for error locations for subscript and
  binary operations that involve non-semantic parentheses and spaces. Patch
  by Pablo Galindo

- gh-104584: Fix a crash when running with :envvar:`PYTHONUOPS` or
  :option:`-X uops <-X>` enabled and an error occurs during optimization.

- gh-108727: Define ``tp_dealloc`` for ``CounterOptimizer_Type``. This fixes
  a segfault on deallocation.

- gh-108520: Fix :meth:`multiprocessing.synchronize.SemLock.__setstate__` to
  properly initialize
  :attr:`multiprocessing.synchronize.SemLock._is_fork_ctx`. This fixes a
  regression when passing a SemLock across nested processes.

  Rename :attr:`multiprocessing.synchronize.SemLock.is_fork_ctx` to
  :attr:`multiprocessing.synchronize.SemLock._is_fork_ctx` to avoid exposing
  it as public API.

- gh-108654: Restore locals shadowed by an inlined comprehension if the
  comprehension raises an exception.

- gh-108488: Change the initialization of inline cache entries so that the
  cache entry for ``JUMP_BACKWARD`` is initialized to zero, instead of the
  ``adaptive_counter_warmup()`` value used for all other instructions. This
  counter, unique among instructions, counts up from zero.

- gh-108716: Turn off deep-freezing of code objects. Modules are still
  frozen, so that a file system search is not needed for common modules.

- gh-108614: Add RESUME_CHECK instruction, to avoid having to handle
  instrumentation, signals, and contexts switches in the tier 2 execution
  engine.

- gh-108487: Move an assert that would cause a spurious crash in a devious
  case that should only trigger deoptimization.

- gh-106176: Use a ``WeakValueDictionary`` to track the lists containing the
  modules each thread is currently importing. This helps avoid a reference
  leak from keeping the list around longer than necessary. Weakrefs are used
  as GC can't interrupt the cleanup.

- gh-105481: The regen-opcode build stage was removed and its work is now
  done in regen-cases.

- gh-107901: Fix missing line number on :opcode:`JUMP_BACKWARD` at the end
  of a for loop.

- gh-108113: The :func:`compile` built-in can now accept a new flag,
  ``ast.PyCF_OPTIMIZED_AST``, which is similar to ``ast.PyCF_ONLY_AST``
  except that the returned ``AST`` is optimized according to the value of
  the ``optimize`` argument.

  :func:`ast.parse` now accepts an optional argument ``optimize`` which is
  passed on to the :func:`compile` built-in. This makes it possible to
  obtain an optimized ``AST``.

- gh-107971: Opcode IDs are generated from bytecodes.c instead of being hard
  coded in opcode.py.

- gh-107944: Improve error message for function calls with bad keyword
  arguments. Patch by Pablo Galindo

- gh-108390: Raise an exception when setting a non-local event (``RAISE``,
  ``EXCEPTION_HANDLED``, etc.) in ``sys.monitoring.set_local_events``.

  Fixes crash when tracing in recursive calls to Python classes.

- gh-108035: Remove the ``_PyCFrame`` struct, moving the pointer to the
  current interpreter frame back to the threadstate, as it was for 3.10 and
  earlier. The ``_PyCFrame`` existed as a performance optimization for
  tracing. Since PEP 669 has been implemented, this optimization no longer
  applies.

- gh-91051: Fix abort / segfault when using all eight type watcher slots, on
  platforms where ``char`` is signed by default.

- gh-106581: Fix possible assertion failures and missing instrumentation
  events when :envvar:`PYTHONUOPS` or :option:`-X uops <-X>` is enabled.

- gh-107526: Revert converting ``vars``, ``dir``, ``next``, ``getattr``, and
  ``iter`` to argument clinic.

- gh-84805: Autogenerate signature for :c:macro:`METH_NOARGS` and
  :c:macro:`METH_O` extension functions.

- gh-107758: Make the ``dump_stack()`` routine used by the ``lltrace``
  feature (low-level interpreter debugging) robust against recursion by
  ensuring that it never calls a ``__repr__`` method implemented in Python.
  Also make the similar output for Tier-2 uops appear on ``stdout`` (instead
  of ``stderr``), to match the ``lltrace`` code in ceval.c.

- gh-107659: Add docstrings for :func:`ctypes.pointer` and
  :func:`ctypes.POINTER`.

- gh-105848: Modify the bytecode so that the actual callable for a
  :opcode:`CALL` is at a consistent position on the stack (regardless of
  whether or not bound-method-calling optimizations are active).

- gh-107674: Fixed performance regression in ``sys.settrace``.

- gh-107724: In pre-release versions of 3.12, up to rc1, the sys.monitoring
  callback function for the ``PY_THROW`` event was missing the third,
  exception argument. That is now fixed.

- gh-84436: Skip reference count modifications for many known immortal
  objects.

- gh-107596: Specialize subscripting :class:`str` objects by :class:`int`
  indexes.

- gh-107080: Trace refs builds (``--with-trace-refs``) were crashing when
  used with isolated subinterpreters.  The problematic global state has been
  isolated to each interpreter.  Other fixing the crashes, this change does
  not affect users.

- gh-107557: Generate the cases needed for the barebones tier 2 abstract
  interpreter for optimization passes in CPython.

- gh-106608: Make ``_PyUOpExecutorObject`` variable length.

- gh-100964: Clear generators' exception state after ``return`` to break
  reference cycles.

- gh-107455: Improve error messages when converting an incompatible type to
  :class:`ctypes.c_char_p`, :class:`ctypes.c_wchar_p` and
  :class:`ctypes.c_void_p`.

- gh-107263: Increase C recursion limit for functions other than the main
  interpreter from 800 to 1500. This should allow functions like
  ``list.__repr__`` and ``json.dumps`` to handle all the inputs that they
  could prior to 3.12

- gh-104584: Fix an issue which caused incorrect inline caches to be read
  when running with :envvar:`PYTHONUOPS` or :option:`-X uops <-X>` enabled.

- gh-104432: Fix potential unaligned memory access on C APIs involving
  returned sequences of ``char *`` pointers within the :mod:`grp` and
  :mod:`socket` modules. These were revealed using a
  ``-fsaniziter=alignment`` build on ARM macOS. Patch by Christopher Chavez.

- gh-106078: Isolate :mod:`!_decimal` (apply :pep:`687`). Patch by Charlie
  Zhao.

- gh-106898: Add the exception as the third argument to ``PY_UNIND``
  callbacks in ``sys.monitoring``. This makes the ``PY_UNWIND`` callback
  consistent with the other exception handling callbacks.

- gh-106895: Raise a ``ValueError`` when a monitoring callback function
  returns ``DISABLE`` for events that cannot be disabled locally.

- gh-106897: Add a ``RERAISE`` event to ``sys.monitoring``, which occurs
  when an exception is reraise, either explicitly by a plain ``raise``
  statement, or implicitly in an ``except`` or ``finally`` block.

- gh-77377: Ensure that multiprocessing synchronization objects created in a
  fork context are not sent to a different process created in a spawn
  context. This changes a segfault into an actionable RuntimeError in the
  parent process.

- gh-106931: Statically allocated string objects are now interned globally
  instead of per-interpreter.  This fixes a situation where such a string
  would only be interned in a single interpreter. Normal string objects are
  unaffected.

- gh-104621: Unsupported modules now always fail to be imported.

- gh-107122: Add :meth:`dbm.ndbm.ndbm.clear` to :mod:`dbm.ndbm`. Patch By
  Donghee Na.

- gh-107122: Add :meth:`dbm.gnu.gdbm.clear` to :mod:`dbm.gnu`. Patch By
  Donghee Na.

- gh-107015: The ASYNC and AWAIT tokens are removed from the Grammar, which
  removes the possibility of making ``async`` and ``await`` soft keywords
  when using ``feature_version<7`` in :func:`ast.parse`.

- gh-106917: Fix classmethod-style :func:`super` method calls (i.e., where
  the second argument to :func:`super`, or the implied second argument drawn
  from ``self/cls`` in the case of zero-arg super, is a type) when the
  target of the call is not a classmethod.

- gh-105699: Python no longer crashes due an infrequent race when
  initializing per-interpreter interned strings.  The crash would manifest
  when the interpreter was finalized.

- gh-105699: Python no longer crashes due to an infrequent race in setting
  ``Py_FileSystemDefaultEncoding`` and ``Py_FileSystemDefaultEncodeErrors``
  (both deprecated), when simultaneously initializing two isolated
  subinterpreters.  Now they are only set during runtime initialization.

- gh-106908: Fix various hangs, reference leaks, test failures, and
  tracing/introspection bugs when running with :envvar:`PYTHONUOPS` or
  :option:`-X uops <-X>` enabled.

- gh-106092: Fix a segmentation fault caused by a use-after-free bug in
  ``frame_dealloc`` when the trashcan delays the deallocation of a
  ``PyFrameObject``.

- gh-106485: Reduce the number of materialized instances dictionaries by
  dematerializing them when possible.

- gh-106719: No longer suppress arbitrary errors in the ``__annotations__``
  getter and setter in the type and module types.

- gh-106723: Propagate ``frozen_modules`` to multiprocessing spawned process
  interpreters.

- gh-104909: Split :opcode:`LOAD_ATTR_INSTANCE_VALUE` into micro-ops.

- gh-104909: Split :opcode:`LOAD_GLOBAL` specializations into micro-ops.

- gh-106597: A new debug structure of offsets has been added to the
  ``_PyRuntimeState`` that will help out-of-process debuggers and profilers
  to obtain the offsets to relevant interpreter structures in a way that is
  agnostic of how Python was compiled and that doesn't require copying the
  headers. Patch by Pablo Galindo

- gh-106487: Allow the *count* argument of :meth:`str.replace` to be a
  keyword. Patch by Hugo van Kemenade.

- gh-96844: Improve error message of :meth:`list.remove`. Patch by Donghee
  Na.

- gh-81283: Compiler now strips indents from docstrings. It reduces ``pyc``
  file size 5% when the module is heavily documented. This change affects to
  ``__doc__`` so tools like doctest will be affected.

- gh-106396: When the format specification of an f-string expression is
  empty, the parser now generates an empty :class:`ast.JoinedStr` node for
  it instead of an one-element :class:`ast.JoinedStr` with an empty string
  :class:`ast.Constant`.

- gh-100288: Specialize :opcode:`LOAD_ATTR` for non-descriptors on the
  class. Adds :opcode:`LOAD_ATTR_NONDESCRIPTOR_WITH_VALUES` and
  :opcode:`LOAD_ATTR_NONDESCRIPTOR_NO_DICT`.

- gh-106008: Fix possible reference leaks when failing to optimize
  comparisons with :const:`None` in the bytecode compiler.

- gh-106145: Make ``end_lineno`` and ``end_col_offset`` required on
  ``type_param`` ast nodes.

- gh-106213: Changed the way that Emscripten call trampolines work for
  compatibility with Wasm/JS Promise integration.

- gh-106182: :func:`sys.getfilesystemencoding` and
  :mod:`sys.getfilesystemencodeerrors` now return interned Unicode object.

- gh-106210: Removed Emscripten import trampoline as it was no longer
  necessary for Pyodide.

- gh-104584: Added a new, experimental, tracing optimizer and interpreter
  (a.k.a. "tier 2"). This currently pessimizes, so don't use yet -- this is
  infrastructure so we can experiment with optimizing passes. To enable it,
  pass ``-Xuops`` or set ``PYTHONUOPS=1``. To get debug output, set
  ``PYTHONUOPSDEBUG=N`` where ``N`` is a debug level (0-4, where 0 is no
  debug output and 4 is excessively verbose).

- gh-105775: :opcode:`LOAD_CLOSURE` is now a pseudo-op.

- gh-105730: Allow any callable other than type objects as the condition
  predicate in :meth:`BaseExceptionGroup.split` and
  :meth:`BaseExceptionGroup.subgroup`.

- gh-105979: Fix crash in :func:`!_imp.get_frozen_object` due to improper
  exception handling.

- gh-106003: Add a new :opcode:`TO_BOOL` instruction, which performs boolean
  conversions for :opcode:`POP_JUMP_IF_TRUE`, :opcode:`POP_JUMP_IF_FALSE`,
  and :opcode:`UNARY_NOT` (which all expect exact :class:`bool` values now).
  Also, modify the oparg of :opcode:`COMPARE_OP` to include an optional
  "boolean conversion" flag.

- gh-98931: Ensure custom :exc:`SyntaxError` error messages are raised for
  invalid imports with multiple targets. Patch by Pablo Galindo

- gh-105724: Improve ``assert`` error messages by providing exact error
  range.

- gh-105908: Fixed bug where :gh:`99111` breaks future import
  ``barry_as_FLUFL`` in the Python REPL.

- gh-105840: Fix possible crashes when specializing function calls with too
  many ``__defaults__``.

- gh-105831: Fix an f-string bug, where using a debug expression (the ``=``
  sign) that appears in the last line of a file results to the debug buffer
  that holds the expression text being one character too small.

- gh-105800: Correctly issue :exc:`SyntaxWarning` in f-strings if invalid
  sequences are used. Patch by Pablo Galindo

- gh-105340: Include the comprehension iteration variable in ``locals()``
  inside a module- or class-scope comprehension.

- gh-105331: Raise :exc:`ValueError` if the ``delay`` argument to
  :func:`asyncio.sleep` is a NaN (matching :func:`time.sleep`).

- gh-105587: The runtime can't guarantee that immortal objects will not be
  mutated by Extensions. Thus, this modifies _PyStaticObject_CheckRefcnt to
  warn instead of asserting.

- gh-105564: Don't include artificil newlines in the ``line`` attribute of
  tokens in the APIs of the :mod:`tokenize` module. Patch by Pablo Galindo

- gh-105549: Tokenize separately ``NUMBER`` and ``NAME`` tokens that are not
  ambiguous. Patch by Pablo Galindo.

- gh-105588: Fix an issue that could result in crashes when compiling
  malformed :mod:`ast` nodes.

- gh-100987: Allow objects other than code objects as the "executable" in
  internal frames. In the long term, this can help tools like Cython and
  PySpy interact more efficiently. In the shorter term, it allows us to
  perform some optimizations more simply.

- gh-105375: Fix bugs in the :mod:`builtins` module where exceptions could
  end up being overwritten.

- gh-105375: Fix bug in the compiler where an exception could end up being
  overwritten.

- gh-105375: Improve error handling in :c:func:`PyUnicode_BuildEncodingMap`
  where an exception could end up being overwritten.

- gh-105486: Change the repr of ``ParamSpec`` list of args in
  ``types.GenericAlias``.

- gh-105678: Break the ``MAKE_FUNCTION`` instruction into two parts,
  ``MAKE_FUNCTION`` which makes the function and ``SET_FUNCTION_ATTRIBUTE``
  which sets the attributes on the function. This makes the stack effect of
  ``MAKE_FUNCTION`` regular to ease optimization and code generation.

- gh-105435: Fix spurious newline character if file ends on a comment
  without a newline. Patch by Pablo Galindo

- gh-105390: Correctly raise :exc:`tokenize.TokenError` exceptions instead
  of :exc:`SyntaxError` for tokenize errors such as incomplete input. Patch
  by Pablo Galindo

- gh-105259: Don't include newline character for trailing ``NEWLINE`` tokens
  emitted in the :mod:`tokenize` module. Patch by Pablo Galindo

- gh-104635: Eliminate redundant :opcode:`STORE_FAST` instructions in the
  compiler. Patch by Donghee Na and Carl Meyer.

- gh-105324: Fix the main function of the :mod:`tokenize` module when
  reading from ``sys.stdin``. Patch by Pablo Galindo

- gh-33092: Simplify and speed up interpreter for f-strings. Removes
  ``FORMAT_VALUE`` opcode. Add ``CONVERT_VALUE``, ``FORMAT_SIMPLE`` and
  ``FORMAT_WITH_SPEC`` opcode. Compiler emits more efficient sequence for
  each format expression.

- gh-105229: Remove remaining two-codeunit superinstructions. All remaining
  superinstructions only take a single codeunit, simplifying instrumentation
  and quickening.

- gh-105235: Prevent out-of-bounds memory access during ``mmap.find()``
  calls.

- gh-98963: Restore the ability for a subclass of :class:`property` to
  define ``__slots__`` or otherwise be dict-less by ignoring failures to set
  a docstring on such a class.  This behavior had regressed in 3.12beta1.
  An :exc:`AttributeError` where there had not previously been one was
  disruptive to existing code.

- gh-104812: The "pending call" machinery now works for all interpreters,
  not just the main interpreter, and runs in all threads, not just the main
  thread. Some calls are still only done in the main thread, ergo in the
  main interpreter. This change does not affect signal handling nor the
  existing public C-API (``Py_AddPendingCall()``), which both still only
  target the main thread. The new functionality is meant strictly for
  internal use for now, since consequences of its use are not well
  understood yet outside some very restricted cases.  This change brings the
  capability in line with the intention when the state was made
  per-interpreter several years ago.

- gh-105194: Do not escape with backslashes f-string format specifiers.
  Patch by Pablo Galindo

- gh-105229: Replace some dynamic superinstructions with single instruction
  equivalents.

- gh-105162: Fixed bug in generator.close()/throw() where an inner iterator
  would be ignored when the outer iterator was instrumented.

- gh-105164: Ensure annotations are set up correctly if the only annotation
  in a block is within a :keyword:`match` block. Patch by Jelle Zijlstra.

- gh-105148: Make ``_PyASTOptimizeState`` internal to ast_opt.c. Make
  ``_PyAST_Optimize`` take two integers instead of a pointer to this struct.
  This avoids the need to include pycore_compile.h in ast_opt.c.

- gh-104799: Attributes of :mod:`ast` nodes that are lists now default to
  the empty list if omitted. This means that some code that previously
  raised :exc:`TypeError` when the AST node was used will now proceed with
  the empty list instead. Patch by Jelle Zijlstra.

- gh-105111: Remove the old trashcan macros ``Py_TRASHCAN_SAFE_BEGIN`` and
  ``Py_TRASHCAN_SAFE_END``. They should be replaced by the new macros
  ``Py_TRASHCAN_BEGIN`` and ``Py_TRASHCAN_END``.

- gh-105035: Fix :func:`super` calls on types with custom
  :c:member:`~PyTypeObject.tp_getattro` implementation (e.g. meta-types.)

- gh-105017: Show CRLF lines in the tokenize string attribute in both NL and
  NEWLINE tokens. Patch by Marta Gómez.

- gh-105013: Fix handling of multiline parenthesized lambdas in
  :func:`inspect.getsource`. Patch by Pablo Galindo

- gh-105017: Do not include an additional final ``NL`` token when parsing
  files having CRLF lines. Patch by Marta Gómez.

- gh-104976: Ensure that trailing ``DEDENT`` :class:`tokenize.TokenInfo`
  objects emitted by the :mod:`tokenize` module are reported as in Python
  3.11. Patch by Pablo Galindo

- gh-104972: Ensure that the ``line`` attribute in
  :class:`tokenize.TokenInfo` objects in the :mod:`tokenize` module are
  always correct. Patch by Pablo Galindo

- gh-104955: Fix signature for the new :meth:`~object.__release_buffer__`
  slot. Patch by Jelle Zijlstra.

- gh-104690: Starting new threads and process creation through
  :func:`os.fork` during interpreter shutdown (such as from :mod:`atexit`
  handlers) is no longer supported.  It can lead to race condition between
  the main Python runtime thread freeing thread states while internal
  :mod:`threading` routines are trying to allocate and use the state of just
  created threads. Or forked children trying to use the mid-shutdown runtime
  and thread state in the child process.

- gh-104879: Fix crash when accessing the ``__module__`` attribute of type
  aliases defined outside a module. Patch by Jelle Zijlstra.

- gh-104825: Tokens emitted by the :mod:`tokenize` module do not include an
  implicit ``\n`` character in the ``line`` attribute anymore. Patch by
  Pablo Galindo

- gh-104770: If a generator returns a value upon being closed, the value is
  now returned by :meth:`generator.close`.

- gh-89091: Raise :exc:`RuntimeWarning` for unawaited async generator
  methods like :meth:`~agen.asend`, :meth:`~agen.athrow` and
  :meth:`~agen.aclose`. Patch by Kumar Aditya.

- gh-96663: Add a better, more introspect-able error message when setting
  attributes on classes without a ``__dict__`` and no slot member for the
  attribute.

- gh-93627: Update the Python pickle module implementation to match the C
  implementation of the pickle module. For objects setting reduction methods
  like :meth:`~object.__reduce_ex__` or :meth:`~object.__reduce__` to
  ``None``, pickling will result in a :exc:`TypeError`.

- gh-101006: Improve error handling when read :mod:`marshal` data.

- gh-91095: Specializes calls to most Python classes. Specifically, any
  class that inherits from ``object``, or another Python class, and does not
  override ``__new__``.

  The specialized instruction does the following:

  1. Creates the object (by calling ``object.__new__``)
  2. Pushes a shim frame to the frame stack (to cleanup after ``__init__``)
  3. Pushes the frame for ``__init__`` to the frame stack

  Speeds up the instantiation of most Python classes.

Library
-------

- gh-110786: :mod:`sysconfig`'s CLI now ignores :exc:`BrokenPipeError`,
  making it exit normally if its output is being piped and the pipe closes.

- gh-103480: The :mod:`sysconfig` module is now a package, instead of a
  single-file module.

- gh-110733: Micro-optimization: Avoid calling ``min()``, ``max()`` in
  :meth:`BaseEventLoop._run_once`.

- gh-94597: Added :class:`asyncio.EventLoop` for use with the
  :func:`asyncio.run` *loop_factory* kwarg to avoid calling the asyncio
  policy system.

- gh-110682: :func:`runtime-checkable protocols <typing.runtime_checkable>`
  used to consider ``__match_args__`` a protocol member in
  ``__instancecheck__`` if it was present on the protocol. Now, this
  attribute is ignored if it is present.

- gh-110488: Fix a couple of issues in :meth:`pathlib.PurePath.with_name`: a
  single dot was incorrectly considered a valid name, and in
  :class:`PureWindowsPath`, a name with an NTFS alternate data stream, like
  ``a:b``, was incorrectly considered invalid.

- gh-110590: Fix a bug in :meth:`!_sre.compile` where :exc:`TypeError` would
  be overwritten by :exc:`OverflowError` when the *code* argument was a list
  of non-ints.

- gh-65052: Prevent :mod:`pdb` from crashing when trying to display
  undisplayable objects

- gh-110519: Deprecation warning about non-integer number in :mod:`gettext`
  now always refers to the line in the user code where gettext function or
  method is used. Previously it could refer to a line in ``gettext`` code.

- gh-89902: Deprecate non-standard format specifier "N" for
  :class:`decimal.Decimal`. It was not documented and only supported in the
  C implementation.

- gh-110378: :func:`~contextlib.contextmanager` and
  :func:`~contextlib.asynccontextmanager` context managers now close an
  invalid underlying generator object that yields more then one value.

- gh-106670: In :mod:`pdb`, set convenience variable ``$_exception`` for
  post mortem debugging.

- gh-110365: Fix :func:`termios.tcsetattr` bug that was overwriting existing
  errors during parsing integers from ``term`` list.

- gh-109653: Slightly improve the import time of several standard-library
  modules by deferring imports of :mod:`warnings` within those modules.
  Patch by Alex Waygood.

- gh-110273: :func:`dataclasses.replace` now raises TypeError instead of
  ValueError if specify keyword argument for a field declared with
  init=False or miss keyword argument for required InitVar field.

- gh-110249: Add ``--inline-caches`` flag to ``dis`` command line.

- gh-109653: Fix a Python 3.12 regression in the import time of
  :mod:`random`. Patch by Alex Waygood.

- gh-110222: Add support of struct sequence objects in :func:`copy.replace`.
  Patched by Xuehai Pan.

- gh-109649: :mod:`multiprocessing`, :mod:`concurrent.futures`,
  :mod:`compileall`: Replace :func:`os.cpu_count` with
  :func:`os.process_cpu_count` to select the default number of worker
  threads and processes. Get the CPU affinity if supported. Patch by Victor
  Stinner.

- gh-110150: Fix base case handling in statistics.quantiles.  Now allows a
  single data point.

- gh-110036: On Windows, multiprocessing ``Popen.terminate()`` now catches
  :exc:`PermissionError` and get the process exit code. If the process is
  still running, raise again the :exc:`PermissionError`. Otherwise, the
  process terminated as expected: store its exit code. Patch by Victor
  Stinner.

- gh-110038: Fixed an issue that caused :meth:`KqueueSelector.select` to not
  return all the ready events in some cases when a file descriptor is
  registered for both read and write.

- gh-110045: Update the :mod:`symtable` module to support the new scopes
  introduced by :pep:`695`.

- gh-88402: Add new variables to :py:meth:`sysconfig.get_config_vars` on
  Windows: ``LIBRARY``, ``LDLIBRARY``, ``LIBDIR``, ``SOABI``, and
  ``Py_NOGIL``.

- gh-109631: :mod:`re` functions such as :func:`re.findall`,
  :func:`re.split`, :func:`re.search` and :func:`re.sub` which perform short
  repeated matches can now be interrupted by user.

- gh-109653: Reduce the import time of :mod:`email.utils` by around 43%.
  This results in the import time of :mod:`email.message` falling by around
  18%, which in turn reduces the import time of :mod:`importlib.metadata` by
  around 6%. Patch by Alex Waygood.

- gh-109818: Fix :func:`reprlib.recursive_repr` not copying
  ``__type_params__`` from decorated function.

- gh-109047: :mod:`concurrent.futures`: The *executor manager thread* now
  catches exceptions when adding an item to the *call queue*. During Python
  finalization, creating a new thread can now raise :exc:`RuntimeError`.
  Catch the exception and call ``terminate_broken()`` in this case. Patch by
  Victor Stinner.

- gh-109782: Ensure the signature of :func:`os.path.isdir` is identical on
  all platforms. Patch by Amin Alaee.

- gh-109653: Improve import time of :mod:`functools` by around 13%. Patch by
  Alex Waygood.

- gh-109590: :func:`shutil.which` will prefer files with an extension in
  ``PATHEXT`` if the given mode includes ``os.X_OK`` on win32. If no
  ``PATHEXT`` match is found, a file without an extension in ``PATHEXT`` can
  be returned. This change will have :func:`shutil.which` act more similarly
  to previous behavior in Python 3.11.

- gh-109653: Reduce the import time of :mod:`enum` by over 50%. Patch by
  Alex Waygood.

- gh-109593: Avoid deadlocking on a reentrant call to the multiprocessing
  resource tracker. Such a reentrant call, though unlikely, can happen if a
  GC pass invokes the finalizer for a multiprocessing object such as
  SemLock.

- gh-109653: Reduce the import time of :mod:`typing` by around a third.
  Patch by Alex Waygood.

- gh-109649: Add :func:`os.process_cpu_count` function to get the number of
  logical CPUs usable by the calling thread of the current process. Patch by
  Victor Stinner.

- gh-74481: Add ``set_error_mode`` related constants in ``msvcrt`` module in
  Python debug build.

- gh-109613: Fix :func:`os.stat` and :meth:`os.DirEntry.stat`: check for
  exceptions. Previously, on Python built in debug mode, these functions
  could trigger a fatal Python error (and abort the process) when a function
  succeeded with an exception set. Patch by Victor Stinner.

- gh-109599: Expose the type of PyCapsule objects as ``types.CapsuleType``.

- gh-109109: You can now get the raw TLS certificate chains from TLS
  connections via :meth:`ssl.SSLSocket.get_verified_chain` and
  :meth:`ssl.SSLSocket.get_unverified_chain` methods.

  Contributed by Mateusz Nowak.

- gh-109559: Update :mod:`unicodedata` database to Unicode 15.1.0.

- gh-109543: Remove unnecessary :func:`hasattr` check during
  :data:`typing.TypedDict` creation.

- gh-109495: Remove unnecessary extra ``__slots__`` in
  :class:`~datetime.datetime`\'s pure python implementation to reduce memory
  size, as they are defined in the superclass. Patch by James Hilton-Balfe

- gh-109461: :mod:`logging`: Use a context manager for lock acquisition.

- gh-109096: :class:`http.server.CGIHTTPRequestHandler` has been deprecated
  for removal in 3.15.  Its design is old and the web world has long since
  moved beyond CGI.

- gh-109409: Fix error when it was possible to inherit a frozen dataclass
  from multiple parents some of which were possibly not frozen.

- gh-109375: The :mod:`pdb` ``alias`` command now prevents registering
  aliases without arguments.

- gh-109319: Deprecate the ``dis.HAVE_ARGUMENT`` field in favour of
  ``dis.hasarg``.

- gh-107219: Fix a race condition in ``concurrent.futures``. When a process
  in the process pool was terminated abruptly (while the future was running
  or pending), close the connection write end. If the call queue is blocked
  on sending bytes to a worker process, closing the connection write end
  interrupts the send, so the queue can be closed. Patch by Victor Stinner.

- gh-66143: The :class:`codecs.CodecInfo` object has been made copyable and
  pickleable. Patched by Robert Lehmann and Furkan Onder.

- gh-109187: :meth:`pathlib.Path.resolve` now treats symlink loops like
  other errors: in strict mode, :exc:`OSError` is raised, and in non-strict
  mode, no exception is raised.

- gh-50644: Attempts to pickle or create a shallow or deep copy of
  :mod:`codecs` streams now raise a TypeError. Previously, copying failed
  with a RecursionError, while pickling produced wrong results that
  eventually caused unpickling to fail with a RecursionError.

- gh-109174: Add support of :class:`types.SimpleNamespace` in
  :func:`copy.replace`.

- gh-109164: :mod:`pdb`: Replace :mod:`getopt` with :mod:`argparse` for
  parsing command line arguments.

- gh-109151: Enable ``readline`` editing features in the :ref:`sqlite3
  command-line interface <sqlite3-cli>` (``python -m sqlite3``).

- gh-108987: Fix :func:`_thread.start_new_thread` race condition. If a
  thread is created during Python finalization, the newly spawned thread now
  exits immediately instead of trying to access freed memory and lead to a
  crash. Patch by Victor Stinner.

- gh-108682: Enum: require ``names=()`` or ``type=...`` to create an empty
  enum using the functional syntax.

- gh-109033: Exceptions raised by os.utime builtin function now include the
  related filename

- gh-108843: Fix an issue in :func:`ast.unparse` when unparsing f-strings
  containing many quote types.

- gh-108469: :func:`ast.unparse` now supports new :term:`f-string` syntax
  introduced in Python 3.12. Note that the :term:`f-string` quotes are
  reselected for simplicity under the new syntax. (Patch by Steven Sun)

- gh-108751: Add :func:`copy.replace` function which allows to create a
  modified copy of an object. It supports named tuples, dataclasses, and
  many other objects.

- gh-108682: Enum: raise :exc:`TypeError` if ``super().__new__()`` is called
  from a custom ``__new__``.

- gh-108278: Deprecate passing the callback callable by keyword for the
  following :class:`sqlite3.Connection` APIs:

  * :meth:`~sqlite3.Connection.set_authorizer`
  * :meth:`~sqlite3.Connection.set_progress_handler`
  * :meth:`~sqlite3.Connection.set_trace_callback`

  The affected parameters will become positional-only in Python 3.15.

  Patch by Erlend E. Aasland.

- gh-105829: Fix concurrent.futures.ProcessPoolExecutor deadlock

- gh-108295: Fix crashes related to use of weakrefs on
  :data:`typing.TypeVar`.

- gh-108463: Make expressions/statements work as expected in pdb

- gh-108277: Add :func:`os.timerfd_create`, :func:`os.timerfd_settime`,
  :func:`os.timerfd_gettime`, :func:`os.timerfd_settime_ns`, and
  :func:`os.timerfd_gettime_ns` to provide a low level interface for Linux's
  timer notification file descriptor.

- gh-107811: :mod:`tarfile`: extraction of members with overly large UID or
  GID (e.g. on an OS with 32-bit :c:type:`!id_t`) now fails in the same way
  as failing to set the ID.

- gh-64662: Fix support for virtual tables in
  :meth:`sqlite3.Connection.iterdump`. Patch by Aviv Palivoda.

- gh-108111: Fix a regression introduced in GH-101251 for 3.12, resulting in
  an incorrect offset calculation in :meth:`gzip.GzipFile.seek`.

- gh-108294: :func:`time.sleep` now raises an auditing event.

- gh-108278: Deprecate passing name, number of arguments, and the callable
  as keyword arguments, for the following :class:`sqlite3.Connection` APIs:

  * :meth:`~sqlite3.Connection.create_function`
  * :meth:`~sqlite3.Connection.create_aggregate`

  The affected parameters will become positional-only in Python 3.15.

  Patch by Erlend E. Aasland.

- gh-108322: Speed-up NormalDist.samples() by using the inverse CDF method
  instead of calling random.gauss().

- gh-83417: Add the ability for venv to create a ``.gitignore`` file which
  causes the created environment to be ignored by Git. It is on by default
  when venv is called via its CLI.

- gh-105736: Harmonized the pure Python version of
  :class:`~collections.OrderedDict` with the C version. Now, both versions
  set up their internal state in ``__new__``.  Formerly, the pure Python
  version did the set up in ``__init__``.

- gh-108083: Fix bugs in the constructor of :mod:`sqlite3.Connection` and
  :meth:`sqlite3.Connection.close` where exceptions could be leaked. Patch
  by Erlend E. Aasland.

- gh-107932: Fix ``dis`` module to properly report and display bytecode that
  do not have source lines.

- gh-105539: :mod:`sqlite3` now emits an :exc:`ResourceWarning` if a
  :class:`sqlite3.Connection` object is not :meth:`closed
  <sqlite3.connection.close>` explicitly. Patch by Erlend E. Aasland.

- gh-107995: The ``__module__`` attribute on instances of
  :class:`functools.cached_property` is now set to the name of the module in
  which the cached_property is defined, rather than "functools". This means
  that doctests in ``cached_property`` docstrings are now properly collected
  by the :mod:`doctest` module. Patch by Tyler Smart.

- gh-107963: Fix :func:`multiprocessing.set_forkserver_preload` to check the
  given list of modules names. Patch by Donghee Na.

- gh-106242: Fixes :func:`os.path.normpath` to handle embedded null
  characters without truncating the path.

- gh-81555: :mod:`xml.dom.minidom` now only quotes ``"`` in attributes.

- gh-50002: :mod:`xml.dom.minidom` now preserves whitespaces in attributes.

- gh-93057: Passing more than one positional argument to
  :func:`sqlite3.connect` and the :class:`sqlite3.Connection` constructor is
  deprecated. The remaining parameters will become keyword-only in Python
  3.15. Patch by Erlend E. Aasland.

- gh-76913: Add *merge_extra* parameter/feature to
  :class:`logging.LoggerAdapter`

- gh-107913: Fix possible losses of ``errno`` and ``winerror`` values in
  :exc:`OSError` exceptions if they were cleared or modified by the cleanup
  code before creating the exception object.

- gh-107845: :func:`tarfile.data_filter` now takes the location of symlinks
  into account when determining their target, so it will no longer reject
  some valid tarballs with ``LinkOutsideDestinationError``.

- gh-107812: Extend socket's netlink support to the FreeBSD platform.

- gh-107805: Fix signatures of module-level generated functions in
  :mod:`turtle`.

- gh-107782: :mod:`pydoc` is now able to show signatures which are not
  representable in Python, e.g. for ``getattr`` and ``dict.pop``.

- gh-56166: Deprecate passing optional arguments *maxsplit*, *count* and
  *flags* in module-level functions :func:`re.split`, :func:`re.sub` and
  :func:`re.subn` as positional. They should only be passed by keyword.

- gh-107710: Speed up :func:`logging.getHandlerNames`.

- gh-107715: Fix :meth:`doctest.DocTestFinder.find` in presence of class
  names with special characters. Patch by Gertjan van Zwieten.

- gh-100814: Passing a callable object as an option value to a Tkinter image
  now raises the expected TclError instead of an AttributeError.

- gh-72684: Add :mod:`tkinter` widget methods: :meth:`!tk_busy_hold`,
  :meth:`!tk_busy_configure`, :meth:`!tk_busy_cget`,
  :meth:`!tk_busy_forget`, :meth:`!tk_busy_current`, and
  :meth:`!tk_busy_status`.

- gh-106684: Raise :exc:`ResourceWarning` when :class:`asyncio.StreamWriter`
  is not closed leading to memory leaks. Patch by Kumar Aditya.

- gh-107465: Add :meth:`pathlib.Path.from_uri` classmethod.

- gh-107077: Seems that in some conditions, OpenSSL will return
  ``SSL_ERROR_SYSCALL`` instead of ``SSL_ERROR_SSL`` when a certification
  verification has failed, but the error parameters will still contain
  ``ERR_LIB_SSL`` and ``SSL_R_CERTIFICATE_VERIFY_FAILED``. We are now
  detecting this situation and raising the appropriate
  ``ssl.SSLCertVerificationError``. Patch by Pablo Galindo

- gh-107576: Fix :func:`types.get_original_bases` to only return
  :attr:`!__orig_bases__` if it is present on ``cls`` directly. Patch by
  James Hilton-Balfe.

- gh-105481: Remove ``opcode.is_pseudo``, ``opcode.MIN_PSEUDO_OPCODE`` and
  ``opcode.MAX_PSEUDO_OPCODE``, which were added in 3.12, were never
  documented and were not intended to be used externally.

- gh-105481: :data:`!opcode.ENABLE_SPECIALIZATION` (which was added in 3.12
  but never documented or intended for external usage) is moved to
  :data:`!_opcode.ENABLE_SPECIALIZATION` where tests can access it.

- gh-107396: tarfiles; Fixed use before assignment of self.exception for
  gzip decompression

- gh-107409: Set :attr:`!__wrapped__` attribute in
  :func:`reprlib.recursive_repr`.

- gh-107406: Implement new :meth:`__repr__` method for
  :class:`struct.Struct`. Now it returns ``Struct(<format repr>)``.

- gh-107369: Optimize :func:`textwrap.indent`. It is ~30% faster for large
  input. Patch by Inada Naoki.

- gh-78722: Fix issue where :meth:`pathlib.Path.iterdir` did not raise
  :exc:`OSError` until iterated.

- gh-105578: Deprecate :class:`typing.AnyStr` in favor of the new Type
  Parameter syntax. See PEP 695.

- gh-62519: Make :func:`gettext.pgettext` search plural definitions when
  translation is not found.

- gh-107089: Shelves opened with :func:`shelve.open` have a much faster
  :meth:`clear` method. Patch by James Cave.

- gh-82500: Fix overflow on 32-bit systems with :mod:`asyncio`
  :func:`os.sendfile` implementation.

- gh-83006: Document behavior of :func:`shutil.disk_usage` for non-mounted
  filesystems on Unix.

- gh-65495: Use lowercase ``mail from`` and ``rcpt to`` in
  :class:`smptlib.SMTP`.

- gh-106186: Do not report ``MultipartInvariantViolationDefect`` defect when
  the :class:`email.parser.Parser` class is used to parse emails with
  ``headersonly=True``.

- gh-105002: Fix invalid result from :meth:`PurePath.relative_to` method
  when attempting to walk a "``..``" segment in *other* with *walk_up*
  enabled. A :exc:`ValueError` exception is now raised in this case.

- gh-106739: Add the ``rtype_cache`` to the warning message (as an addition
  to the type of leaked objects and the number of leaked objects already
  included in the message) to make debugging leaked objects easier when the
  multiprocessing resource tracker process finds leaked objects at shutdown.
  This helps more quickly identify what was leaked and/or why the leaked
  object was not properly cleaned up.

- gh-106751: Optimize :meth:`SelectSelector.select` for many iteration case.
  Patch By Donghee Na.

- gh-106751: Optimize :meth:`!_PollLikeSelector.select` for many iteration
  case.

- gh-106751: Optimize :meth:`KqueueSelector.select` for many iteration case.
  Patch By Donghee Na.

- gh-106831: Fix potential missing ``NULL`` check of ``d2i_SSL_SESSION``
  result in ``_ssl.c``.

- gh-105481: The various opcode lists in the :mod:`dis` module are now
  generated from bytecodes.c instead of explicitly constructed in opcode.py.

- gh-106727: Make :func:`inspect.getsource` smarter for class for same name
  definitions

- gh-106789: Remove import of :mod:`pprint` from :mod:`sysconfig`.

- gh-105726: Added ``__slots__`` to
  :class:`contextlib.AbstractContextManager` and
  :class:`contextlib.AbstractAsyncContextManager` so that child classes can
  use ``__slots__``.

- gh-106774: Update the bundled copy of pip to version 23.2.1.

- gh-106751: :mod:`selectors`: Optimize ``EpollSelector.select()`` code by
  moving some code outside of the loop.

- gh-106752: Fixed several bugs in zipfile.Path, including: in
  :meth:`zipfile.Path.match`, Windows separators are no longer honored (and
  never were meant to be); Fixed ``name``/``suffix``/``suffixes``/``stem``
  operations when no filename is present and the Path is not at the root of
  the zipfile; Reworked glob for performance and more correct matching
  behavior.

- gh-105293: Remove call to ``SSL_CTX_set_session_id_context`` during client
  side context creation in the :mod:`ssl` module.

- gh-106734: Disable tab completion in multiline mode of :mod:`pdb`

- gh-105481: Expose opcode metadata through :mod:`!_opcode`.

- gh-106670: Add the new ``exceptions`` command to the Pdb debugger. It
  makes it possible to move between chained exceptions when using post
  mortem debugging.

- gh-106602: Add __copy__ and __deepcopy__ in :mod:`enum`

- gh-106664: :mod:`selectors`: Add ``_SelectorMapping.get()`` method and
  optimize ``_SelectorMapping.__getitem__()``.

- gh-106628: Speed up parsing of emails by about 20% by not compiling a new
  regular expression for every single email.

- gh-89427: Set the environment variable ``VIRTUAL_ENV_PROMPT`` at
  :mod:`venv` activation, even when ``VIRTUAL_ENV_DISABLE_PROMPT`` is set.

- gh-106530: Revert a change to :func:`colorsys.rgb_to_hls` that caused
  division by zero for certain almost-white inputs.  Patch by Terry Jan
  Reedy.

- gh-106584: Fix exit code for ``unittest`` if all tests are skipped. Patch
  by Egor Eliseev.

- gh-106566: Optimize ``(?!)`` (pattern which always fails) in regular
  expressions.

- gh-106554: :mod:`selectors`: Reduce Selector overhead by using a
  ``dict.get()`` to lookup file descriptors.

- gh-106558: Remove ref cycle in callers of
  :func:`~multiprocessing.managers.convert_to_error` by deleting ``result``
  from scope in a ``finally`` block.

- gh-100502: Add :attr:`pathlib.PurePath.pathmod` class attribute that
  stores the implementation of :mod:`os.path` used for low-level path
  operations: either ``posixpath`` or ``ntpath``.

- gh-106527: Reduce overhead to add and remove :mod:`asyncio` readers and
  writers.

- gh-106524: Fix crash in :func:`!_sre.template` with templates containing
  invalid group indices.

- gh-106531: Removed ``_legacy`` and the names it provided from
  ``importlib.resources``: ``Resource``, ``contents``, ``is_resource``,
  ``open_binary``, ``open_text``, ``path``, ``read_binary``, and
  ``read_text``.

- gh-106052: :mod:`re` module: fix the matching of possessive quantifiers in
  the case of a subpattern containing backtracking.

- gh-106510: Improve debug output for atomic groups in regular expressions.

- gh-106503: Fix ref cycle in :class:`!asyncio._SelectorSocketTransport` by
  removing ``_write_ready`` in ``close``.

- gh-105497: Fix flag mask inversion when unnamed flags exist.

- gh-90876: Prevent :mod:`multiprocessing.spawn` from failing to *import* in
  environments where ``sys.executable`` is ``None``.  This regressed in 3.11
  with the addition of support for path-like objects in multiprocessing.

- gh-106403: Instances of :class:`typing.TypeVar`,
  :class:`typing.ParamSpec`, :class:`typing.ParamSpecArgs`,
  :class:`typing.ParamSpecKwargs`, and :class:`typing.TypeVarTuple` once
  again support weak references, fixing a regression introduced in Python
  3.12.0 beta 1. Patch by Jelle Zijlstra.

- gh-89812: Add private ``pathlib._PathBase`` class, which provides
  experimental support for virtual filesystems, and may be made public in a
  future version of Python.

- gh-106292: Check for an instance-dict cached value in the :meth:`__get__`
  method of :func:`functools.cached_property`. This better matches the
  pre-3.12 behavior and improves compatibility for users subclassing
  :func:`functools.cached_property` and adding a :meth:`__set__` method.

- gh-106350: Detect possible memory allocation failure in the libtommath
  function :c:func:`mp_init` used by the ``_tkinter`` module.

- gh-106330: Fix incorrect matching of empty paths in
  :meth:`pathlib.PurePath.match`. This bug was introduced in Python 3.12.0
  beta 1.

- gh-106309: Deprecate :func:`typing.no_type_check_decorator`. No major type
  checker ever added support for this decorator. Patch by Alex Waygood.

- gh-102541: Make :func:`pydoc.doc` catch bad module :exc:`ImportError` when
  output stream is not ``None``.

- gh-106263: Fix crash when calling ``repr`` with a manually constructed
  SignalDict object. Patch by Charlie Zhao.

- gh-106236: Replace ``assert`` statements with ``raise RuntimeError`` in
  :mod:`threading`, so that ``_DummyThread`` cannot be joined even with
  ``-OO``.

- gh-106238: Fix rare concurrency bug in lock acquisition by the logging
  package.

- gh-106152: Added PY_THROW event hook for :mod:`cProfile` for generators

- gh-106075: Added ``asyncio.taskgroups.__all__`` to ``asyncio.__all__`` for
  export in star imports.

- gh-104527: Zipapp will now skip over appending an archive to itself.

- gh-106046: Improve the error message from :func:`os.fspath` if called on
  an object where ``__fspath__`` is set to ``None``. Patch by Alex Waygood.

- gh-105987: Fix crash due to improper reference counting in :mod:`asyncio`
  eager task factory internal routines.

- gh-105974: Fix bug where a :class:`typing.Protocol` class that had one or
  more non-callable members would raise :exc:`TypeError` when
  :func:`issubclass` was called against it, even if it defined a custom
  ``__subclasshook__`` method. The behaviour in Python 3.11 and lower --
  which has now been restored -- was not to raise :exc:`TypeError` in these
  situations if a custom ``__subclasshook__`` method was defined. Patch by
  Alex Waygood.

- gh-96145: Reverted addition of ``json.AttrDict``.

- gh-89812: Add :exc:`pathlib.UnsupportedOperation`, which is raised instead
  of :exc:`NotImplementedError` when a path operation isn't supported.

- gh-105808: Fix a regression introduced in GH-101251 for 3.12, causing
  :meth:`gzip.GzipFile.flush` to not flush the compressor (nor pass along
  the ``zip_mode`` argument).

- gh-105481: :func:`~dis.stack_effect` no longer raises an exception if an
  ``oparg`` is provided for an ``opcode`` that doesn't use its arg, or when
  it is not provided for an ``opcode`` that does use it. In the latter case,
  the stack effect is returned for ``oparg=0``.

- gh-104799: Enable :func:`ast.unparse` to unparse function and class
  definitions created without the new ``type_params`` field from :pep:`695`.
  Patch by Jelle Zijlstra.

- gh-105793: Add *follow_symlinks* keyword-only argument to
  :meth:`pathlib.Path.is_dir` and :meth:`~pathlib.Path.is_file`, defaulting
  to ``True``.

- gh-105570: Deprecate two methods of creating :class:`typing.TypedDict`
  classes with 0 fields using the functional syntax: ``TD =
  TypedDict("TD")`` and ``TD = TypedDict("TD", None)``. Both will be
  disallowed in Python 3.15. To create a ``TypedDict`` class with 0 fields,
  either use ``class TD(TypedDict): pass`` or ``TD = TypedDict("TD", {})``.

- gh-105745: Fix ``webbrowser.Konqueror.open`` method.

- gh-105733: :mod:`ctypes`: Deprecate undocumented
  :func:`!ctypes.SetPointerType` and :func:`!ctypes.ARRAY` functions. Patch
  by Victor Stinner.

- gh-105687: Remove deprecated ``re.template``, ``re.T``, ``re.TEMPLATE``,
  ``sre_constans.SRE_FLAG_TEMPLATE``.

- gh-105684: Supporting :meth:`asyncio.Task.set_name` is now mandatory for
  third party task implementations. The undocumented :func:`!_set_task_name`
  function (deprecated since 3.8) has been removed. Patch by Kumar Aditya.

- gh-105375: Fix a bug in :c:func:`!_Unpickler_SetInputStream` where an
  exception could end up being overwritten in case of failure.

- gh-105626: Change the default return value of
  :meth:`http.client.HTTPConnection.get_proxy_response_headers` to be
  ``None`` and not ``{}``.

- gh-105375: Fix bugs in :mod:`sys` where exceptions could end up being
  overwritten because of deferred error handling.

- gh-105605: Harden :mod:`pyexpat` error handling during module
  initialisation to prevent exceptions from possibly being overwritten, and
  objects from being dereferenced twice.

- gh-105375: Fix bug in :mod:`decimal` where an exception could end up being
  overwritten.

- gh-105375: Fix bugs in :mod:`!_datetime` where exceptions could be
  overwritten in case of module initialisation failure.

- gh-105375: Fix bugs in :mod:`!_ssl` initialisation which could lead to
  leaked references and overwritten exceptions.

- gh-105375: Fix a bug in :class:`array.array` where an exception could end
  up being overwritten.

- gh-105375: Fix bugs in :mod:`!_ctypes` where exceptions could end up being
  overwritten.

- gh-105375: Fix a bug in the :mod:`posix` module where an exception could
  be overwritten.

- gh-105375: Fix bugs in :mod:`!_elementtree` where exceptions could be
  overwritten.

- gh-105375: Fix bugs in :mod:`zoneinfo` where exceptions could be
  overwritten.

- gh-105375: Fix bugs in :mod:`errno` where exceptions could be overwritten.

- gh-105566: Deprecate creating a :class:`typing.NamedTuple` class using
  keyword arguments to denote the fields (``NT = NamedTuple("NT", x=int,
  y=str)``). This will be disallowed in Python 3.15. Use the class-based
  syntax or the functional syntax instead.

  Two methods of creating ``NamedTuple`` classes with 0 fields using the
  functional syntax are also deprecated, and will be disallowed in Python
  3.15: ``NT = NamedTuple("NT")`` and ``NT = NamedTuple("NT", None)``. To
  create a ``NamedTuple`` class with 0 fields, either use ``class
  NT(NamedTuple): pass`` or ``NT = NamedTuple("NT", [])``.

- gh-105545: Remove deprecated in 3.11 ``webbrowser.MacOSXOSAScript._name``
  attribute.

- gh-105497: Fix flag inversion when alias/mask members exist.

- gh-105509: :data:`typing.Annotated` is now implemented as an instance of
  ``typing._SpecialForm`` rather than a class. This should have no
  user-facing impact for users of the :mod:`typing` module public API.

- gh-105375: Fix bugs in :mod:`pickle` where exceptions could be
  overwritten.

- gh-70303: Emit :exc:`FutureWarning` from :meth:`pathlib.Path.glob` and
  :meth:`~pathlib.Path.rglob` if the given pattern ends with "``**``". In a
  future Python release, patterns with this ending will match both files and
  directories. Add a trailing slash to only match directories.

- gh-105375: Fix a bug in :mod:`sqlite3` where an exception could be
  overwritten in the :meth:`collation <sqlite3.Connection.create_collation>`
  callback.

- gh-105382: Remove *cafile*, *capath* and *cadefault* parameters of the
  :func:`urllib.request.urlopen` function, deprecated in Python 3.6. Patch
  by Victor Stinner.

- gh-105376: :mod:`logging`: Remove undocumented and untested
  ``Logger.warn()`` and ``LoggerAdapter.warn()`` methods and
  ``logging.warn()`` function. Deprecated since Python 3.3, they were
  aliases to the :meth:`logging.Logger.warning` method,
  :meth:`!logging.LoggerAdapter.warning` method and :func:`logging.warning`
  function. Patch by Victor Stinner.

- gh-105332: Revert pickling method from by-name back to by-value.

- gh-104554: Add RTSPS scheme support in urllib.parse

- gh-105292: Add option to :func:`traceback.format_exception_only` to
  recurse into the nested exception of a :exc:`BaseExceptionGroup`.

- gh-105280: Fix bug where ``isinstance([], collections.abc.Mapping)`` could
  evaluate to ``True`` if garbage collection happened at the wrong time. The
  bug was caused by changes to the implementation of
  :class:`typing.Protocol` in Python 3.12.

- gh-80480: :mod:`array`: Add ``'w'`` typecode that represents ``Py_UCS4``.

- gh-105239: Fix longstanding bug where ``issubclass(object,
  typing.Protocol)`` would evaluate to ``True`` in some edge cases. Patch by
  Alex Waygood.

- gh-104310: In the beta 1 release we added a utility function for extension
  module authors, to use when testing their module for support in multiple
  interpreters or under a per-interpreter GIL.  The name of that function
  has changed from ``allowing_all_extensions`` to
  ``_incompatible_extension_module_restrictions``.  The default for the
  "disable_check" argument has change from ``True`` to ``False``, to better
  match the new function name.

- gh-105080: Fixed inconsistent signature on derived classes for
  :func:`inspect.signature`

- gh-105144: Fix a recent regression in the :mod:`typing` module. The
  regression meant that doing ``class Foo(X, typing.Protocol)``, where ``X``
  was a class that had :class:`abc.ABCMeta` as its metaclass, would then
  cause subsequent ``isinstance(1, X)`` calls to erroneously raise
  :exc:`TypeError`. Patch by Alex Waygood.

- gh-62948: The :class:`io.IOBase` finalizer now logs the ``close()`` method
  errors with :data:`sys.unraisablehook`. Previously, errors were ignored
  silently by default, and only logged in :ref:`Python Development Mode
  <devmode>` or on :ref:`Python built on debug mode <debug-build>`.  Patch
  by Victor Stinner.

- gh-105096: :mod:`wave`: Deprecate the ``getmark()``, ``setmark()`` and
  ``getmarkers()`` methods of the :class:`wave.Wave_read` and
  :class:`wave.Wave_write` classes. They will be removed in Python 3.15.
  Patch by Victor Stinner.

- gh-104992: Remove the untested and undocumented
  :meth:`!unittest.TestProgram.usageExit` method, deprecated in Python 3.11.
  Patch by Hugo van Kemenade.

- gh-104996: Improve performance of :class:`pathlib.PurePath` initialisation
  by deferring joining of paths when multiple arguments are given.

- gh-101588: Deprecate undocumented copy/deepcopy/pickle support for
  itertools.

- gh-103631: Fix ``pathlib.PurePosixPath(pathlib.PureWindowsPath(...))`` not
  converting path separators to restore 3.11 compatible behavior.

- gh-104947: Make comparisons between :class:`pathlib.PureWindowsPath`
  objects consistent across Windows and Posix to match 3.11 behavior.

- gh-104773: :pep:`594`: Remove the :mod:`!audioop` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!aifc` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!uu` module, deprecated in Python
  3.11. Patch by Victor Stinner.

- gh-104935: Fix bugs with the interaction between
  :func:`typing.runtime_checkable` and :class:`typing.Generic` that were
  introduced by the :pep:`695` implementation. Patch by Jelle Zijlstra.

- gh-104773: :pep:`594`: Remove the :mod:`!crypt` module and its private
  :mod:`!_crypt` extension, deprecated in Python 3.11. Patch by Victor
  Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!nis` module, deprecated in Python
  3.11. Patch by Victor Stinner.

- gh-104898: Add missing :attr:`~object.__slots__` to :class:`os.PathLike`.

- gh-104773: :pep:`594`: Remove the :mod:`!xdrlib` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!nntplib` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104886: Remove the undocumented
  :class:`!configparser.LegacyInterpolation` class, deprecated in the
  docstring since Python 3.2, and with a deprecation warning since Python
  3.11. Patch by Hugo van Kemenade.

- gh-104786: Remove kwargs-based :class:`typing.TypedDict` creation

- gh-104876: Remove the :meth:`!turtle.RawTurtle.settiltangle` method,
  deprecated in docs since Python 3.1 and with a deprecation warning since
  Python 3.11. Patch by Hugo van Kemenade.

- gh-104773: :pep:`594`: Removed the :mod:`!msilib` package, deprecated in
  Python 3.11.

- gh-104773: :pep:`594`: Remove the :mod:`!spwd` module, deprecated in
  Python 3.11: the :pypi:`python-pam` project can be used instead. Patch by
  Victor Stinner.

- gh-75552: Removed the ``tkinter.tix`` module, deprecated since Python 3.6.

- gh-104773: :pep:`594`: Remove the :mod:`!chunk` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!mailcap` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!sunau` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104780: :pep:`594`: Remove the :mod:`!ossaudiodev` module, deprecated
  in Python 3.11. Patch Victor Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!pipes` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104873: Add :func:`typing.get_protocol_members` to return the set of
  members defining a :class:`typing.Protocol`.  Add
  :func:`typing.is_protocol` to check whether a class is a
  :class:`typing.Protocol`. Patch by Jelle Zijlstra.

- gh-104874: Document the ``__name__`` and ``__supertype__`` attributes of
  :class:`typing.NewType`. Patch by Jelle Zijlstra.

- gh-104835: Removed the following :mod:`unittest` functions, deprecated in
  Python 3.11:

  * :func:`!unittest.findTestCases`
  * :func:`!unittest.makeSuite`
  * :func:`!unittest.getTestCaseNames`

  Use :class:`~unittest.TestLoader` methods instead:

  * :meth:`unittest.TestLoader.loadTestsFromModule`
  * :meth:`unittest.TestLoader.loadTestsFromTestCase`
  * :meth:`unittest.TestLoader.getTestCaseNames`

  Patch by Hugo van Kemenade.

- gh-104804: Remove the untested and undocumented :mod:`webbrowser`
  :class:`!MacOSX` class, deprecated in Python 3.11. Patch by Hugo van
  Kemenade.

- gh-83863: Support for using :class:`pathlib.Path` objects as context
  managers has been removed. Before Python 3.9, exiting the context manager
  marked a path as "closed", which caused some (but not all!) methods to
  raise when called. Since Python 3.9, using a path as a context manager
  does nothing.

- gh-104799: Adjust the location of the (see :pep:`695`) ``type_params``
  field on :class:`ast.ClassDef`, :class:`ast.AsyncFunctionDef`, and
  :class:`ast.FunctionDef` to better preserve backward compatibility. Patch
  by Jelle Zijlstra

- gh-104797: Allow :class:`typing.Protocol` classes to inherit from
  :class:`collections.abc.Buffer`. Patch by Jelle Zijlstra.

- gh-104783: Remove ``locale.resetlocale()`` function deprecated in Python
  3.11. Patch by Victor Stinner.

- gh-104780: Remove the ``2to3`` program and the :mod:`!lib2to3` module,
  deprecated in Python 3.11. Patch by Victor Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!telnetlib` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!imghdr` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!cgi` and :mod:`!cgitb` modules,
  deprecated in Python 3.11. Patch by Victor Stinner.

- gh-104773: :pep:`594`: Remove the :mod:`!sndhdr` module, deprecated in
  Python 3.11. Patch by Victor Stinner.

- gh-104372: On Linux where :mod:`subprocess` can use the ``vfork()``
  syscall for faster spawning, prevent the parent process from blocking
  other threads by dropping the GIL while it waits for the vfork'ed child
  process ``exec()`` outcome. This prevents spawning a binary from a slow
  filesystem from blocking the rest of the application.

- gh-99108: We now release the GIL around built-in :mod:`hashlib`
  computations of reasonable size for the SHA families and MD5 hash
  functions, matching what our OpenSSL backed hash computations already
  does.

- gh-102613: Improve performance of :meth:`pathlib.Path.glob` when expanding
  a pattern with a non-terminal "``**``" component by filtering walked paths
  through a regular expression, rather than calling :func:`os.scandir` more
  than once on each directory.

- gh-104399: Prepare the ``_tkinter`` module for building with Tcl 9.0 and
  future libtommath by replacing usage of deprecated functions
  :c:func:`mp_to_unsigned_bin_n` and :c:func:`mp_unsigned_bin_size` when
  necessary.

- gh-102676: Add fields ``start_offset``, ``cache_offset``, ``end_offset``,
  ``baseopname``, ``baseopcode``, ``jump_target`` and ``oparg`` to
  :class:`dis.Instruction`.

- gh-103558: Fixed ``parent`` argument validation mechanism of
  :mod:`argparse`. Improved test coverage.

- gh-103464: Provide helpful usage messages when parsing incorrect
  :mod:`pdb` commands.

- gh-103384: Generalize the regex pattern ``BaseConfigurator.INDEX_PATTERN``
  to allow spaces and non-alphanumeric characters in keys.

- gh-103124: Added multiline statement support for :mod:`pdb`

- gh-101162: Forbid using :func:`builtins.issubclass` with
  :class:`types.GenericAlias` as the first argument.

- gh-103200: Fix cache repopulation semantics of
  zipimport.invalidate_caches(). The cache is now repopulated upon
  retrieving files with an invalid cache, not when the cache is invalidated.

- gh-100061: Fix a bug that causes wrong matches for regular expressions
  with possessive qualifier.

- gh-77609: Add *follow_symlinks* argument to :meth:`pathlib.Path.glob` and
  :meth:`~pathlib.Path.rglob`, defaulting to false.

- gh-102541: Hide traceback in :func:`help` prompt, when import failed.

- gh-102120: Added a stream mode to ``tarfile`` that allows for reading
  archives without caching info about the inner files.

- gh-102029: Deprecate passing any arguments to :func:`threading.RLock`.

- gh-88233: Refactored ``zipfile._strip_extra`` to use higher level
  abstractions for extras instead of a heavy-state loop.

- gh-102024: Reduce calls of ``_idle_semaphore.release()`` in
  :func:`concurrent.futures.thread._worker`.

- gh-73435: Add support for recursive wildcards in
  :meth:`pathlib.PurePath.match`.

- gh-84867: :class:`unittest.TestLoader` no longer loads test cases from
  exact :class:`unittest.TestCase` and :class:`unittest.FunctionTestCase`
  classes.

- gh-99203: Restore following CPython <= 3.10.5 behavior of
  :func:`shutil.make_archive`: do not create an empty archive if
  ``root_dir`` is not a directory, and, in that case, raise
  :class:`FileNotFoundError` or :class:`NotADirectoryError` regardless of
  ``format`` choice. Beyond the brought-back behavior, the function may now
  also raise these exceptions in ``dry_run`` mode.

- gh-80480: Emit :exc:`DeprecationWarning` for :mod:`array`'s ``'u'`` type
  code, deprecated in docs since Python 3.3.

- gh-94924: :func:`unittest.mock.create_autospec` now properly returns
  coroutine functions compatible with :func:`inspect.iscoroutinefunction`

- gh-94777: Fix hanging :mod:`multiprocessing` ``ProcessPoolExecutor`` when
  a child process crashes while data is being written in the call queue.

- gh-92871: Remove the ``typing.io`` and ``typing.re`` namespaces,
  deprecated since Python 3.8. All items are still available from the main
  :mod:`typing` module.

- bpo-43633: Improve the textual representation of IPv4-mapped IPv6
  addresses (:rfc:`4291` Sections 2.2, 2.5.5.2) in :mod:`ipaddress`. Patch
  by Oleksandr Pavliuk.

- bpo-44850: Improve performance of :func:`operator.methodcaller` using the
  :pep:`590` ``vectorcall`` convention. Patch by Anthony Lee and Pieter
  Eendebak.

- bpo-44185: :func:`unittest.mock.mock_open` will call the :func:`close`
  method of the file handle mock when it is exiting from the context
